// log-2 exponentiator.

// is_hom w/ fcn ptr
// is_isom w/ fcn ptr
// find_isoms(G, H) much like autck:
//	check |G| == |H|
//	check both are/aren't abelian
//	if both cyclic, isom; then, find the isoms (one g gen => all h gens??)
//	make G's & H's SOS; make sure ==
//	from there, try all possible order-preserving pmts.

// subfield check?

// veq, vless => vcmp?

// max deg = 2 * max m in zppoly.h; check m <= max m in zppoly.c.

// for large q, m and/or n, test #-zero-det formula stochastically.

// to/from cyc-decomp for pmt_t.

// matrix inverter for vmatrix.c?

// rename mains: underscores, inverse => inverses, etc.

// xxx note (in the code) parameterized groups: reason for separate
// group-spec and group structures.

// Make sure to memcpy temps in all vadds, vmuls.  Cmt in code to avoid
//   in-at-out clashes.  Then rm temps from outer code.

// quotient groups (quotient rings), with array of sizes &array re-sort.
// Make sure e.g. (G/I) / (H/I) is handleable.

// xxx sizeof check (MAX_...) in vscan

// hom_t (pfunc); is_hom check; is epim; is monom; is isom.

// pmt_t, an_t, dih_t -> pmt_t, epmt_t, dih_t

// scan stub for lgf.

// cube gp not as < S_n, but as triply generated by pitch, roll and yaw.
// - What is the rule?
// ! find & fix typo in ASCII art in cube.c.

// more verbosities, e.g. on subset check.

// miscibility check whenever two groups/subgroups are involved.

// xxx how to make a subgroup:
// k explicit list (passed by caller inside the code)
// k HK
// * H cap K
// k center
// k centralizer
// * normalizer of a subgroup
// k stabilizer
// k j-power subgroup, k-torsion subgroup.
// * what else??
// k elements from file / stdin.
// * check to see if a subgroup is characteristic?  Requires autck.

// standalones for mul, inv, single order; factor/irred when supported.
// mul by single element

// decompose arb fin ab gp => zmx

// sn acting on arb G

// pelem => pvelem etc.

// lib/libkalg.a, & inc/kalg.h?

// Zero-divisor check?
// Ring structure.
// Ideal check.
// is_prime_ideal
// Quotient rings.

#ifndef VGROUP_H
#define VGROUP_H

#include "vops.h"

#define VGROUP_ELEMENT(pg,i) \
	VARRAY_ELEMENT((pg)->pvelements, (i), (pg)->pspec->element_size)

// ith coset, jth element in coset
#define VCOSETS_ELEMENT(pq,i,j) \
	VARRAY_ELEMENT((pq)->pvelements, \
		(i) * (pq)->elements_per_coset + (j), \
		(pq)->pspec->element_size)

// ----------------------------------------------------------------
// Returns 0 if the group would be too big.  Caller must handle this.
typedef int  fill_group_t(
	void * pvelements,
	void * pvaux,
	int    max_group_bytes,
	int  * pnum_elements);

// ----------------------------------------------------------------
typedef struct _group_spec_t {
	int                element_size;
	int                naux;

	vop_t            * pvop;

	vequal_t         * pvequal;
	vless_t          * pvless;

	vprint_t         * pvprint;
	vauxprint_t      * pvauxprint;

	vscan_t          * pvscan;
	vauxscan_t       * pvauxscan;

	fill_group_t     * pfill_group;
	char             * desc;
} group_spec_t;

typedef struct _group_t {
	void            * pvelements;
	int               num_elements;
	void            * pvaux;
	group_spec_t    * pspec;
} group_t;

// As of this writing, this is an ad-hoc structure for a single purpose
// (namely, computing ascending central series).  Only a single quotient
// depth is supported.  In the future, if I ever do it (there is GAP, after
// all ...) this structure would disappear and group_t should be augmented
// to handle quotient groups.

typedef struct _group_cosets_t {
	void            * pvelements;
	int               num_cosets;
	int               elements_per_coset;
	void            * pvaux;
	group_spec_t    * pspec;
} group_cosets_t;

// ----------------------------------------------------------------
int find_group_spec(
	char * desc,
	group_spec_t ** ppspec);

void list_group_specs(
	void);

int make_group(
	group_t * pgroup,           // input
	group_spec_t * pgroup_spec, // input
	void    * pvaux,            // input
	char    * elements_file,    // input -- null for default elts.
	void    * elements_buffer,  // output
	int       max_group_bytes); // output

void describe_group(
	group_t * pgroup);

void print_group_elements(
	group_t * pgroup);

void group_print_cosets(
	group_cosets_t * pcosets);

// ----------------------------------------------------------------
// Adds the element unless already present.  This entails a linear search
// through the group elements on every function call.
int group_maybe_add_element(
	group_t * pgroup,
	void    * psrc,
	int       max_group_bytes);

// Appends the new element unconditionally.
int group_append_element(
	group_t * pgroup,
	void    * psrc,
	int       max_group_bytes);

// ----------------------------------------------------------------
void group_element_power(
	group_t      * pgroup,
	void         * pvin,
	int            power,
	void         * pvout);

void group_element_inverse(
	group_t * pgroup,
	void    * pvin,
	void    * pvout);

int group_element_order(
	group_t * pgroup,
	void    * pvin);

// ----------------------------------------------------------------
// xxx to other file.
void sort_varray(
	void * pvelements,
	int    num_elements,
	int    element_size,
	vless_t * pvless,
	void * pvaux);

#endif // VGROUP_H
