#include <stdio.h>
#include <stdlib.h>
#include "group.h"

// ----------------------------------------------------------------
void group_show_cayley_table(
	group_t * pgroup)
{
	void * pa;
	void * pb;
	unsigned char c[VOP_MAX_ELEMENT_SIZE];
	int i, j;

	if (pgroup->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: group element size %d too big.\n",
				__FILE__, pgroup->pspec->element_size);
		exit(1);
	}

	for (i = 0; i < pgroup->num_elements; i++) {
		pa = VGROUP_ELEMENT(pgroup, i);
		for (j = 0; j < pgroup->num_elements; j++) {
			pb = VGROUP_ELEMENT(pgroup, j);
			if (j > 0)
				printf(" ");
			pgroup->pspec->pvop(&c, pa, pb, pgroup->pvaux);
			pgroup->pspec->pvprint(&c, pgroup->pvaux);
		}
		printf("\n");
	}
}
