#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "group.h"
#include "pmt.h"
#include "group_check.h"
#include "group_center.h"

void make_center(
	group_t * pgroup,
	group_t * pcenter,
	void    * center_elements_buffer,
	int       max_center_bytes)
{
	int i, j;
	void * px;
	void * pg;
	void * pc;
	unsigned char xg[VOP_MAX_ELEMENT_SIZE];
	unsigned char gx[VOP_MAX_ELEMENT_SIZE];
	int ok;

	// xxx to lib func.
	if (pgroup->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: group element size %d too big.\n",
				__FILE__, pgroup->pspec->element_size);
		exit(1);
	}


	pcenter->pvelements = center_elements_buffer;
	pcenter->num_elements = 0; // Increment below
	pcenter->pvaux = pgroup->pvaux;
	pcenter->pspec = pgroup->pspec;

	// for each x [i] in G
	//	for each g [j] in G
	//		if xg == gx
	//			add x to the center

	for (i = 0; i < pgroup->num_elements; i++) {
		px = VGROUP_ELEMENT(pgroup, i);
		ok = 1;
		for (j = 0; j < pgroup->num_elements; j++) {
			pg = VGROUP_ELEMENT(pgroup, j);
			pgroup->pspec->pvop(xg, px, pg, pgroup->pvaux);
			pgroup->pspec->pvop(gx, pg, px, pgroup->pvaux);

			if (!pgroup->pspec->pvequal(xg, gx, pgroup->pvaux)) {
				ok = 0;
				break;
			}
		}
		if (ok) {
			pc = VGROUP_ELEMENT(pcenter, pcenter->num_elements);
			memcpy(pc, px, pgroup->pspec->element_size);
			pcenter->num_elements++;
		}
	}
}
