#ifndef GROUP_CHECK_H
#define GROUP_CHECK_H
#include "group.h"

// ----------------------------------------------------------------
int is_group(
	group_t * pgroup,
	int verbosity);

int is_closed(
	group_t * pgroup,
	int verbosity);

int is_associative(
	group_t * pgroup,
	int verbosity);

int has_unique_identity(
	group_t * pgroup,
	int verbosity);

int has_unique_inverses(
	group_t * pgroup,
	int verbosity);

// ----------------------------------------------------------------
int is_abelian(
	group_t * pgroup,
	int verbosity);

// ----------------------------------------------------------------
int find_identity(
	group_t * pgroup,
	void    * pe);

int group_find_index(
	group_t * pgroup,
	void    * sought,
	int     * pindex);

int is_subgroup(
	group_t * pH,
	group_t * pG,
	int       verbosity);

int is_subset(
	group_t * pH,
	group_t * pG,
	int       verbosity);

int is_normal_subgroup(
	group_t * pH,
	group_t * pG,
	int       verbosity);

// ----------------------------------------------------------------
int close_group(
	group_t * pgroup,
	int       max_group_bytes,
	int       verbosity);

#endif // GROUP_CHECK_H
