#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "group.h"
#include "group_check.h"
#include "group_cyclic.h"

void conjugate_by_element(
	group_t * pgroup,
	void    * pg)
{
	// Make a copy in case pg points into pgroup's space,
	// so the thing we're conjugating by won't change partway
	// through.
	unsigned char g   [VOP_MAX_ELEMENT_SIZE];
	unsigned char ginv[VOP_MAX_ELEMENT_SIZE];
	unsigned char gx  [VOP_MAX_ELEMENT_SIZE];
	int i;
	void    * px;

	// xxx to lib func.
	if (pgroup->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: group element size %d too big.\n",
				__FILE__, pgroup->pspec->element_size);
		exit(1);
	}

	memcpy(g, pg, pgroup->pspec->element_size);
	group_element_inverse(pgroup, g, ginv);

	// For each x in G, replace x by g x g^{-1}.
	for (i = 0; i < pgroup->num_elements; i++) {
		px = VGROUP_ELEMENT(pgroup, i);

		pgroup->pspec->pvop(gx, g,  px,   pgroup->pvaux);
		pgroup->pspec->pvop(px, gx, ginv, pgroup->pvaux);
	}
}
