#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "group.h"
#include "group_check.h"
#include "group_cyclic.h"

void make_cyclic_subgroup(
	group_t * pgroup,
	void    * pgenerator,
	group_t * pcyclic_subgroup,
	void    * sgr_elements_buffer,
	int       max_group_bytes)
{
	int i;
	int si;
	unsigned char e[VOP_MAX_ELEMENT_SIZE];
	unsigned char gi[VOP_MAX_ELEMENT_SIZE];
	unsigned char temp[VOP_MAX_ELEMENT_SIZE];
	void * pdest;

	pcyclic_subgroup->pvelements = sgr_elements_buffer;
	pcyclic_subgroup->num_elements = 0; // increment below

	pcyclic_subgroup->pvaux = pgroup->pvaux;
	pcyclic_subgroup->pspec = pgroup->pspec;


	// xxx to lib func.
	if (pgroup->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: group element size %d too big.\n",
				__FILE__, pgroup->pspec->element_size);
		exit(1);
	}

	if (!find_identity(pgroup, e)) {
		fprintf(stderr, "make_cyclic_subgroup: no identity found!\n");
		exit(1);
	}

	memcpy(gi, e, pgroup->pspec->element_size);

	for (i = 0, si = 0; i < pgroup->num_elements; i++) {
		if ((i > 0)
		&& (pgroup->pspec->pvequal(gi, e, pgroup->pvaux)))
		{
			break;
		}
		pdest = VGROUP_ELEMENT(pcyclic_subgroup, si);
		memcpy(pdest, gi, pgroup->pspec->element_size);
		si++;

		memcpy(temp, gi, pgroup->pspec->element_size);
		pgroup->pspec->pvop(gi, temp, pgenerator, pgroup->pvaux);
	}
	pcyclic_subgroup->num_elements = si;
}
