#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "group.h"
#include "group_check.h"
#include "group_orders.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
// xxx would prefer a partition-group-into-conj-classes function,
// with a separate printer function.

void list_conj_cls(
	group_t * pgroup,
	int       verbosity)
{
	int    i, j, k;
	void * pconjs;
	char * marks;
	int    nconj, cjgidx;
	int    group_num_bytes;
	void * px, * pg, * pc;
	unsigned char xinv  [VOP_MAX_ELEMENT_SIZE];
	unsigned char xg    [VOP_MAX_ELEMENT_SIZE];
	unsigned char xgxinv[VOP_MAX_ELEMENT_SIZE];
	int    found;

	// xxx to lib func.
	if (pgroup->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: group element size %d too big.\n",
				__FILE__, pgroup->pspec->element_size);
		exit(1);
	}

	group_num_bytes = pgroup->num_elements * pgroup->pspec->element_size;
	pconjs = malloc_check(group_num_bytes);
	marks  = malloc_check(pgroup->num_elements);
	for (i = 0; i < pgroup->num_elements; i++) {
		marks[i] = 0;
	}

	for (i = 0; i < pgroup->num_elements; i++) {
		if (marks[i])
			continue;
		pg = VGROUP_ELEMENT(pgroup, i);

		if (verbosity >= 2) {
			printf("[");
			pgroup->pspec->pvprint(pg, pgroup->pvaux);
			printf("] = ");
		}

		nconj = 0;
		for (j = 0; j < pgroup->num_elements; j++) {
			px = VGROUP_ELEMENT(pgroup, j);
			group_element_inverse(pgroup, px, xinv);
			pgroup->pspec->pvop(xg, px, pg, pgroup->pvaux);
			pgroup->pspec->pvop(xgxinv, xg, xinv, pgroup->pvaux);

			// xxx really need an add-to-set lib function.
			found = 0;
			for (k = 0; k < nconj; k++) {
				pc = VARRAY_ELEMENT(pconjs, k,
					pgroup->pspec->element_size);
				if (pgroup->pspec->pvequal(pc, xgxinv,
					pgroup->pvaux))
				{
					found = 1;
					break;
				}
			}
			if (!found) {
				pc = VARRAY_ELEMENT(pconjs, nconj,
					pgroup->pspec->element_size);
				memcpy(pc, xgxinv,
					pgroup->pspec->element_size);

				if (!group_find_index(pgroup, xgxinv,&cjgidx)) {
					fprintf(stderr,
					"list_conj_cls:  group not closed.\n");
					exit(1);
				}
				marks[cjgidx] = 1;
				nconj++;
			}
		}

		for (j = 0; j < nconj; j++) {
			pc = VARRAY_ELEMENT(pconjs, j,
				pgroup->pspec->element_size);
			if (j > 0)
				printf(" ");
			pgroup->pspec->pvprint(pc, pgroup->pvaux);
		}

		if (verbosity >= 1) {
			printf(" (%d)", group_element_order(pgroup, pg));
		}

		printf("\n");
	}

	free(marks);
	free(pconjs);
}
