#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "group.h"
#include "group_check.h"
#include "group_orbits.h"

// ----------------------------------------------------------------
void group_show_orbits(
	group_t * pgroup)
{
	unsigned char e[VOP_MAX_ELEMENT_SIZE];
	void * pa;
	unsigned char apower[VOP_MAX_ELEMENT_SIZE];
	int i;
	int n = pgroup->num_elements;
	int order;

	// xxx to lib func.
	if (pgroup->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: group element size %d too big.\n",
				__FILE__, pgroup->pspec->element_size);
		exit(1);
	}

	// First, locate the identity.
	if (!find_identity(pgroup, e)) {
		fprintf(stderr,
			"group_show_orbits:  Couldn't find identity "
			"element in group.\n");
		exit(1);
	}

// xxx use group_element_orbit() instead.
	for (i = 0; i < pgroup->num_elements; i++) {
		pa = VGROUP_ELEMENT(pgroup, i);
		memcpy(apower, pa, pgroup->pspec->element_size);

		pgroup->pspec->pvprint(pa, pgroup->pvaux);

		for (order = 0; order <= n; order++) {
			if (order > pgroup->num_elements) {
				printf("group_show_orbits: "
					"non-invertible element ");
				pgroup->pspec->pvprint(pa, pgroup->pvaux);
				printf(".\n");
				exit(1);
			}
			if (pgroup->pspec->pvequal(apower, e, pgroup->pvaux))
				break;
			pgroup->pspec->pvop(apower, apower, pa, pgroup->pvaux);
			printf(" ");
			pgroup->pspec->pvprint(apower, pgroup->pvaux);
		}
		printf("\n");
	}
}
