#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "group.h"
#include "group_check.h"
#include "group_power.h"

// ----------------------------------------------------------------
void show_power(
	group_t * pgroup,
	int       power)
{
	void * pa;
	unsigned char apower[VOP_MAX_ELEMENT_SIZE];
	int i;

	// xxx to lib func.
	if (pgroup->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: group element size %d too big.\n",
				__FILE__, pgroup->pspec->element_size);
		exit(1);
	}

	for (i = 0; i < pgroup->num_elements; i++) {
		pa = VGROUP_ELEMENT(pgroup, i);
		memcpy(apower, pa, pgroup->pspec->element_size);

		group_element_power(pgroup, pa, power, apower);

		pgroup->pspec->pvprint(pa, pgroup->pvaux);
		printf("  ");
		pgroup->pspec->pvprint(apower, pgroup->pvaux);
		printf("\n");
	}
}

// ----------------------------------------------------------------
void make_power_subgroup(
	group_t * pgroup,
	int       k,
	group_t * ppower_subgroup,
	void    * sgr_elements_buffer,
	int       max_group_bytes)
{
	int i;
	void * pg;
	void * pdest;
	unsigned char gk[VOP_MAX_ELEMENT_SIZE];
	int index;

	ppower_subgroup->pvelements = sgr_elements_buffer;
	ppower_subgroup->num_elements = 0; // increment below

	ppower_subgroup->pvaux = pgroup->pvaux;
	ppower_subgroup->pspec = pgroup->pspec;


	// xxx to lib func.
	if (pgroup->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: group element size %d too big.\n",
				__FILE__, pgroup->pspec->element_size);
		exit(1);
	}


	for (i = 0; i < pgroup->num_elements; i++) {
		pg = VGROUP_ELEMENT(pgroup, i);

		group_element_power(pgroup, pg, k, gk);

		if (!group_find_index(ppower_subgroup, gk, &index)) {
			pdest = VGROUP_ELEMENT(ppower_subgroup,
				ppower_subgroup->num_elements);
			memcpy(pdest, gk, ppower_subgroup->pspec->element_size);
			ppower_subgroup->num_elements++;
		}
	}
}
