#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "group.h"
#include "group_power.h"

// ----------------------------------------------------------------
void show_powers(
	group_t * pgroup,
	int       max_power)
{
	void * pa;
	unsigned char apower[VOP_MAX_ELEMENT_SIZE];
	int i, j;

	// xxx to lib func.
	if (pgroup->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: group element size %d too big.\n",
				__FILE__, pgroup->pspec->element_size);
		exit(1);
	}

	for (i = 0; i < pgroup->num_elements; i++) {
		pa = VGROUP_ELEMENT(pgroup, i);
		memcpy(apower, pa, pgroup->pspec->element_size);
		pgroup->pspec->pvprint(pa, pgroup->pvaux);
		for (j = 1; j < max_power; j++) {
			pgroup->pspec->pvop(apower, pa, apower, pgroup->pvaux);
			printf(" ");
			pgroup->pspec->pvprint(apower, pgroup->pvaux);
		}
		printf("\n");
	}
}
