#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "group.h"
#include "pmt.h"
#include "group_check.h"
#include "group_stabilizer.h"

void make_stabilizer(
	group_t * pgroup,
	void    * px,
	group_t * pstabilizer,
	void    * stabilizer_elements_buffer,
	int       max_stabilizer_bytes)
{
	int    j;
	void * pg;
	void * pc;
	unsigned char gx[VOP_MAX_ELEMENT_SIZE];

	// xxx to lib func.
	if (pgroup->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: group element size %d too big.\n",
				__FILE__, pgroup->pspec->element_size);
		exit(1);
	}


	pstabilizer->pvelements = stabilizer_elements_buffer;
	pstabilizer->num_elements = 0; // Increment below
	pstabilizer->pvaux = pgroup->pvaux;
	pstabilizer->pspec = pgroup->pspec;

	//for each g [j] in G
	//	if gx == x
	//		add x to the stabilizer

	for (j = 0; j < pgroup->num_elements; j++) {
		pg = VGROUP_ELEMENT(pgroup, j);
		pgroup->pspec->pvop(gx, px, pg, pgroup->pvaux);

		if (pgroup->pspec->pvequal(gx, px, pgroup->pvaux)) {
			pc = VGROUP_ELEMENT(pstabilizer,
				pstabilizer->num_elements);
			memcpy(pc, pg, pgroup->pspec->element_size);
			pstabilizer->num_elements++;
		}
	}
}
