#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "group.h"
#include "group_check.h"
#include "group_torsion.h"

void make_torsion_subgroup(
	group_t * pgroup,
	int       k,
	group_t * ptorsion_subgroup,
	void    * sgr_elements_buffer,
	int       max_group_bytes)
{
	int gi;
	int si;
	unsigned char e[VOP_MAX_ELEMENT_SIZE];
	unsigned char gk[VOP_MAX_ELEMENT_SIZE];
	void * pg;
	void * ps;

	ptorsion_subgroup->pvelements = sgr_elements_buffer;
	ptorsion_subgroup->num_elements = 0; // increment below

	ptorsion_subgroup->pvaux = pgroup->pvaux;
	ptorsion_subgroup->pspec = pgroup->pspec;


	// xxx to lib func.
	if (pgroup->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: group element size %d too big.\n",
				__FILE__, pgroup->pspec->element_size);
		exit(1);
	}

	if (!find_identity(pgroup, e)) {
		fprintf(stderr, "make_torsion_subgroup: no identity found!\n");
		exit(1);
	}

	for (gi = 0, si = 0; gi < pgroup->num_elements; gi++) {
		pg = VGROUP_ELEMENT(pgroup, gi);

		group_element_power(pgroup, pg, k, gk);

		if (pgroup->pspec->pvequal(gk, e, pgroup->pvaux)) {
			ps = VGROUP_ELEMENT(ptorsion_subgroup, si);
			memcpy(ps, pg, pgroup->pspec->element_size);
			si++;
		}
	}
	ptorsion_subgroup->num_elements = si;
}
