#include <stdio.h>
#include <stdlib.h>
#include "ring.h"

// ----------------------------------------------------------------
void ring_show_cayley_table(
	ring_t * pring)
{
	void * pa;
	void * pb;
	unsigned char c[VOP_MAX_ELEMENT_SIZE];
	int i, j;

	if (pring->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: ring element size %d too big.\n",
				__FILE__, pring->pspec->element_size);
		exit(1);
	}

	for (i = 0; i < pring->num_elements; i++) {
		pa = VRING_ELEMENT(pring, i);
		for (j = 0; j < pring->num_elements; j++) {
			pb = VRING_ELEMENT(pring, j);
			if (j > 0)
				printf(" ");
			pring->pspec->pvop(&c, pa, pb, pring->pvaux);
			pring->pspec->pvprint(&c, pring->pvaux);
		}
		printf("\n");
	}
}
