#ifndef RING_CHECK_H
#define RING_CHECK_H
#include "ring.h"

// ----------------------------------------------------------------
int is_ring(
	ring_t * pring,
	int verbosity);

int is_closed(
	ring_t * pring,
	int verbosity);

int is_associative(
	ring_t * pring,
	int verbosity);

int has_unique_identity(
	ring_t * pring,
	int verbosity);

int has_unique_inverses(
	ring_t * pring,
	int verbosity);

// ----------------------------------------------------------------
int is_abelian(
	ring_t * pring,
	int verbosity);

// ----------------------------------------------------------------
int find_identity(
	ring_t * pring,
	void    * pe);

int ring_find_index(
	ring_t * pring,
	void    * sought,
	int     * pindex);

int is_subring(
	ring_t * pH,
	ring_t * pG,
	int       verbosity);

int is_subset(
	ring_t * pH,
	ring_t * pG,
	int       verbosity);

int is_normal_subring(
	ring_t * pH,
	ring_t * pG,
	int       verbosity);

// ----------------------------------------------------------------
int close_ring(
	ring_t * pring,
	int       max_ring_bytes,
	int       verbosity);

#endif // RING_CHECK_H
