#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ring.h"
#include "ring_check.h"
#include "ring_cyclic.h"

void conjugate_by_element(
	ring_t * pring,
	void    * pg)
{
	// Make a copy in case pg points into pring's space,
	// so the thing we're conjugating by won't change partway
	// through.
	unsigned char g   [VOP_MAX_ELEMENT_SIZE];
	unsigned char ginv[VOP_MAX_ELEMENT_SIZE];
	unsigned char gx  [VOP_MAX_ELEMENT_SIZE];
	int i;
	void    * px;

	// xxx to lib func.
	if (pring->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: ring element size %d too big.\n",
				__FILE__, pring->pspec->element_size);
		exit(1);
	}

	memcpy(g, pg, pring->pspec->element_size);
	ring_element_inverse(pring, g, ginv);

	// For each x in G, replace x by g x g^{-1}.
	for (i = 0; i < pring->num_elements; i++) {
		px = VRING_ELEMENT(pring, i);

		pring->pspec->pvop(gx, g,  px,   pring->pvaux);
		pring->pspec->pvop(px, gx, ginv, pring->pvaux);
	}
}
