#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ring.h"
#include "ring_check.h"
#include "ring_cyclic.h"

void make_cyclic_subring(
	ring_t * pring,
	void    * pgenerator,
	ring_t * pcyclic_subring,
	void    * sgr_elements_buffer,
	int       max_ring_bytes)
{
	int i;
	int si;
	unsigned char e[VOP_MAX_ELEMENT_SIZE];
	unsigned char gi[VOP_MAX_ELEMENT_SIZE];
	unsigned char temp[VOP_MAX_ELEMENT_SIZE];
	void * pdest;

	pcyclic_subring->pvelements = sgr_elements_buffer;
	pcyclic_subring->num_elements = 0; // increment below

	pcyclic_subring->pvaux = pring->pvaux;
	pcyclic_subring->pspec = pring->pspec;


	// xxx to lib func.
	if (pring->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: ring element size %d too big.\n",
				__FILE__, pring->pspec->element_size);
		exit(1);
	}

	if (!find_identity(pring, e)) {
		fprintf(stderr, "make_cyclic_subring: no identity found!\n");
		exit(1);
	}

	memcpy(gi, e, pring->pspec->element_size);

	for (i = 0, si = 0; i < pring->num_elements; i++) {
		if ((i > 0)
		&& (pring->pspec->pvequal(gi, e, pring->pvaux)))
		{
			break;
		}
		pdest = VRING_ELEMENT(pcyclic_subring, si);
		memcpy(pdest, gi, pring->pspec->element_size);
		si++;

		memcpy(temp, gi, pring->pspec->element_size);
		pring->pspec->pvop(gi, temp, pgenerator, pring->pvaux);
	}
	pcyclic_subring->num_elements = si;
}
