#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ring.h"
#include "ring_check.h"
#include "ring_orbits.h"

// ----------------------------------------------------------------
void ring_show_orbits(
	ring_t * pring)
{
	unsigned char e[VOP_MAX_ELEMENT_SIZE];
	void * pa;
	unsigned char apower[VOP_MAX_ELEMENT_SIZE];
	int i;
	int n = pring->num_elements;
	int order;

	// xxx to lib func.
	if (pring->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: ring element size %d too big.\n",
				__FILE__, pring->pspec->element_size);
		exit(1);
	}

	// First, locate the identity.
	if (!find_identity(pring, e)) {
		fprintf(stderr,
			"ring_show_orbits:  Couldn't find identity "
			"element in ring.\n");
		exit(1);
	}

// xxx use ring_element_orbit() instead.
	for (i = 0; i < pring->num_elements; i++) {
		pa = VRING_ELEMENT(pring, i);
		memcpy(apower, pa, pring->pspec->element_size);

		pring->pspec->pvprint(pa, pring->pvaux);

		for (order = 0; order <= n; order++) {
			if (order > pring->num_elements) {
				printf("ring_show_orbits: "
					"non-invertible element ");
				pring->pspec->pvprint(pa, pring->pvaux);
				printf(".\n");
				exit(1);
			}
			if (pring->pspec->pvequal(apower, e, pring->pvaux))
				break;
			pring->pspec->pvop(apower, apower, pa, pring->pvaux);
			printf(" ");
			pring->pspec->pvprint(apower, pring->pvaux);
		}
		printf("\n");
	}
}
