#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ring.h"
#include "ring_check.h"
#include "ring_power.h"

// ----------------------------------------------------------------
void show_power(
	ring_t * pring,
	int       power)
{
	void * pa;
	unsigned char apower[VOP_MAX_ELEMENT_SIZE];
	int i;

	// xxx to lib func.
	if (pring->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: ring element size %d too big.\n",
				__FILE__, pring->pspec->element_size);
		exit(1);
	}

	for (i = 0; i < pring->num_elements; i++) {
		pa = VRING_ELEMENT(pring, i);
		memcpy(apower, pa, pring->pspec->element_size);

		ring_element_power(pring, pa, power, apower);

		pring->pspec->pvprint(pa, pring->pvaux);
		printf("  ");
		pring->pspec->pvprint(apower, pring->pvaux);
		printf("\n");
	}
}

// ----------------------------------------------------------------
void make_power_subring(
	ring_t * pring,
	int       k,
	ring_t * ppower_subring,
	void    * sgr_elements_buffer,
	int       max_ring_bytes)
{
	int i;
	void * pg;
	void * pdest;
	unsigned char gk[VOP_MAX_ELEMENT_SIZE];
	int index;

	ppower_subring->pvelements = sgr_elements_buffer;
	ppower_subring->num_elements = 0; // increment below

	ppower_subring->pvaux = pring->pvaux;
	ppower_subring->pspec = pring->pspec;


	// xxx to lib func.
	if (pring->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: ring element size %d too big.\n",
				__FILE__, pring->pspec->element_size);
		exit(1);
	}


	for (i = 0; i < pring->num_elements; i++) {
		pg = VRING_ELEMENT(pring, i);

		ring_element_power(pring, pg, k, gk);

		if (!ring_find_index(ppower_subring, gk, &index)) {
			pdest = VRING_ELEMENT(ppower_subring,
				ppower_subring->num_elements);
			memcpy(pdest, gk, ppower_subring->pspec->element_size);
			ppower_subring->num_elements++;
		}
	}
}
