#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ring.h"
#include "ring_power.h"

// ----------------------------------------------------------------
void show_powers(
	ring_t * pring,
	int       max_power)
{
	void * pa;
	unsigned char apower[VOP_MAX_ELEMENT_SIZE];
	int i, j;

	// xxx to lib func.
	if (pring->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: ring element size %d too big.\n",
				__FILE__, pring->pspec->element_size);
		exit(1);
	}

	for (i = 0; i < pring->num_elements; i++) {
		pa = VRING_ELEMENT(pring, i);
		memcpy(apower, pa, pring->pspec->element_size);
		pring->pspec->pvprint(pa, pring->pvaux);
		for (j = 1; j < max_power; j++) {
			pring->pspec->pvop(apower, pa, apower, pring->pvaux);
			printf(" ");
			pring->pspec->pvprint(apower, pring->pvaux);
		}
		printf("\n");
	}
}
