#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ring.h"
#include "pmt.h"
#include "ring_check.h"
#include "ring_stabilizer.h"

void make_stabilizer(
	ring_t * pring,
	void    * px,
	ring_t * pstabilizer,
	void    * stabilizer_elements_buffer,
	int       max_stabilizer_bytes)
{
	int    j;
	void * pg;
	void * pc;
	unsigned char gx[VOP_MAX_ELEMENT_SIZE];

	// xxx to lib func.
	if (pring->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: ring element size %d too big.\n",
				__FILE__, pring->pspec->element_size);
		exit(1);
	}


	pstabilizer->pvelements = stabilizer_elements_buffer;
	pstabilizer->num_elements = 0; // Increment below
	pstabilizer->pvaux = pring->pvaux;
	pstabilizer->pspec = pring->pspec;

	//for each g [j] in G
	//	if gx == x
	//		add x to the stabilizer

	for (j = 0; j < pring->num_elements; j++) {
		pg = VRING_ELEMENT(pring, j);
		pring->pspec->pvop(gx, px, pg, pring->pvaux);

		if (pring->pspec->pvequal(gx, px, pring->pvaux)) {
			pc = VRING_ELEMENT(pstabilizer,
				pstabilizer->num_elements);
			memcpy(pc, pg, pring->pspec->element_size);
			pstabilizer->num_elements++;
		}
	}
}
