#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ring.h"
#include "ring_check.h"
#include "ring_torsion.h"

void make_torsion_subring(
	ring_t * pring,
	int       k,
	ring_t * ptorsion_subring,
	void    * sgr_elements_buffer,
	int       max_ring_bytes)
{
	int gi;
	int si;
	unsigned char e[VOP_MAX_ELEMENT_SIZE];
	unsigned char gk[VOP_MAX_ELEMENT_SIZE];
	void * pg;
	void * ps;

	ptorsion_subring->pvelements = sgr_elements_buffer;
	ptorsion_subring->num_elements = 0; // increment below

	ptorsion_subring->pvaux = pring->pvaux;
	ptorsion_subring->pspec = pring->pspec;


	// xxx to lib func.
	if (pring->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: ring element size %d too big.\n",
				__FILE__, pring->pspec->element_size);
		exit(1);
	}

	if (!find_identity(pring, e)) {
		fprintf(stderr, "make_torsion_subring: no identity found!\n");
		exit(1);
	}

	for (gi = 0, si = 0; gi < pring->num_elements; gi++) {
		pg = VRING_ELEMENT(pring, gi);

		ring_element_power(pring, pg, k, gk);

		if (pring->pspec->pvequal(gk, e, pring->pvaux)) {
			ps = VRING_ELEMENT(ptorsion_subring, si);
			memcpy(ps, pg, pring->pspec->element_size);
			si++;
		}
	}
	ptorsion_subring->num_elements = si;
}
