#ifndef VMATRIX_H
#define VMATRIX_H

#include "vops.h"

void vmatrix_print(
	void     * pvmat,
	void     * pvaux,
	vfops_t  * pvfops,
	int        nrows,
	int        ncols,
	int        lda);

// Results are undefined if pout points to the same space as pvin1 or pvin2.
void vmatrix_add(
	void     * pvin1,
	void     * pvin2,
	void     * pvout,
	void     * pvaux,
	vfops_t  * pvfops,
	int        nrows,
	int        ncols,
	int        ldain1,
	int        ldain2,
	int        ldaout);

// Results are undefined if pout points to the same space as pvin1 or pvin2.
void vmatrix_mul(
	void     * pvin1,
	void     * pvin2,
	void     * pvout,
	void     * pvaux,
	vfops_t  * pvfops,
	int        nrows1,
	int        ncols1,
	int        nrows2,
	int        ncols2,
	int        ldain1,
	int        ldain2,
	int        ldaout);

void vmatrix_det(
	void     * pvmat, // In
	void     * pvdet, // Out
	void     * pvaux,
	vfops_t  * pvfops,
	int        dim,
	int        lda);

void vmatrix_row_reduce_above(
	void     * pvmat,
	void     * pvaux,
	vfops_t  * pvfops,
	int        nrows,
	int        ncols,
	int        lda,
	int      * pnswaps);

// xxx print-matrix function.

#endif // VMATRIX_H
