#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "vops.h"

// ----------------------------------------------------------------
void sort_varray(
	void * pvelements,
	int    num_elements,
	int    element_size,
	vless_t * pvless,
	void * pvaux)
{
	void * pa, * pb;
	unsigned char temp[VOP_MAX_ELEMENT_SIZE];
	int i, top;

	// xxx to lib func.
	if (element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: group element size %d too big.\n",
				__FILE__, element_size);
		exit(1);
	}

	for (top = num_elements - 1; top > 0; top--) {
		for (i = 0; i < top; i++) {
			pa = VARRAY_ELEMENT(pvelements, i,   element_size);
			pb = VARRAY_ELEMENT(pvelements, i+1, element_size);
			if (pvless(pb, pa, pvaux)) {
				memcpy(temp, pa,   element_size);
				memcpy(pa,   pb,   element_size);
				memcpy(pb,   temp, element_size);
			}
		}
	}
}
