// Gaussian integers

#ifndef GINT_H
#define GINT_H

// ----------------------------------------------------------------
typedef struct _gint_t {
	int re;
	int im;
} gint_t;

// ----------------------------------------------------------------
gint_t gint_add (gint_t a, gint_t b);
gint_t gint_sub (gint_t a, gint_t b);
gint_t gint_mul (gint_t a, gint_t b);
gint_t gint_quot(gint_t a, gint_t b);
gint_t gint_rem (gint_t a, gint_t b);
void   gint_quot_and_rem(gint_t a, gint_t b, gint_t * pquot, gint_t * prem);
int    gint_equal(gint_t a, gint_t b);

int    gint_norm(gint_t a);
int    gint_is_zero(gint_t a);
int    gint_is_unit(gint_t a);

int    gint_scan(
	gint_t * pout,
	char   * pin);

void   gint_print(
	gint_t   g);

#endif // GINT_H
