// SL_n(GF(q)) (det == 1) and GL_n(GF(q)) (det != 0).

#ifndef LGF_H
#define LGF_H

#include "group.h"

#define LGF_MAX_DIM 4

typedef struct _lgf_t {
	int mat[LGF_MAX_DIM][LGF_MAX_DIM];
} lgf_t;

typedef struct _lgf_aux_t {
	int n;
	int q;
} lgf_aux_t;

void lgf_mul     (lgf_t * pa, lgf_t * pb, lgf_t * pc, int n, int q);
void lgf_print   (lgf_t * pa, int n, int q);
int  lgf_calc_det(lgf_t * pa, int n, int q);
void kth_nqmat   (lgf_t * pa, int k, int n, int q);

extern group_spec_t slgf_group_spec;
extern group_spec_t glgf_group_spec;
extern group_spec_t dgf_group_spec;

#endif // LGF_H
