#ifndef MOD_H
#define MOD_H

#include "group.h"
#include "ring.h"

int mod_add(int a, int b, int m);
int mod_sub(int a, int b, int m);
int mod_mul(int a, int b, int m);
int mod_div(int a, int b, int m);
int mod_rem(int a, int b, int m);
int mod_recip(int a, int m);
int mod_power(int a, int e, int m);
int mod_mul_order(int x, int m);
int mod_equal(int a, int b, int m);

long long mod64_div  (long long a, long long b, long long m);
long long mod64_recip(long long a, long long m);
long long mod64_power(long long a, long long e, long long m);
long long mod64_mul_order(long long x, long long m);

extern group_spec_t mod_add_group_spec;
extern group_spec_t mod_mul_group_spec;

extern group_spec_t smod_add_group_spec;
extern group_spec_t smod_mul_group_spec;

extern ring_spec_t  mod_ring_spec;
extern ring_spec_t  smod_ring_spec;

extern vfops_t      mod_vfops;

#endif // MOD_H
