#ifndef PADIC_H
#define PADIC_H

#include <stdio.h>
#include "rat.h"

// ----------------------------------------------------------------
#define PADIC_NUM_FRACT  4//16
#define PADIC_NUM_TOTAL  8//32

// ----------------------------------------------------------------
// E.g. num total = 12, num fract = 4, p=2:

// +------+-----+-----+-----+   +---+---+---+---+----+----+----+-----+
// | 1/16 | 1/8 | 1/4 | 1/2 | . | 1 | 2 | 4 | 8 | 16 | 32 | 64 | 128 |
// +------+-----+-----+-----+   +---+---+---+---+----+----+----+-----+

typedef struct _padic_t {
	unsigned digits[PADIC_NUM_TOTAL];
} padic_t;

// ----------------------------------------------------------------
padic_t padic_zero(void);
void  padic_print(padic_t * pc, int p);

padic_t padic_add(padic_t * pa, padic_t * pb, int p);
padic_t padic_uneg(padic_t * pa, int p);
padic_t padic_sub(padic_t * pa, padic_t * pb, int p);
padic_t padic_mul(padic_t * pa, padic_t * pb, int p);
padic_t padic_div(padic_t * pa, padic_t * pb, int p);

padic_t padic_from_int(int   n, int p);
padic_t padic_from_rat(rat_t n, int p);

#endif // PADIC_H
