#include <stdio.h>
#include <string.h>
#define PMT_MAX_N 256

// ----------------------------------------------------------------
void print_pmt(
	unsigned char a[PMT_MAX_N],
	int n)
{
	int i;
	for (i = 0; i < n; i++)
		//printf("%d", (int)a[i]);
		printf("%c", 'a' + a[i]);
}

// ----------------------------------------------------------------
// hebcdgfa
void print_cd(
	unsigned char a[PMT_MAX_N],
	int n)
{
	int i;
	unsigned char marks[PMT_MAX_N];
	unsigned char next;

	// abcd
	// dacb
	// 0000

	// i=0
	// next=d

	// (db

	for (i = 0; i < n; i++)
		marks[i] = 0;
	for (i = 0; i < n; i++) {
		if (marks[i])
			continue;

		printf("(");

		next = i;
		marks[next] = 1;
		printf("%c", next + 'a');

		while (1) {
			next = a[next];
			if (next == i)
				break;
			marks[next] = 1;
			printf("%c", next + 'a');
		}


		printf(")");
	}
}

//		printf("(");
//		next = a[i];
//		marks[next] = 1;
//		printf("%c", next + 'a');
//		while (1) {
//			if (next == i)
//				break;
//			printf("%c", next + 'a');
//			next = a[next];
//			marks[next] = 1;
//		}
//		printf(")");


// ----------------------------------------------------------------
int is_identity(
	unsigned char a[PMT_MAX_N],
	int n)
{
	int i;
	for (i = 0; i < n; i++)
		if (a[i] != i)
			return 0;
	return 1;
}

// ----------------------------------------------------------------
void compose(
	unsigned char a[PMT_MAX_N],
	unsigned char b[PMT_MAX_N],
	unsigned char c[PMT_MAX_N],
	int n)
{
	int i;
	for (i = 0; i < n; i++)
		c[i] = a[b[i]];
}

// ----------------------------------------------------------------
int find_order(
	unsigned char a[PMT_MAX_N],
	int n)
{
	int rv;
	int i;
	unsigned char apower[PMT_MAX_N];
	unsigned char temp[PMT_MAX_N];

	for (i = 0; i < n; i++)
		apower[i] = a[i];

	for (rv = 1; ; rv++) {
		//printf("  [%2d] ", rv); // xxx
		//print_pmt(apower, n); // xxx
		//printf("\n"); // xxx
		if (is_identity(apower, n))
			return rv;
		for (i = 0; i < n; i++)
			temp[i] = apower[i];
		compose(a, temp, apower, n);
	}
}

// ----------------------------------------------------------------
int count_transpositions(
	unsigned char images[PMT_MAX_N],
	int n)
{
	unsigned char temp[PMT_MAX_N];
	unsigned char t;
	int i, top;
	int rv = 0;

	for (i = 0; i < n; i++)
		temp[i] = images[i];

	for (top = n - 1; top > 0; top--) {
		for (i = 0; i < top; i++) {
			if (temp[i] > temp[i+1]) {
				rv++;
				t         = temp[i];
				temp[i]   = temp[i+1];
				temp[i+1] = t;
			}
		}
	}
	return rv;
}

// ----------------------------------------------------------------
void kth_pmt(
	unsigned char in[],
	unsigned char temp[],
	unsigned char out[],
	unsigned   n,
	unsigned   nfact,
	unsigned   which)
{
	unsigned pos, q, r, i;
	unsigned ni, nifact;

	nifact = nfact;

	for (i = 0; i < n; i++)
		temp[i] = in[i];

	ni = n;
	for (pos = 0; pos < n; pos++) {
		nifact /= ni;
		r = which % nifact;
		q = which / nifact;
		which = r;

		out[pos] = temp[q];
		for (i = q; i < ni; i++)
			temp[i] = temp[i+1];

		ni--;
	}
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	unsigned char identity[PMT_MAX_N];
	unsigned char temp[PMT_MAX_N];
	unsigned char images[PMT_MAX_N];
	int n = 4;
	int nfact;
	int i;
	int nt;
	int order;

	if (argc == 2) {
		(void)sscanf(argv[1], "%d", &n);
	}
	if (n > 8) {
		fprintf(stderr, "8! is my max; got %d!.\n", n);
		exit(1);
	}
	nfact = 1;
	for (i = 1; i <= n; i++)
		nfact *= i;

	for (i = 0; i < n; i++)
		identity[i] = i;

	for (i = 0; i < nfact; i++) {
		kth_pmt(identity, temp, images, n, nfact, i);

		//print_pmt(identity, n);
		//printf("\n");
		print_pmt(images, n);
		//printf("\n");
		printf("  ");
		nt = count_transpositions(images, n);
		order = find_order(images, n);
		//printf("\n"); // xxx

		printf("  nt=%3d  order=%3d", nt, order);

		printf("  cycle decomposition: ");
		print_cd(images, n);
		printf("\n");
	}
	return 0;
}
