// Quadratic number field elements.

#ifndef QNFE_H
#define QNFE_H

#include "rat.h"

// ----------------------------------------------------------------
typedef struct _qnfe_t {
	rat_t r; // rational part
	rat_t i; // irrational and/or imaginary part
} qnfe_t;

// D is really an integer.  But it is stored as a rational (with
// denominator 1) to facilitate computations.
typedef struct _qnfe_aux_t {
	rat_t D; // e.g. a + b * sqrt(D)
} qnfe_aux_t;

// ----------------------------------------------------------------
qnfe_t qnfe_add  (qnfe_t a, qnfe_t b, qnfe_aux_t m);
qnfe_t qnfe_sub  (qnfe_t a, qnfe_t b, qnfe_aux_t m);
qnfe_t qnfe_mul  (qnfe_t a, qnfe_t b, qnfe_aux_t m);
qnfe_t qnfe_quot (qnfe_t a, qnfe_t b, qnfe_aux_t m);
qnfe_t qnfe_rem  (qnfe_t a, qnfe_t b, qnfe_aux_t m);
int    qnfe_equal(qnfe_t a, qnfe_t b, qnfe_aux_t m);

int    qnfe_scan (qnfe_t * pout, char  * pin);
void   qnfe_print(qnfe_t  g);

#endif // QNFE_H
