// Quadratic number ring elements.

#ifndef QNRE_H
#define QNRE_H

// ----------------------------------------------------------------
typedef struct _qnre_t {
	int r; // rational part
	int i; // irrational and/or imaginary part
} qnre_t;

typedef struct _qnre_aux_t {
	int D; // e.g. a + b * sqrt(D)
} qnre_aux_t;

// ----------------------------------------------------------------
qnre_t qnre_add  (qnre_t a, qnre_t b, qnre_aux_t m);
qnre_t qnre_sub  (qnre_t a, qnre_t b, qnre_aux_t m);
qnre_t qnre_mul  (qnre_t a, qnre_t b, qnre_aux_t m);
qnre_t qnre_quot (qnre_t a, qnre_t b, qnre_aux_t m);
qnre_t qnre_rem  (qnre_t a, qnre_t b, qnre_aux_t m);
int    qnre_equal(qnre_t a, qnre_t b, qnre_aux_t m);

int    qnre_scan(
	qnre_t * pout,
	char   * pin);

void   qnre_print(
	qnre_t   g);

#endif // QNRE_H
