#ifndef RAT_H
#define RAT_H

typedef struct _rat_t {
	int numer;
	int denom;
} rat_t;

rat_t rat_add(rat_t a, rat_t b);
rat_t rat_sub(rat_t a, rat_t b);
rat_t rat_usub(rat_t a);
rat_t rat_mul(rat_t a, rat_t b);
rat_t rat_div(rat_t a, rat_t b);
rat_t rat_recip(rat_t a);
rat_t rat_power(rat_t a, int e);

int rat_equal(rat_t a, rat_t b);
int rat_lt(rat_t a, rat_t b);
int rat_le(rat_t a, rat_t b);
int rat_gt(rat_t a, rat_t b);
int rat_ge(rat_t a, rat_t b);

// For use with qsort(3).
int rat_qcmp(const void * pv1, const void * pv2);

rat_t rat_from_int(int numer);
rat_t rat_from_ints(int numer,int denom);
int  rat_is_zero(rat_t a);
int  rat_is_one(rat_t a);
void rat_print(rat_t a);
int  rat_sscan(char  * pin, rat_t * pout);


#endif // RAT_H
