#include <stdio.h>
#include "ubig.h"

// ----------------------------------------------------------------
// sum k = 0 to n (n k) = 2**n

int main(int argc, char ** argv)
{
	unsigned ni = 100;
	ubig one, two_n, n, k, n_k, sum;
	ubig i, hi, lo;
	ubig_opts_t o;

	if (argc == 2)
		(void)sscanf(argv[1], "%d", &ni);

	o.hex_out = 0;
	o.zero_fill = 0;
	o.underscore_out = 0;

	ubig_from_unsigned(&sum, 0);
	ubig_from_unsigned(&one, 1);
	ubig_from_unsigned(&n,   ni);
	ubig_lsh(&two_n, &one, &n);

	for (ubig_from_unsigned(&k, 0); ubig_le(&k, &n); ubig_incr(&k)) {
		ubig_from_unsigned(&n_k, 1);

		hi = n;
		lo = one;
		for (ubig_from_unsigned(&i, 1); ubig_le(&i, &k); ubig_incr(&i)) {
			n_k = ubig_mul(&n_k, &hi);
			n_k = ubig_div(&n_k, &lo);
			ubig_decr(&hi);
			ubig_incr(&lo);
		}
		printf("(%3d %3hu) ", ni, k.parts[0]);
		ubig_print(stdout, &n_k, &o);
		printf("\n");

		sum = ubig_add(&sum, &n_k);
	}

	printf("sum = "); ubig_print(stdout, &sum,   &o); printf("\n");
	printf("2^n = "); ubig_print(stdout, &two_n, &o); printf("\n");

	return 0;
}
