#ifndef Z2ILINALG_H
#define Z2ILINALG_H

#include "z2ipoly.h"

void z2ila_transpose(
	z2ipoly_t * Mout,
	z2ipoly_t * Min,
	int n);

void z2ila_row_echelon_form(
	z2ipoly_t * M,
	int n);

void z2ila_row_reduce_below(
	z2ipoly_t * M,
	int n);

// Assumes z2ila_row_reduce_below has already been done.
void z2ila_row_reduce_above(
	z2ipoly_t * M,
	int n);

// Assumes the matrix is already in row-echelon form.
int z2ila_find_rank(
	z2ipoly_t * M,
	int n);

// Assumes the matrix is already in row-echelon form.
void z2ila_find_nullspace_basis(
	z2ipoly_t * BIT,
	int         n,
	z2ipoly_t * nullspace_basis,
	int         dimker);

// The caller must free the return value.
z2ipoly_t * z2ipoly_companion_matrix(
	z2ipoly_t r,
	int do_galois_cfg);

int z2ila_mx_times_vr(
	z2ipoly_t * M,
	int         n,
	z2ipoly_t   x);

void z2ila_sq_mx_times_sq_mx(
	z2ipoly_t * C, // output
	z2ipoly_t * A, // input 1
	z2ipoly_t * B, // input 2
	int         n);

#endif // Z2ILINALG_H
