#ifndef Z2IPOLY_FACTOR_H
#define Z2IPOLY_FACTOR_H

#include "z2ipolymod.h"

// ----------------------------------------------------------------
#define Z2IPOLY_MAX_NUM_FACTORS  Z2IPOLY_MAX_DEGREE

typedef struct _z2ipoly_factor_count_t {
	z2ipoly_t f;
	unsigned count;
} z2ipoly_factor_count_t;
typedef struct _z2ipoly_factor_info_t {
	z2ipoly_factor_count_t factor_counts[Z2IPOLY_MAX_NUM_FACTORS];
	int  num_distinct;
} z2ipoly_factor_info_t;

// ----------------------------------------------------------------
void z2ipoly_factor(
	z2ipoly_t r,
	z2ipoly_factor_info_t * pfinfo);

unsigned z2ipoly_num_divisors(
	z2ipoly_factor_info_t * pfinfo);

z2ipoly_t z2ipoly_kth_divisor(
	z2ipoly_factor_info_t * pfinfo,
	unsigned k);

// The caller must free the return value.
z2ipoly_t * z2ipoly_get_all_divisors(
	z2ipoly_t r,
	unsigned * pnum_divisors);

void z2ipoly_print_factors(
	z2ipoly_t r);

#endif // Z2IPOLY_FACTOR_H
