#ifndef Z2LINALG_H
#define Z2LINALG_H

#include "z2poly.h"

void z2la_transpose(
	z2poly_t * Mout,
	z2poly_t * Min,
	int n);

void z2la_row_echelon_form(
	z2poly_t * M,
	int n);

void z2la_row_reduce_below(
	z2poly_t * M,
	int n);

// Assumes z2la_row_reduce_below has already been done.
void z2la_row_reduce_above(
	z2poly_t * M,
	int n);

// Assumes the matrix is already in row-echelon form.
int z2la_find_rank(
	z2poly_t * M,
	int n);

// Assumes the matrix is already in row-echelon form.
void z2la_find_nullspace_basis(
	z2poly_t * BIT,
	int         n,
	z2poly_t * nullspace_basis,
	int         dimker);

#endif // Z2LINALG_H
