#include <stdio.h>
#include <stdlib.h>
#include "z2n.h"

// ----------------------------------------------------------------
int z2n_add(int a, int b, int n)
{
	int c;
	a &= (1 << n) - 1;
	b &= (1 << n) - 1;
	c = a ^ b;
	return c;
}

// ----------------------------------------------------------------
int z2n_minus(int a, int b, int n)
{
	int c;
	a &= (1 << n) - 1;
	b &= (1 << n) - 1;
	c = a ^ b;
	return c;
}

// ----------------------------------------------------------------
int z2n_mul(int a, int b, int n)
{
	int c;
	a &= (1 << n) - 1;
	b &= (1 << n) - 1;
	c = a & b;
	return (a * b) % n;
}

// ----------------------------------------------------------------
int z2n_quot(int a, int b, int n)
{
	printf("z2n quot stub.\n");
	exit(1);
	return 0;
}

// ----------------------------------------------------------------
int z2n_rem(int a, int b, int n)
{
	printf("z2n rem stub.\n");
	exit(1);
	return 0;
}

// ----------------------------------------------------------------
int z2n_recip(int a, int n)
{
	printf("z2n recip stub.\n");
	exit(1);
	return 0;
}

// ----------------------------------------------------------------
int z2n_equal(int a, int b, int n)
{
	return (a & ((1 << n) - 1)) == (b & ((1 << n) - 1));
}

// ----------------------------------------------------------------
void z2n_vadd(
	void * pvout,
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	int a = *(int *)pvin1;
	int b = *(int *)pvin2;
	int n = *(int *)pvaux;
	int c = z2n_add(a, b, n);
	*(int *)pvout = c;
}

// ----------------------------------------------------------------
int z2n_vequal(
	void * pin1,
	void * pin2,
	void * paux)
{
	int a = *(int *)pin1;
	int b = *(int *)pin2;
	int n = *(int *)paux;
	return z2n_equal(a, b, n);
}

// ----------------------------------------------------------------
void z2n_vprint(
	void * pin,
	void * paux)
{
	int i;
	int n = *(int *)paux;

	//printf("%02x:", *(int *)pin);
	printf("(");
	for (i = n-1; i >= 0; i--) {
		if (i != n-1)
			printf(",");
		printf("%c", '0' + ((*(int *)pin >> i) & 1));
	}
	printf(")");
}

// ================================================================
void z2n_vindex_to_element(
	int    which,
	void * pn,
	void * pelement)
{
	int n = *(int *)pn;
	*(int *)pelement = which & ((1 << n) - 1);
}
