#ifndef Z2NILINALG_H
#define Z2NILINALG_H

#include <stdio.h>
#include "z2ipolymod.h"
#include "z2nipoly.h"

z2ipoly_t ** z2nila_alloc_matrix(
	int          nrows,
	int          ncols);

void z2nila_free_matrix(
	z2ipoly_t ** M,
	int          nrows,
	int          ncols);

void z2nila_print_matrix(
	z2ipoly_t ** M,
	int          nrows,
	int          ncols,
	z2ipoly_t    r);

void z2nila_print_vector(
	z2ipoly_t * v,
	int         n,
	z2ipoly_t   r);

void z2nila_matrix_from_z2nipolys(
	z2ipoly_t ** M,
	int          nrows,
	int          ncols,
	z2nipoly_t * polys);

void z2nila_z2nipolys_from_matrix(
	z2nipoly_t * polys,
	z2ipoly_t ** M,
	int          nrows,
	int          ncols);

void z2nila_row_from_z2nipoly(
	z2ipoly_t  * prow,
	z2nipoly_t * pzpoly,
	int          ncols);

void z2nila_transpose(
	z2ipoly_t ** Mout,
	z2ipoly_t ** Min,
	int          n);

void z2nila_row_echelon_form(
	z2ipoly_t ** M,
	z2ipoly_t    r,
	int          nrows,
	int          ncols);

void z2nila_row_reduce_below(
	z2ipoly_t ** M,
	z2ipoly_t    r,
	int          nrows,
	int          ncols);

// Assumes z2nila_row_reduce_below has already been done.
void z2nila_row_reduce_above(
	z2ipoly_t ** M,
	z2ipoly_t    r,
	int          nrows,
	int          ncols);

void z2nila_make_matrix_monic(
	z2ipoly_t ** M,
	z2ipoly_t    r,
	int          nrows,
	int          ncols);

// Assumes the matrix is already in row-echelon form.
int z2nila_find_rank(
	z2ipoly_t ** M,
	int          nrows,
	int          ncols);

int z2nila_row_is_zero(
	z2ipoly_t  * prow,
	int          ncols);

// Assumes the matrix is already in row-echelon form.
void z2nila_find_nullspace_basis(
	z2ipoly_t ** M,
	int          nrows,
	int          ncols,
	z2ipoly_t    r,
	z2nipoly_t * nullspace_basis,
	int          dimker);

// Square matrix times vector
void z2nila_mx_times_vr(
	z2ipoly_t  ** M,
	z2ipoly_t   * vin,
	z2ipoly_t   * vout,
	int           n,
	z2ipoly_t     r);

#endif // Z2NILINALG_H
