#ifndef Z2NIPOLY_FACTOR_H
#define Z2NIPOLY_FACTOR_H

#include "zppolymod.h"
#include "z2nipoly.h"

// ----------------------------------------------------------------
#define Z2NIPOLY_MAX_NUM_FACTORS  Z2NIPOLY_MAX_DEGREE

typedef struct _z2nipoly_factor_count_t {
	z2nipoly_t f;
	unsigned count;
} z2nipoly_factor_count_t;
typedef struct _z2nipoly_factor_info_t {
	z2nipoly_factor_count_t factor_counts[Z2NIPOLY_MAX_NUM_FACTORS];
	int  num_distinct;
} z2nipoly_factor_info_t;

// ----------------------------------------------------------------
void z2nipoly_factor(
	z2nipoly_t * pz,
	z2ipoly_t    r,
	z2nipoly_factor_info_t * pfinfo);

unsigned z2nipoly_num_divisors(
	z2nipoly_factor_info_t * pfinfo);

z2nipoly_t z2nipoly_kth_divisor(
	z2nipoly_factor_info_t * pfinfo,
	z2ipoly_t    r,
	unsigned     k);

// The caller must free the return value.
z2nipoly_t * z2nipoly_get_all_divisors(
	z2nipoly_t * pz,
	z2ipoly_t    r,
	unsigned   * pnum_divisors);

// The caller must free the return value.
z2ipoly_t * z2ipoly_get_roots(
	z2ipoly_t z,
	z2ipoly_t r);

// The caller must free the return value.
z2ipoly_t * z2ipolymod_get_elements_frobord(
	z2ipoly_t r,
	int * pnel);

#endif // Z2NIPOLY_FACTOR_H
