#ifndef Z2NLINALG_H
#define Z2NLINALG_H

#include <stdio.h>
#include "z2polymod.h"
#include "z2npoly.h"

z2poly_t ** z2nla_alloc_matrix(
	int         nrows,
	int         ncols);

void z2nla_free_matrix(
	z2poly_t ** M,
	int         nrows,
	int         ncols);

void z2nla_print_matrix(
	z2poly_t ** M,
	int         nrows,
	int         ncols,
	z2poly_t  * pr);

void z2nla_matrix_from_z2npolys(
	z2poly_t ** M,
	int         nrows,
	int         ncols,
	z2npoly_t * polys);

void z2nla_z2npolys_from_matrix(
	z2npoly_t * polys,
	z2poly_t ** M,
	int         nrows,
	int         ncols);

void z2nla_row_from_z2npoly(
	z2poly_t  * prow,
	z2npoly_t * pzpoly,
	int         ncols);

void z2nla_transpose(
	z2poly_t ** Mout,
	z2poly_t ** Min,
	int         n);

void z2nla_row_echelon_form(
	z2poly_t ** M,
	z2poly_t  * pr,
	int         nrows,
	int         ncols);

void z2nla_row_reduce_below(
	z2poly_t ** M,
	z2poly_t  * pr,
	int         nrows,
	int         ncols);

// Assumes z2nla_row_reduce_below has already been done.
void z2nla_row_reduce_above(
	z2poly_t ** M,
	z2poly_t  * pr,
	int         nrows,
	int         ncols);

void z2nla_make_matrix_monic(
	z2poly_t ** M,
	z2poly_t  * pr,
	int         nrows,
	int         ncols);

// Assumes the matrix is already in row-echelon form.
int z2nla_find_rank(
	z2poly_t ** M,
	int         nrows,
	int         ncols);

int z2nla_row_is_zero(
	z2poly_t  * prow,
	int         ncols);

// Assumes the matrix is already in row-echelon form.
void z2nla_find_nullspace_basis(
	z2poly_t ** M,
	int         nrows,
	int         ncols,
	z2poly_t  * pr,
	z2npoly_t * nullspace_basis,
	int         dimker);

#endif // Z2NLINALG_H
