#ifndef Z2NPOLY_FACTOR_H
#define Z2NPOLY_FACTOR_H

#include "zppolymod.h"
#include "z2npoly.h"

// ----------------------------------------------------------------
#define Z2NPOLY_MAX_NUM_FACTORS  Z2NPOLY_MAX_DEGREE

typedef struct _z2npoly_factor_count_t {
	z2npoly_t f;
	unsigned count;
} z2npoly_factor_count_t;
typedef struct _z2npoly_factor_info_t {
	z2npoly_factor_count_t factor_counts[Z2NPOLY_MAX_NUM_FACTORS];
	int  num_distinct;
} z2npoly_factor_info_t;

// ----------------------------------------------------------------
void z2npoly_factor(
	z2npoly_t * pz,
	z2poly_t  * pr,
	z2npoly_factor_info_t * pfinfo);

unsigned z2npoly_num_divisors(
	z2npoly_factor_info_t * pfinfo);

z2npoly_t z2npoly_kth_divisor(
	z2npoly_factor_info_t * pfinfo,
	z2poly_t  * pr,
	unsigned     k);

// The caller must free the return value.
z2npoly_t * z2npoly_get_all_divisors(
	z2npoly_t * pz,
	z2poly_t  * pr,
	unsigned  * pnum_divisors);

// The caller must free the return value.
z2poly_t * z2poly_get_roots(
	z2poly_t  * pz,
	z2poly_t  * pr);

// The caller must free the return value.
z2poly_t * z2polymod_get_elements_frobord(
	z2poly_t  * pr);

#endif // Z2NPOLY_FACTOR_H
