#ifndef Z2POLY_FACTOR_H
#define Z2POLY_FACTOR_H

#include "z2polymod.h"

// ----------------------------------------------------------------
#define Z2POLY_MAX_NUM_FACTORS  Z2POLY_MAX_DEGREE

typedef struct _z2poly_factor_count_t {
	z2poly_t f;
	unsigned count;
} z2poly_factor_count_t;
typedef struct _z2poly_factor_info_t {
	z2poly_factor_count_t factor_counts[Z2POLY_MAX_NUM_FACTORS];
	int  num_distinct;
} z2poly_factor_info_t;

// ----------------------------------------------------------------
void z2poly_factor(
	z2poly_t * pr,
	z2poly_factor_info_t * pfinfo);

unsigned z2poly_num_divisors(
	z2poly_factor_info_t * pfinfo);

z2poly_t z2poly_kth_divisor(
	z2poly_factor_info_t * pfinfo,
	unsigned k);

// The caller must free the return value.
z2poly_t * z2poly_get_all_divisors(
	z2poly_t * pr,
	unsigned * pnum_divisors);

#endif // Z2POLY_FACTOR_H
