#ifndef Z3LINALG_H
#define Z3LINALG_H

#include <stdio.h>
#include "z3poly.h"

unsigned char ** z3la_alloc_matrix(
	int        nrows,
	int        ncols);

void z3la_free_matrix(
	unsigned char ** M,
	int        nrows,
	int        ncols);

void z3la_print_matrix(
	unsigned char ** M,
	int        nrows,
	int        ncols);

void z3la_matrix_from_z3polys(
	unsigned char ** M,
	int        nrows,
	int        ncols,
	z3poly_t * polys);

void z3la_z3polys_from_matrix(
	z3poly_t  * polys,
	unsigned char ** M,
	int        nrows,
	int        ncols);

void z3la_row_from_z3poly(
	unsigned char * prow,
	z3poly_t * pz3poly,
	int        ncols);

void z3la_transpose(
	unsigned char ** Mout,
	unsigned char ** Min,
	int        n);

void z3la_row_echelon_form(
	unsigned char ** M,
	int        nrows,
	int        ncols);

void z3la_row_reduce_below(
	unsigned char ** M,
	int        nrows,
	int        ncols);

// Assumes z2ila_row_reduce_below has already been done.
void z3la_row_reduce_above(
	unsigned char ** M,
	int        nrows,
	int        ncols);

void z3la_make_matrix_monic(
	unsigned char ** M,
	int        nrows,
	int        ncols);

// Assumes the matrix is already in row-echelon form.
int z3la_find_rank(
	unsigned char ** M,
	int        nrows,
	int        ncols);

int z3la_row_is_zero(
	unsigned char * prow,
	int        ncols);

// Assumes the matrix is already in row-echelon form.
void z3la_find_nullspace_basis(
	unsigned char ** BIT,
	int        nrows,
	int        ncols,
	z3poly_t * nullspace_basis,
	int        dimker);

#endif // Z3LINALG_H
