#ifndef Z3NLINALG_H
#define Z3NLINALG_H

#include <stdio.h>
#include "z3polymod.h"
#include "z3npoly.h"

z3poly_t ** z3nla_alloc_matrix(
	int         nrows,
	int         ncols);

void z3nla_free_matrix(
	z3poly_t ** M,
	int         nrows,
	int         ncols);

void z3nla_print_matrix(
	z3poly_t ** M,
	int         nrows,
	int         ncols,
	z3poly_t  * pr);

void z3nla_matrix_from_z3npolys(
	z3poly_t ** M,
	int         nrows,
	int         ncols,
	z3npoly_t * polys);

void z3nla_z3npolys_from_matrix(
	z3npoly_t * polys,
	z3poly_t ** M,
	int         nrows,
	int         ncols);

void z3nla_row_from_z3npoly(
	z3poly_t  * prow,
	z3npoly_t * pzpoly,
	int         ncols);

void z3nla_transpose(
	z3poly_t ** Mout,
	z3poly_t ** Min,
	int         n);

void z3nla_row_echelon_form(
	z3poly_t ** M,
	z3poly_t  * pr,
	int         nrows,
	int         ncols);

void z3nla_row_reduce_below(
	z3poly_t ** M,
	z3poly_t  * pr,
	int         nrows,
	int         ncols);

// Assumes z3nla_row_reduce_below has already been done.
void z3nla_row_reduce_above(
	z3poly_t ** M,
	z3poly_t  * pr,
	int         nrows,
	int         ncols);

void z3nla_make_matrix_monic(
	z3poly_t ** M,
	z3poly_t  * pr,
	int         nrows,
	int         ncols);

// Assumes the matrix is already in row-echelon form.
int z3nla_find_rank(
	z3poly_t ** M,
	int         nrows,
	int         ncols);

int z3nla_row_is_zero(
	z3poly_t  * prow,
	int         ncols);

// Assumes the matrix is already in row-echelon form.
void z3nla_find_nullspace_basis(
	z3poly_t ** M,
	int         nrows,
	int         ncols,
	z3poly_t  * pr,
	z3npoly_t * nullspace_basis,
	int         dimker);

#endif // Z3NLINALG_H
