#ifndef Z3NPOLY_FACTOR_H
#define Z3NPOLY_FACTOR_H

#include "zppolymod.h"
#include "z3npoly.h"

// ----------------------------------------------------------------
#define Z3NPOLY_MAX_NUM_FACTORS  Z3NPOLY_MAX_DEGREE

typedef struct _z3npoly_factor_count_t {
	z3npoly_t f;
	unsigned count;
} z3npoly_factor_count_t;
typedef struct _z3npoly_factor_info_t {
	z3npoly_factor_count_t factor_counts[Z3NPOLY_MAX_NUM_FACTORS];
	int  num_distinct;
} z3npoly_factor_info_t;

// ----------------------------------------------------------------
void z3npoly_factor(
	z3npoly_t * pz,
	z3poly_t  * pr,
	z3npoly_factor_info_t * pfinfo);

unsigned z3npoly_num_divisors(
	z3npoly_factor_info_t * pfinfo);

z3npoly_t z3npoly_kth_divisor(
	z3npoly_factor_info_t * pfinfo,
	z3poly_t  * pr,
	unsigned     k);

// The caller must free the return value.
z3npoly_t * z3npoly_get_all_divisors(
	z3npoly_t * pz,
	z3poly_t  * pr,
	unsigned  * pnum_divisors);

// The caller must free the return value.
z3poly_t * z3poly_get_roots(
	z3poly_t  * pz,
	z3poly_t  * pr);

// The caller must free the return value.
z3poly_t * z3polymod_get_elements_frobord(
	z3poly_t  * pr,
	int * pnel);

#endif // Z3NPOLY_FACTOR_H
