#ifndef Z3POLY_FACTOR_H
#define Z3POLY_FACTOR_H

#include "z3polymod.h"

// ----------------------------------------------------------------
#define Z3POLY_MAX_NUM_FACTORS  Z3POLY_MAX_DEGREE

typedef struct _z3poly_factor_count_t {
	z3poly_t f;
	unsigned count;
} z3poly_factor_count_t;
typedef struct _z3poly_factor_info_t {
	z3poly_factor_count_t factor_counts[Z3POLY_MAX_NUM_FACTORS];
	int  num_distinct;
} z3poly_factor_info_t;

// ----------------------------------------------------------------
void z3poly_factor(
	z3poly_t * pr,
	z3poly_factor_info_t * pfinfo);

unsigned z3poly_num_divisors(
	z3poly_factor_info_t * pfinfo);

z3poly_t z3poly_kth_divisor(
	z3poly_factor_info_t * pfinfo,
	unsigned  k);

// The caller must free the return value.
z3poly_t * z3poly_get_all_divisors(
	z3poly_t * pr,
	unsigned * pnum_divisors);

#endif // Z3POLY_FACTOR_H
