#ifndef ZLINALG_H
#define ZLINALG_H

#include <stdio.h>
#include "zpoly.h"

int ** zla_alloc_matrix(
	int        nrows,
	int        ncols);

void zla_free_matrix(
	int     ** M,
	int        nrows,
	int        ncols);

void zla_print_matrix(
	int     ** M,
	int        nrows,
	int        ncols);

// Input of the form 1010:0010:0011:1110,
// or 1,0,1,0:0,0,1,0:0,0,1,1:1,1,1,0.
// Caller must free the return value.
int zla_matrix_from_string(
	char     * string,
	int    *** pM,
	int      * pnrows,
	int      * pncols);

// Input of the form
//   1 0 1 0
//   0 0 1 0
//   0 0 1 1
//   1 1 1 0
// Caller must free the return value.
int zla_matrix_from_stream(
	FILE     * fp,
	int    *** pM,
	int      * pnrows,
	int      * pncols);


void zla_transpose(
	int     ** Mout,
	int     ** Min,
	int        n);

// For square matrices.
void zla_mats_mul(
	int     ** out,
	int     ** in1,
	int     ** in2,
	int        n);

// For square matrices.
void zla_mats_copy(
	int     ** out,
	int     ** in,
	int        n);

// For square matrices.
int zla_is_I(
	int     ** M,
	int        n);

// For square matrices.
int zla_equals(
	int     ** A,
	int     ** B,
	int        n);

#endif // ZLINALG_H
