#ifndef ZPNPOLY_FACTOR_H
#define ZPNPOLY_FACTOR_H

#include "zppolymod.h"
#include "zpnpoly.h"

// ----------------------------------------------------------------
#define ZPNPOLY_MAX_NUM_FACTORS  ZPNPOLY_MAX_DEGREE

typedef struct _zpnpoly_factor_count_t {
	zpnpoly_t f;
	unsigned count;
} zpnpoly_factor_count_t;
typedef struct _zpnpoly_factor_info_t {
	zpnpoly_factor_count_t factor_counts[ZPNPOLY_MAX_NUM_FACTORS];
	int  num_distinct;
} zpnpoly_factor_info_t;

// ----------------------------------------------------------------
void zpnpoly_factor(
	zpnpoly_t * pr,
	zppoly_aux_t * paux,
	zpnpoly_factor_info_t * pfinfo);

unsigned zpnpoly_num_divisors(
	zpnpoly_factor_info_t * pfinfo);

zpnpoly_t zpnpoly_kth_divisor(
	zpnpoly_factor_info_t * pfinfo,
	zppoly_aux_t * paux,
	unsigned  k);

// The caller must free the return value.
zpnpoly_t * zpnpoly_get_all_divisors(
	zpnpoly_t * pr,
	zppoly_aux_t * paux,
	unsigned  * pnum_divisors);

// The caller must free the return value.
zpoly_t * zppoly_get_roots(
	zpoly_t      * pz,
	zppoly_aux_t * paux);

// The caller must free the return value.
zpoly_t * zppolymod_get_elements_frobord(
	zpoly_t  * pr,
	int        p,
	int      * pnel);

#endif // ZPNPOLY_FACTOR_H
