#ifndef ZPPOLY_FACTOR_H
#define ZPPOLY_FACTOR_H

#include "zppolymod.h"

// ----------------------------------------------------------------
#define ZPPOLY_MAX_NUM_FACTORS  ZPOLY_MAX_DEGREE

typedef struct _zppoly_factor_count_t {
	zpoly_t f;
	unsigned count;
} zppoly_factor_count_t;
typedef struct _zppoly_factor_info_t {
	zppoly_factor_count_t factor_counts[ZPPOLY_MAX_NUM_FACTORS];
	int  num_distinct;
} zppoly_factor_info_t;

// ----------------------------------------------------------------
void zppoly_factor(
	zpoly_t * pr,
	int       p,
	zppoly_factor_info_t * pfinfo);

unsigned zppoly_num_divisors(
	zppoly_factor_info_t * pfinfo);

zpoly_t zppoly_kth_divisor(
	zppoly_factor_info_t * pfinfo,
	int       p,
	unsigned  k);

// The caller must free the return value.
zpoly_t * zppoly_get_all_divisors(
	zpoly_t  * pr,
	int        p,
	unsigned * pnum_divisors);

void zppoly_print_factors(
	zpoly_t * pr,
	int       p);

#endif // ZPPOLY_FACTOR_H
