#include <stdio.h>
#include <stdlib.h>
#include <sys/select.h>

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m1} {m2} [ms delay]\n", argv0);
	fprintf(stderr, "  m1 is plotted along rows, m2 along columns.\n");
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	unsigned x1, x2;
	unsigned m1, m2;
	unsigned msdelay = 25;
	struct timeval tv, tvs;
	int dot = 1;
	int wait = 0;

	if ((argc != 3) && (argc != 4))
		usage(argv[0]);
	if (sscanf(argv[1], "%u", &m1) != 1)
		usage(argv[0]);
	if (sscanf(argv[2], "%u", &m2) != 1)
		usage(argv[0]);
	if (argc == 4) {
		if (sscanf(argv[3], "%u", &msdelay) != 1)
			usage(argv[0]);
	}

	tv.tv_sec  = 0;
	tv.tv_usec = msdelay * 1000;
	tv.tv_sec  = tv.tv_usec / 1000000;
	tv.tv_usec = tv.tv_usec % 1000000;
	tvs = tv;

	printf("\033[H\033[J");
	for (x1 = 0; x1 < m1; x1++) {
		for (x2 = 0; x2 < m2; x2++) {
			if (dot)
				printf(". ");
			else
				printf("  .   ");
		}
		printf("\n");
	}
	printf("\033[H");
	x1 = 0;
	x2 = 0;
	do {
		if (dot) {
			printf("\033[%u;%uH", x1+1, x2*2+1);
			printf("*");
		}
		else {
			printf("\033[%u;%uH", x1+1, x2*6+1);
			printf("%2u,%2u", x1, x2);
		}
		fflush(stdout);
		x1 = (x1 + 1) % m1;
		x2 = (x2 + 1) % m2;
		if (msdelay) {
			tv = tvs;
			select(0, 0, 0, 0, &tv);
		}
		if (wait) {
			fflush(stdin);
			(void)getchar();
		}
	} while ((x1 != 0) || (x2 != 0));
	printf("\033[%u;%uH\n", m1, 1);

	return 0;
}
