use Dda;
use Mymx;

$max = 10000;
$dim = 3;

for $i (0 .. $dim) {
	$seeds[$i] = 0;
}
$seeds[$dim] = 1;
@dda = @seeds;

for $k (0 .. $max) {
	printf "[%4d] ", $k;

	for $i (0 .. $dim) {
		printf "%08x", $dda[$i];
		if ($i == $dim) {
			print "\n";
		}
		else {
			print " ";
		}
	}
	step_dda(\@dda);
}

# # ----------------------------------------------------------------
# sub demo
# {
# 	die "Usage: $0 {num steps} {delta} {alpha} {polynomial coefficients ...}\n"
# 		unless (@ARGV >= 3);
# 	my $num_steps = shift @ARGV;
# 	my $delta = shift @ARGV;
# 	my $alpha = shift @ARGV;
# 	my $dim   = @ARGV;
# 	my @coefs = @ARGV;
# 	my $x0 = 0.0;
# 	my $h  = 0.1;
# 
# 	print "Coefs:\n";
# 	show_vector(\@coefs, $dim);
# 	print "\n";
# 
# 	my @poly_outputs = eval_poly_mesh(\@coefs, $x0, $h);
# 	print "Outputs:\n";
# 	show_vector(\@poly_outputs, $dim);
# 	print "\n";
# 
# 	my @seeds = poly_outputs_to_seeds(\@poly_outputs);
# 	print "Seeds:\n";
# 	show_vector(\@seeds, $dim);
# 	print "\n";
# 
# 	print "Direct evaluation of polynomial on original mesh:\n";
# 	for $i (0 .. $num_steps - 1) {
# 		my $x = $x0 + $i * $h;
# 		my $y = eval_poly(\@coefs, $x);
# 		printf "x_%-2d = %7.4f: %7.4f\n", $i, $x, $y;
# 	}
# 	print "\n";
# 
# 	print "DDA output over the same mesh:\n";
# 	my @R = @seeds;
# 	for $i (0 .. $num_steps - 1) {
# 		my $x = $x0 + $i * $h;
# 		my $y = $R[0];
# 		printf "x_%-2d = %7.4f: %7.4f\n", $i, $x, $y;
# 		step_dda(\@R);
# 	}
# 	print "\n";
# 
# 	my @Q = make_Q($dim, $delta, $alpha);
# 	print "Q($delta, $alpha):\n";
# 	show_matrix(\@Q, $dim);
# 
# 	my @AiQA = make_AiQA($dim, $delta, $alpha);
# 	print "AiQA:\n";
# 	show_matrix(\@AiQA, $dim);
# 
# 	my @new_seeds = matrix_times_vector(\@AiQA, \@seeds, $dim);
# 
# 	print "Seeds scaled by AiQA:\n";
# 	show_vector(\@new_seeds, $dim);
# 	print "\n";
# 
# 	print "DDA outputs over the new mesh:\n";
# 	@R = @new_seeds;
# 	for $i (0 .. $num_steps - 1) {
# 		my $x = $x0 + $i * $h;
# 		my $y = $R[0];
# 		printf "x_%-2d = %7.4f: %7.4f\n", $i, $x, $y;
# 		step_dda(\@R);
# 	}
# 	print "\n";
# 
# 	$x0 += $delta * $h;
# 	$h *= $alpha;
# 	print "Direct evaluation of polynomial on new mesh:\n";
# 	for $i (0 .. $num_steps - 1) {
# 		my $x = $x0 + $i * $h;
# 		my $y = eval_poly(\@coefs, $x);
# 		printf "x_%-2d = %7.4f: %7.4f\n", $i, $x, $y;
# 	}
# 	print "\n";
# }
# 
# # ----------------------------------------------------------------
# sub apply_test
# {
# 	die "Usage: $0 {num steps} {delta} {alpha} {DDA seeds ...}\n"
# 		unless (@ARGV >= 3);
# 	$num_steps = shift @ARGV;
# 	$delta = shift @ARGV;
# 	$alpha = shift @ARGV;
# 	$dim   = @ARGV;
# 	my @c  = @ARGV;
# 	my $i;
# 
# 	my @Q = make_Q($dim, $delta, $alpha);
# 	print "Q:\n";
# 	show_matrix(\@Q, $dim);
# 
# 	my @AiQA = make_AiQA($dim, $delta, $alpha);
# 	print "AiQA:\n";
# 	show_matrix(\@AiQA, $dim);
# 
# 	my @cp = matrix_times_vector(\@AiQA, \@c, $dim);
# 
# 	my @R = @c;
# 	for $i (0 .. $num_steps - 1) {
# 		#show_vector(\@R, $dim);
# 		printf "%3d: %7.4f\n", $i, $R[0];
# 		step_dda(\@R);
# 	}
# 
# 	print "\n";
# 
# 	@R = @cp;
# 	for $i (0 .. $num_steps - 1) {
# 		#show_vector(\@R, $dim);
# 		printf "%3d: %7.4f\n", $i, $R[0];
# 		step_dda(\@R);
# 	}
# }
# 
# # ----------------------------------------------------------------
# sub AiQA_test
# {
# 	die "Usage: $0 {dim} {delta} {alpha}\n" unless (@ARGV == 3);
# 	$dim   = $ARGV[0];
# 	$delta = $ARGV[1];
# 	$alpha = $ARGV[2];
# 
# 	my @A = make_A($dim);
# 	# print "A:\n";
# 	# show_matrix(\@A, $dim);
# 
# 	my @A_inv = make_A_inv($dim);
# 	# print "A inverse:\n";
# 	# show_matrix(\@A_inv, $dim);
# 
# 	my @Q = make_Q($dim, $delta, $alpha);
# 	print "Q($delta, $alpha):\n";
# 	show_matrix(\@Q, $dim);
# 
# 	my @QA   = matrix_product(\@Q, \@A, $dim);
# 	my @AiQA = matrix_product(\@A_inv, \@QA, $dim);
# 	print "A inverse * Q * A:\n";
# 	show_matrix(\@AiQA, $dim);
# }
# 
# # ----------------------------------------------------------------
# sub binc_test
# {
# 	my $max = 10;
# 	my $i;
# 
# 	$max = $ARGV[0] if (@ARGV);
# 
# 	for $i (1 .. $max) {
# 		for $j (0 .. $i) {
# 			my $b = binc($i, $j);
# 			print "$b ";
# 		}
# 		print "\n";
# 	}
# }
# 
# # ----------------------------------------------------------------
# sub make_AiQA
# {
# 	my ($dim, $delta, $alpha) = @_;
# 
# 	die "make_AiQA():  Need matrix dimension, delta and alpha as arguments.\n"
# 		unless defined $alpha;
# 
# 	my @A = make_A($dim);
# 	my @A_inv = make_A_inv($dim);
# 	my @Q = make_Q($dim, $delta, $alpha);
# 	my @QA   = matrix_product(\@Q, \@A, $dim);
# 	my @AiQA = matrix_product(\@A_inv, \@QA, $dim);
# 	return @AiQA;
# }
# 
# # ----------------------------------------------------------------
# sub make_A
# {
# 	my ($dim) = @_;
# 	my $i;
# 	my $j;
# 	my @A;
# 
# 	die "make_A():  Need matrix dimension as argument.\n"
# 		unless defined $dim;
# 
# 	for $i (0 .. $dim - 1) {
# 		for $j (0 .. $dim - 1) {
# 			$A[$i][$j] = binc($i, $j);
# 		}
# 	}
# 
# 	return @A;
# }
# 
# # ----------------------------------------------------------------
# sub make_A_inv
# {
# 	my ($dim) = @_;
# 	my $i;
# 	my $j;
# 	my $sign;
# 	my @A_inv;
# 
# 	die "make_A_inv():  Need matrix dimension as argument.\n"
# 		unless defined $dim;
# 
# 	for $i (0 .. $dim - 1) {
# 		if (($i % 2) == 0) {
# 			$sign = 1;
# 		}
# 		else {
# 			$sign = -1;
# 		}
# 		for $j (0 .. $dim - 1) {
# 			$A_inv[$i][$j] = binc($i, $j) * $sign;
# 			$sign = -$sign;
# 		}
# 	}
# 
# 	return @A_inv;
# }
# 
# # ----------------------------------------------------------------
# #
# # [ d + j*a - l ]
# # [-------------]
# # [    k - l    ]
# 
# sub make_Q
# {
# 	my ($dim, $delta, $alpha) = @_;
# 	my @Q;
# 	my $i;
# 	my $j;
# 	my $k;
# 
# 	die "make_Q():  Need matrix dimension, delta and alpha as arguments.\n"
# 		unless defined $alpha;
# 
# 	for $i (0 .. $dim - 1) {
# 		for $j (0 .. $dim - 1) {
# 			$Q[$i][$j] = 1.0;
# 			for $k (0 .. $dim - 1) {
# 				if ($k != $j) {
# 					$Q[$i][$j] *= ($delta + $i * $alpha - $k) / ($j - $k);
# 				}
# 			}
# 		}
# 	}
# 	return @Q;
# }
# 
# # ----------------------------------------------------------------
# sub binc
# {
# 	my ($a, $b) = @_;
# 	my $result;
# 	my $top;
# 	my $bottom;
# 	my $i;
# 
# 	die "binc():  Need two non-negative integer arguments.\n"
# 		unless defined $b;
# 
# 	die "binc():  Need two non-negative integer arguments.\n"
# 		if (($a < 0) || ($b < 0));
# 
# 	return 0 if ($a < $b);
# 
# 	if ($b > $a/2) {
# 		$b = $a - $b;
# 	}
# 
# 	$result = 1;
# 	$top = $a;
# 	$bottom = 1;
# 	for $i (1 .. $b) {
# 		$result *= $top;
# 		$result /= $bottom;
# 		$top--;
# 		$bottom++;
# 	}
# 	return $result;
# }
