#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "diffy.h"

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int n = argc - 1;
	int * px = (int *)malloc(n * sizeof(int));
	int * pt = (int *)malloc(n * sizeof(int));
	int argi, i, niter;

	if (!px || !pt) {
		fprintf(stderr, "%s:  malloc failed.\n", argv[0]);
		exit(1);
	}

	if (n < 2) {
		fprintf(stderr, "%s:  Need at least two arguments.\n",
			argv[0]);
		exit(1);
	}

	for (argi = 1, i = 0; argi < argc; argi++, i++) {
		if (sscanf(argv[argi], "%d", &px[i]) != 1) {
			fprintf(stderr, "%s:  Can't scan \"%s\".\n",
				argv[0], argv[argi]);
			exit(1);
		}
		if (px[i] < 0)
			px[i] = -px[i];
	}

	diffy_iterate(px, pt, n, 1, &niter);

	free(px);
	free(pt);
	return 0;
}
