#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "diffy.h"

// ----------------------------------------------------------------
static void take_abs(
	int * px,
	int   n)
{
	int i;
	for (i = 0; i < n; i++)
		if (px[i] < 0)
			px[i] = -px[i];
}

// ----------------------------------------------------------------
static void take_diffs(
	int * px,
	int * pt,
	int   n,
	int * psum)
{
	int i, sum;

	for (i = 0; i < n-1; i++) {
		pt[i] = px[i+1] - px[i];
	}
	pt[n-1] = px[0] - px[n-1];
	for (i = 0; i < n; i++) {
		if (pt[i] < 0)
			px[i] = -pt[i];
		else
			px[i] =  pt[i];
	}

	sum = 0;
	for (i = 0; i < n; i++)
		sum += px[i];

	*psum = sum;
}

// ----------------------------------------------------------------
void diffy_iterate(
	int * px,
	int * pt,
	int   n,
	int   verbose,
	int * pniter)
{
	int width, maxwidth = 0;
	int i, niter, sum;

	take_abs(px, n);

	for (i = 0; i < n; i++) {
		if (px[i] == 0)
			width = 1;
		else
			width = (int)log10((double)px[i]) + 1;
		if (width > maxwidth)
			maxwidth = width;
	}

	for (niter = 0; ; niter++) {
		if (niter > 10000) {
			fprintf(stderr, "Panic!\n");
			exit(1);
		}

		if (verbose) {
			for (i = 0; i < n; i++)
				printf(" %*d", maxwidth, px[i]);
			printf("\n");
		}

		take_diffs(px, pt, n, &sum);
		if (sum == 0)
			break;
	}

	*pniter = niter;
}
