#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "diffy.h"


// ----------------------------------------------------------------
void diffy_iterate(
	int * px,
	int * pt,
	int   n,
	int   verbose,
	int * pniter)
{
#ifndef FAST
	int width = 0, maxwidth = 0;
#endif
	int i, niter, t, d, sum;

	for (i = 0; i < n; i++)
		if (px[i] < 0)
			px[i] = -px[i];


#ifndef FAST
	for (i = 0; i < n; i++) {
		if (px[i] == 0)
			width = 1;
		else
			width = (int)log10((double)px[i]) + 1;
		if (width > maxwidth)
			maxwidth = width;
	}
#endif

	for (niter = 0; ; niter++) {
		if (niter > 10000) {
			fprintf(stderr, "Panic!\n");
			exit(1);
		}

#ifndef FAST
		if (verbose) {
			for (i = 0; i < n; i++)
				printf(" %*d", maxwidth, px[i]);
			printf("\n");
		}
#endif

		// x0 = |x1 - x0|;
		// x1 = |x2 - x1|;
		// x2 = |x3 - x2|;
		// x3 = |x0 - x3|;

		// t  = |x1 - x0|;
		// x1 = |x2 - x1|;
		// x2 = |x3 - x2|;
		// x3 = |x0 - x3|;
		// x0 = t;

		sum = 0;

		t = px[1] - px[0];
		if (t < 0)
			t = -t;
		sum += t;

		for (i = 1; i < n-1; i++) {
			d = px[i+1] - px[i];
			if (d < 0)
				d = -d;
			px[i] = d;
			sum += d;
		}

		d = px[0] - px[n-1];
		if (d < 0)
			d = -d;
		px[n-1] = d;
		sum += d;

		px[0] = t;

		if (sum == 0)
			break;
	}

	*pniter = niter;
}
