// Input: m, n
// Output: GCD d; a, b such that am + bn = d

void extended_GCD(
	int   m,
	int   n,
	int * pg,
	int * pa,
	int * pb)
{
	int a, b;
	int aprime, bprime, c, d, q, r, t;

	// Initialize
	aprime = b = 1;
	a = bprime = 0;
	c = m;
	d = n;

	while (1) {

		// Divide
		q = c / d;
		r = c % d;
		// Note:  now c = qd + r and 0 <= r < d

		// Remainder zero?
		if (r == 0)
			break;

		// Recycle
		c = d;
		d = r;

		t = aprime;
		aprime = a;
		a = t - q * a;

		t = bprime;
		bprime = b;
		b = t - q * b;
	}

	*pg = d;
	*pa = a;
	*pb = b;
}

#include <stdio.h>

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int m = 20, n = 24, g, a, b;
	int check;

	if (argc == 3) {
		m = atoi(argv[1]);
		n = atoi(argv[2]);
	}
	extended_GCD(m, n, &g, &a, &b);
	check = a * m + b * n;

	printf("GCD(%d, %d) = %d.\n", m, n, g);
	printf("%d * %d + %d * %d = %d\n",
		a, m, b, n, check);
	return 0;
}
