// Knuth vol. 2 section 4.5.4 algorithm C
#include <stdio.h>
#include <stdlib.h>
#include "../utils/isqrt.h"

void fermat_split_factors(
	int   N,
	int * pa,
	int * pb)
{
	int sqrtn, x, y, r;

	sqrtn = calc_isqrt_32(N, IFLOOR);

	x = 2 * sqrtn + 1;
	y = 1;
	r = sqrtn * sqrtn - N;

	if (!(N & 1)) {
		fprintf(stderr,
			"fermat_split_factors:  Need odd N; got %d.\n", N);
		exit(1);
	}
	printf("x=%6d   y=%6d   r=%6d\n", x, y, r);

C2:	if (r == 0) {
		*pa = (x - y) / 2;
		*pb = (x + y - 2) / 2;
		return;
	}

	r += x; x += 2;
	printf("\n");
	printf("x=%6d   r=%6d\n", x, r);
C4:	r -= y; y += 2;
	printf("y=%6d   r=%6d\n", y, r);

	if (r > 0)
		goto C4;
	else
		goto C2;
}

int main(int argc, char ** argv)
{
	int N = 377, a, b;

	if (argc >= 2)
		(void)sscanf(argv[1], "%d", &N);
	fermat_split_factors(N, &a, &b);
	printf("\n");
	printf("%d = %d *% d.\n", N, a, b);
	return 0;
}
