#include <stdio.h>
#include <stdlib.h>
#include "../utils/isqrt.h"

#ifndef MYINT
#define MYINT unsigned
#endif

// ================================================================
static int isprime(MYINT m)
{
	MYINT i;
	MYINT top;

	if ((m & 1) == 0)
		return 0;
	top = calc_isqrt_32(m, ICEIL);
	for (i = 3; i <= top; i += 2)
		if ((m % i) == 0)
			return 0;
	return 1;
}

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s [lo] {hi}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	unsigned long long lllo, llhi;
	MYINT lo = 3;
	MYINT hi = 10;
	MYINT m1;
	MYINT m2;

	if (argc == 2) {
		if (sscanf(argv[1], "%llu", &llhi) != 1)
			usage(argv[0]);
		lo = lllo;
	}
	else if (argc == 3) {
		if (sscanf(argv[1], "%llu", &lllo) != 1)
			usage(argv[0]);
		if (sscanf(argv[2], "%llu", &llhi) != 1)
			usage(argv[0]);
		lo = lllo;
		hi = llhi;
	}
	else {
		usage(argv[0]);
	}

	lo |= 1; // Make it even.

	for (m1 = lo, m2 = lo+2; m2 <= hi; m1+=2, m2+=2) {
		if (isprime(m1) && isprime(m2))
			printf("%20llu %20llu\n",
				(unsigned long long)m1,
				(unsigned long long)m2);
	}
	return;
}
