#include <stdio.h>
#include <gcd.h>

// ----------------------------------------------------------------
int get_k_torsion_subgroup_size(int n, int k, int verbosity)
{
	int s = 0;
	int x;
	int xk;

	for (x = 0; x < n; x++) {
		xk = (x * k) % n;
		if (xk == 0) {
			s++;
		}
		if (verbosity) {
			if (xk == 0)
				printf(" %2d", x);
			else
				printf("   ");
		}
	}

	return s;
}

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int n, k, s, g;

	if (argc != 2)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &n) != 1)
		usage(argv[0]);

	for (k = 0; k <= n+n; k++) {
		s = get_k_torsion_subgroup_size(n, k, 0);
		g = calc_gcd(k, n);
		printf("k=%2d s=%2d g=%2d %2s",
			k, s, g, (s == g) ? "OK" : "! ");
		printf(" : ");
		(void)get_k_torsion_subgroup_size(n, k, 1);
		printf("\n");
	}
	return 0;
}
