#include <stdio.h>

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int m, x, d;
	int dinv, minv, check;

	if (argc != 2)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &m) != 1) {
		fprintf(stderr,
			"Couldn't scan \"%s\" as integer; skipping.\n",
			argv[1]);
		exit(1);
	}
//Suppose (x, m) is d.
//Compute inverse in (Z(m/d), *), then multiply by d and take result mod m.

//  1 (  1)   1
//  2 (  2) 496
//  3 skip
//  4 (  2) 248
//  5 (  5) 595
//  6 skip
//  7 (  1) 283
//  8 (  2) 124
//  9 (  9) 441
// 10 ( 10) 100
// 11 ( 11) 451
// 12 skip

// m = 990
// x = 2
// d = 2
// want 1/2 mod 495: get 248
	for (x = 1; x < m; x++) {
		d = calc_gcd(x, m);

		//dinv = calc_inv(x/d, m/d);
		if (calc_gcd(x, m/d) != 1) {
			printf("%3d skip\n", x);
			continue;
		}
		dinv = calc_inv(x, m/d);

		//minv = (dinv * d) % m;
		minv = dinv;
		check = (x * minv) % m;
		printf("%3d (%3d) * %3d = %3d [%3d %3d %3d %3d]\n",
			x, d, minv, check, check % d, check % (m/d),
			x % d, minv % d);
	}
	return 0;
}
