// From Saxena & McCluskey, 2000

// This program prints all primitive polynomials of a given degree.
// The usage is: program_name {degree}

#include <stdio.h>
#define N 32

int i, n, xx, degree;
char d[N];
char s[N], t, j, f;
unsigned long c, max;
int print_all = 0;

// ----------------------------------------------------------------
void see(int is_prim)
{
	for (i = n; i >= 0; i--)
		printf("%c", d[i] + '0');
	if (is_prim)
		printf(" *");
	printf("\n");
}

// ----------------------------------------------------------------
void visit(void)
{
	for (i = 0; i < n; i++)
		s[i] = 1;
	c = 0;
	do {
		c++;
		for (i = t = 0; i < n; i++)
			t = (t ^ (s[i] & d[i]));
		for (i = 0; i < n-1; i++)
			s[i] = s[i+1];
		s[n-1] = t;
		for (i = f = 0; i < n; i++) {
			if (!s[i]) {
				f = 1;
				break;
			}
		}
	} while (f);
	if (print_all || c == max)
		see(c == max);
}

// ----------------------------------------------------------------
void gp(char l)
{
	if (!l) {
		visit();
	}
	else {
		d[l] = 0; gp(l-1);
		d[l] = 1; gp(l-1);
	}
}

// ----------------------------------------------------------------
// rw is the nomiality, e.g. use rw=3 to test trinomials
void gc(char l, char rw)
{
	char q;
	if (rw == 2) {
		visit();
		return;
	}
	for (q = l; q >= rw - 2; q--) {
		d[q] = 1;
		gc(q-1,rw-1);
		d[q] = 0;
	}
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	printf("\n");
	degree = atoi(argv[1]);
	if (argc > 2)
		print_all = 1;
	for (n = degree; n <= degree; n++) {
		printf("degree=%d\n", n);
		for (xx = max = 1; xx <= n; xx++)
			max <<= 1;
		max--;
		d[n] = d[0] = 1;
		gp(n-1); // use gp(n-1) if all primitive polys are desired
		//gc(n-1,5);
		printf("\n");
	}
	return 0;
}
