#include <stdio.h>
#include <stdlib.h>
#include "../utils/isqrt.h"

#define HI_MAX 4000

// ================================================================
static int isprime(unsigned m)
{
	unsigned i;
	unsigned top;

	if (m == 1)
		return 0;
	if (m == 2)
		return 1;
	if ((m & 1) == 0)
		return 0;
	top = calc_isqrt_32(m, ICEIL);
	for (i = 3; i <= top; i += 2)
		if ((m % i) == 0)
			return 0;
	return 1;
}

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {hi}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	unsigned hi = 10;
	unsigned i, j;
	unsigned char prime_flags[HI_MAX];
	unsigned top;

	if (argc == 2) {
		if (sscanf(argv[1], "%u", &hi) != 1)
			usage(argv[0]);
	}
	else {
		usage(argv[0]);
	}
	if (hi > HI_MAX) {
		fprintf(stderr, "hi too big; max %u.\n", HI_MAX);
		exit(1);
	}

	for (j = 2; j < hi; j++) {
		prime_flags[j] = 1;
	}
	prime_flags[0] = 0;
	prime_flags[1] = 0;

	printf("     ");
	for (j = 0; j < hi;  j++) {
		if (j < 100)
			printf(" ");
		else
			printf("%u", (j / 100) % 10);
	}
	printf("\n");
	printf("     ");
	for (j = 0; j < hi;  j++) {
		if (j < 10)
			printf(" ");
		else
		printf("%u", (j / 10) % 10);
	}
	printf("\n");
	printf("     ");
	for (j = 0; j < hi;  j++)
		printf("%u", j % 10);
	printf("\n");

	//top = hi;
	top = calc_isqrt_32(hi, ICEIL);
	for (i = 1; i < top;  i++) {
		if (!isprime(i))
			continue;
		printf("%3u: ", i);
		for (j = i+i; j < hi;  j+=i) {
			prime_flags[j] = 0;
		}

//		for (j = 0; j < hi;  j++) {
//			if ((j%i) == 0)
//				printf("|");
//			else
//				printf(" ");
//			// xxx temp
//		}
//		printf("\n"); // xxx temp

		for (j = 0; j < hi;  j++) {
			//printf("%c", prime_flags[j] ? 'p' : '.');
			//printf("%c", prime_flags[j] ? '@' : ' ');
			printf("%c", prime_flags[j] ? ' ' : 'c');
		}
		printf("\n");
	}

//	printf("     ");
//	for (j = 0; j < hi;  j++) {
//		//printf("%c", prime_flags[j] ? 'p' : '.');
//		printf("%c", prime_flags[j] ? '@' : ' ');
//	}
//	printf("\n");

	return;
}
