// For which m is 2 a quadratic residue mod m?

#include <stdio.h>
#include "isprime.h"

// ----------------------------------------------------------------
int is_two_qr_mod_m(
	int   m,
	int * proot)
{
	int i;
	for (i = 1; i < m; i++) {
		if (((i*i) % m) == 2) {
			*proot = i;
			return 1;
		}
	}
	return 0;
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int lo = 2;
	int hi = 400;
	int m;
	int root;

	if (argc == 2) {
		(void)sscanf(argv[1], "%d", &hi);
	}

	if (argc == 3) {
		(void)sscanf(argv[1], "%d", &lo);
		(void)sscanf(argv[2], "%d", &hi);
	}

	for (m = lo; m <= hi; m++) {

		// xxx temp
		if (!isprime(m))
			continue;

		if (is_two_qr_mod_m(m, &root)) {
			printf(
			"[%3d] 2 is     quadratic mod %3d (%3d * %3d = %3d).\n",
				m & 7,
				m, root, root, (root * root) % m);
		}
		else {
			printf("[%3d] 2 is not quadratic mod %3d.\n",
				m & 7,
				m);
		}
	}

	return 0;
}
