#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {key}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int key[2][2];
	int key_inv[2][2];
	int check[2][2];
	int i;
	int det;
	int det_inv;

	if (argc != 2)
		usage(argv[0]);
	if (strlen(argv[1]) != 4)
		usage(argv[0]);
	key[0][0] = toupper(argv[1][0]); key[0][1] = toupper(argv[1][1]);
	key[1][0] = toupper(argv[1][2]); key[1][1] = toupper(argv[1][3]);

	key[0][0] -= 'A';
	key[0][1] -= 'A';
	key[1][0] -= 'A';
	key[1][1] -= 'A';

	det = (int)key[0][0] * (int)key[1][1] - (int)key[1][0] * (int)key[0][1];
	det %= 26;
	if (det < 0)
		det += 26;

	if ((det % 2) == 0) {
		fprintf(stderr, "Determinant (%d) is even.\n", det);
		exit(1);
	}
	if ((det % 13) == 0) {
		fprintf(stderr, "13 divides determinant (%d).\n", det);
		exit(1);
	}

	det_inv = 1;
	// phi(26) = 12
	for (i = 0; i < 11; i++) {
		det_inv *= det;
		det_inv %= 26;
	}

	key_inv[0][0]  = key[1][1];

	key_inv[0][1]  = 26 - key[0][1];
	key_inv[0][1] %= 26;

	key_inv[1][0]  = 26 - key[1][0];
	key_inv[1][0] %= 26;

	key_inv[1][1]  = key[0][0];

	key_inv[0][0] *= det_inv;
	key_inv[0][1] *= det_inv;
	key_inv[1][0] *= det_inv;
	key_inv[1][1] *= det_inv;

	key_inv[0][0] %= 26;
	key_inv[0][1] %= 26;
	key_inv[1][0] %= 26;
	key_inv[1][1] %= 26;

	check[0][0] = (key[0][0] * key_inv[0][0]) + (key[0][1] * key_inv[1][0]);
	check[0][1] = (key[0][0] * key_inv[0][1]) + (key[0][1] * key_inv[1][1]);
	check[1][0] = (key[1][0] * key_inv[0][0]) + (key[1][1] * key_inv[1][0]);
	check[1][1] = (key[1][0] * key_inv[0][1]) + (key[1][1] * key_inv[1][1]);

	check[0][0] %= 26;
	check[0][1] %= 26;
	check[1][0] %= 26;
	check[1][1] %= 26;


	key[0][0] += 'A';
	key[0][1] += 'A';
	key[1][0] += 'A';
	key[1][1] += 'A';

	key_inv[0][0] += 'A';
	key_inv[0][1] += 'A';
	key_inv[1][0] += 'A';
	key_inv[1][1] += 'A';

	check[0][0] += 'A';
	check[0][1] += 'A';
	check[1][0] += 'A';
	check[1][1] += 'A';

	printf("%c%c\n", key[0][0], key[0][1]);
	printf("%c%c\n", key[1][0], key[1][1]);
	printf("\n");
	printf("%c%c\n", key_inv[0][0], key_inv[0][1]);
	printf("%c%c\n", key_inv[1][0], key_inv[1][1]);
	printf("\n");
	printf("%c%c\n", check[0][0], check[0][1]);
	printf("%c%c\n", check[1][0], check[1][1]);
	printf("\n");

	printf("det     = %d\n", det);
	printf("det inv = %d\n", det_inv);
	printf("check   = %d\n", (det * det_inv) % 26);


	return 0;
}
