#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <string.h>
#include "zlinalg.h"

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int n = 2;
	int ** a = zla_alloc_matrix(n, n);
	int ** b = zla_alloc_matrix(n, n);
	int ** c = zla_alloc_matrix(n, n);
	int ** k = zla_alloc_matrix(n, n);
	int rep, reps = 1000000;
	int i, j;

	if (argc == 2)
		(void)sscanf(argv[1], "%d", &reps);

	k[0][0] = 1; k[0][1] = 2;
	k[1][0] = 0; k[1][1] = 1;

	srandom(time(0) ^ getpid());
	for (rep = 0; rep < reps; rep++) {
		for (i = 0; i < n; i++) {
			for (j = 0; j < n; j++) {
				a[i][j] = (((unsigned)random()) % 7) - 3;
				b[i][j] = (((unsigned)random()) % 7) - 3;
			}
		}
		zla_mats_mul(c, a, b, n);

		if (zla_equals(c, k, n)) {
			printf("\n");
			printf("a:\n");
			zla_print_matrix(a, n, n);
			printf("b:\n");
			zla_print_matrix(b, n, n);
			printf("c:\n");
			zla_print_matrix(c, n, n);
		}

	}

	zla_free_matrix(a, n, n);
	zla_free_matrix(b, n, n);
	zla_free_matrix(c, n, n);

	return 0;
}
