#include <stdio.h>
#include <stdlib.h>
#include "zppoly_factor.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t Pe;
	int p, n, i;

	if (argc != 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);
	if (sscanf(argv[2], "%d", &n) != 1)
		usage(argv[0]);
	if (n > ZPOLY_MAX_DEGREE) {
		fprintf(stderr, "%s: max n is %d; got %d.\n",
			argv[0], ZPOLY_MAX_DEGREE, n);
		exit(1);
	}
	Pe.degree = n - 1;
	for (i = 0; i < n; i++)
		Pe.coeffs[i] = 1;
	zppoly_print(&Pe, p);
	printf("\n");

	return 0;
}
