#include <stdio.h>
#include <stdlib.h>
#include "z2poly_factor.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2poly_t Pe;
	int n, i;

	if (argc != 2)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &n) != 1)
		usage(argv[0]);
	if (n > Z2POLY_NUM_BITS) {
		fprintf(stderr, "%s: max n is %d; got %d.\n",
			argv[0], Z2POLY_NUM_BITS, n);
		exit(1);
	}
	Pe = z2poly_from_base_rep(0);
	for (i = 0; i < n; i++)
		z2poly_set_bit(&Pe, i);

	z2poly_print(&Pe);
	printf("\n");

	return 0;
}
