#include <stdio.h>
#include <stdlib.h>
#include "zppoly.h"
#include "power.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t Up;
	int p, n, pn, i;

	if (argc != 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);
	if (sscanf(argv[2], "%d", &n) != 1)
		usage(argv[0]);
	pn = calc_power(p, n);
	if (pn > ZPOLY_MAX_DEGREE) {
		fprintf(stderr, "%s: max p^n is %d; got %d.\n",
			argv[0], ZPOLY_MAX_DEGREE, pn);
		exit(1);
	}
	Up.degree = pn;
	for (i = 0; i <= pn; i++)
		Up.coeffs[i] = 0;
	Up.coeffs[pn] = 1;
	Up.coeffs[1]  = p - 1;
	zppoly_print(&Up, p);
	printf("\n");

	return 0;
}
