#include <stdio.h>
#include <stdlib.h>
#include "z2poly_factor.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2poly_t Up;
	int n, pn;

	if (argc != 2)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &n) != 1)
		usage(argv[0]);
	pn = 1 << n;
	if (pn > Z2POLY_NUM_BITS) {
		fprintf(stderr, "%s: max 2^n is %d; got %d.\n",
			argv[0], Z2POLY_NUM_BITS, pn);
		exit(1);
	}
	Up = z2poly_from_base_rep(0);
	z2poly_set_bit(&Up, pn);
	z2poly_set_bit(&Up, 1);
	z2poly_print(&Up);
	printf("\n");

	return 0;
}
