#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"
#include "isprime.h"

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t z, ztop = 0x1000;
	int irr, prime;
	int nmatch = 0, ndiff = 0;
	z2ipoly_t id, pd;

	if (argc == 2)
		(void)sscanf(argv[1], "%llx", &ztop);

	for (z = 2LL; z < ztop; z++) {
		irr   = z2ipoly_is_irreducible(z);
		prime = isprime((int)z);

		for (id = 2; id <= z; id++)
			if ((z % id) == 0LL)
				break;
		for (pd = 2; pd <= z; pd++)
			if (z2ipoly_mod(z, pd) == 0LL)
				break;

		if (irr ^ prime)
			ndiff++;
		else
			nmatch++;

		//printf("%08llx: i:%08llx p:%08llx %c%c%s\n",
		//	z, id, pd,
		//	irr   ? 'i' : '-',
		//	prime ? 'p' : '-',
		//	irr ^ prime ? " DIFF" : "");

		printf("%08llx:", z);
		printf(" i:");
		if (prime)
			printf("--------");
		else
			printf("%08llx", id);
		printf(" p:");
		if (irr)
			printf("--------");
		else
			printf("%08llx", pd);
		printf(" %c%c %s",
			irr   ? 'i' : '-',
			prime ? 'p' : '-',
			irr ^ prime ? "DIFF" : "    ");

		if (!irr && !prime) {
			printf(" sub %08llx  xor %08llx",
				pd > id ? pd - id : id - pd,
				pd ^ id);
		}
		printf("\n");
	}
	printf("# match %d  # diff %d\n", nmatch, ndiff);
	return 0;
}
