#include <stdio.h>
#include <stdlib.h>
#include "isprime.h"
#include "mod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {max}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int max = 20;
	int p, g;
	int verbose = 0;
	int gen_count;

	if ((argc != 2) && (argc != 3))
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &max) != 1)
		usage(argv[0]);
	if (argc == 3)
		verbose = 1;

	for (g = 2; g < max; g++) {

		gen_count = 0;

		printf("%4d: ", g);
		for (p = g+1; p < max; p++) {
			if (!isprime(p))
				continue;
			if (mod_mul_order(g, p) == (p - 1)) {
				gen_count++;
				if (verbose)
					printf(" [%d]", p);
			}
		}
		printf("%4d\n", gen_count);
	}

	return 0;
}
