
\\ Print a polynomial in F_p[x] using compact notation.
cpr1(f)=
{
	local(d, i);
	d = poldegree(f);
	forstep (i=d,0,-1,
		print1(lift(polcoeff(f,i)));
		);
}

cpr(f)=
{
	cpr1(f);
	print();
}

cprc(f)=
{
	local(d, i);
	d = poldegree(f);
	forstep (i=d,0,-1,
		if (i < d, print1(","));
		print1(lift(polcoeff(f,i)));
		);
	print();
}

\\ Print a vector of polynomials in F_p[x] using compact notation.
cprv(vf)=
{
	local(i, n);
	n = length(vf);
	for (i=1, n, cpr(vf[i]));
}

\\ Print the output of GP's factor() using compact notation.
cprv1(vf)=
{
	local(i, n);
	n = length(vf[,1]);
	for (i=1, n, cpr(vf[i,1]));
}

\\ Print the output of GP's factor() using compact notation.
cpr1v1(vf)=
{
	local(i, n);
	n = length(vf[,1]);
	for (i=1, n, print1(" "); cpr1(vf[i,1]);
		if (vf[i,2] > 1, print1("^", vf[i,2])));
}
