#include <stdio.h>
#include <stdlib.h>
#include "zppolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t z, d, g, s;
	int p, argi;

	if (argc < 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);

	for (argi = 2; argi < argc; argi++) {
		if (!zppoly_scan(&z, argv[argi], p))
			usage(argv[0]);
		d = zppoly_deriv(&z, p);
		if (zppoly_is_zero(&d))
			// xxx fix me for input = 0?
			g = z;
		else
			g = zppoly_gcd(&z, &d, p);

		printf("z="); zppoly_print(&z, p);
		printf(" d="); zppoly_print(&d, p);
		printf(" g="); zppoly_print(&g, p);
		printf(" ");

		if (zppoly_is_zero(&g)) {
			printf("input is zero?");
		}
		else if (zppoly_is_one(&g)) {
			printf("input is squarefree?");
		}
		else {
			if (zppoly_is_zero(&d)) {
				printf("input is a perfect pth power: ");
				s = zppoly_pth_root(&z, p);
				zppoly_print(&s, p);
			}
			else if (zppoly_equal(&g, &z, p))
				printf("trouble?");
			else
				printf("whew!");
		}
		printf("\n");
	}

	return 0;
}
