#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t a, d, g, s;
	int argi;

	if (argc < 2)
		usage(argv[0]);

	for (argi = 1; argi < argc; argi++) {
		if (!z2ipoly_scan(&a, argv[argi]))
			usage(argv[0]);
		d = z2ipoly_deriv(a);
		g = z2ipoly_gcd(a, d);
		printf("z=%04llx d=%04llx g=%04llx ", a, d, g);
		if (g == 0) {
			printf("input is zero?");
		}
		else if (g == 1) {
			printf("input is squarefree?");
		}
		else {
			if (d == 0) {
				printf("input is a perfect square: ");
				s = z2ipoly_square_root(a);
				printf("s=%04llx ", s);
			}
			else if (g == a)
				printf("trouble?");
			else
				printf("whew!");
		}
		printf("\n");
	}

	return 0;
}
