#include <stdio.h>
#include <stdlib.h>
#include "z2ipoly_factor.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t r;
	unsigned argi, i, nd;
	z2ipoly_t * all_divisors;

	if (argc < 2)
		usage(argv[0]);

	for (argi = 1; argi < argc; argi++) {
		if (!z2ipoly_scan(&r, argv[argi]))
			usage(argv[0]);
		all_divisors = z2ipoly_get_all_divisors(r, &nd);
		for (i = 0; i < nd; i++) {
			if (i > 0)
				printf(" ");
			z2ipoly_print(all_divisors[i]);
		}
		printf("\n");
		free(all_divisors);
	}

	return 0;
}
