#include <stdio.h>
#include <stdlib.h>
#include "factorize.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {numbers ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	unsigned argi, i, nd;
	unsigned long long n;
	unsigned long long * all_divisors;

	if (argc < 2)
		usage(argv[0]);

	for (argi = 1; argi < argc; argi++) {
		if (sscanf(argv[argi], "%llu", &n) != 1)
			usage(argv[0]);
		all_divisors = get_all_divisors_ull(n, &nd);
		for (i = 0; i < nd; i++) {
			if (i > 0)
				printf(" ");
			printf("%llu", all_divisors[i]);
		}
		printf("\n");
		free(all_divisors);
	}

	return 0;
}
