#include <stdio.h>
#include <stdlib.h>
#include "zppoly_factor.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t r;
	int p;
	unsigned argi, i, nd;
	zpoly_t * all_divisors;

	if (argc < 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);

	for (argi = 2; argi < argc; argi++) {
		if (!zppoly_scan(&r, argv[argi], p))
			usage(argv[0]);
		all_divisors = zppoly_get_all_divisors(&r, p, &nd);
		for (i = 0; i < nd; i++) {
			if (i > 0)
				printf(" ");
			zppoly_print(&all_divisors[i], p);
		}
		printf("\n");
		free(all_divisors);
	}

	return 0;
}
