#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2ipolymod.h"
#include "z2nipoly_factor.h"
#include "power.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s [-c] {r ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
static void show_iterated_map(
	z2ipoly_t r,
	int show_log)
{
	z2ipoly_t * fes;
	int n, nel, i, j;
	z2ipoly_t g = z2ipolymod_find_generator(r);

	fes = z2ipolymod_get_elements_frobord(r, &nel);
	n = z2ipoly_get_degree(r);
	printf("%llx", r);
	if (show_log)
		printf(" %llx", g);
	printf("\n");
	for (i = 0; i <= n+n; i++) {
		for (j = 0; j < nel; j++) {
			if (show_log)
				printf("%d", z2ipolymod_log(fes[j], g, r));
			else
				z2ipoly_print(fes[j]);
			if (j == (nel - 1))
				printf("\n");
			else
				printf(" ");
		}
		for (j = 0; j < nel; j++) {
			fes[j] = z2ipolymod_compose(r, fes[j], r);
		}
	}
	free(fes);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t r;
	int argb, argi, show_log;

	if ((argc >= 2) && (strcmp(argv[1], "-l") == 0)) {
		show_log = 1;
		argb = 2;
	}
	else {
		show_log = 0;
		argb = 1;
	}
	if (argc <= argb)
		usage(argv[0]);

	for (argi = argb; argi < argc; argi++) {
		if (!z2ipoly_scan(&r, argv[argi]))
			usage(argv[0]);
		show_iterated_map(r, show_log);
		if (argi < (argc - 1))
			printf("\n");
	}

	return 0;
}
