#include <stdio.h>
#include <stdlib.h>
#include "z2ipoly.h"
#include "isprime.h"

// ----------------------------------------------------------------
void try_one(int argc, char ** argv)
{
	int argi;
	z2ipoly_t r;

	if (argc < 2) {
		fprintf(stderr, "Usage: %s {Z2 polys in hex ...}\n", argv[0]);
		exit(1);
	}

	for (argi = 1; argi < argc; argi++) {

		printf("--------------------------------"
			"--------------------------------\n");

		if (sscanf(argv[argi], "%lld", &r) != 1) {
			fprintf(stderr, "Scan failure on \"%s\".\n",
				argv[argi]);
			continue;
		}

		printf("%08llx: ", r);

		if (z2ipoly_is_irreducible(r))
			printf("IRRED\n");
		else
			printf("reducible.\n");
	}

	printf("--------------------------------"
		"--------------------------------\n");
}

// ----------------------------------------------------------------
void search(int argc, char ** argv)
{
	int x;
	z2ipoly_t z;
	int lo = 3;
	int hi = 100;

	if (argc == 1) {
		;
	}
	else if (argc == 2) {
		if (sscanf(argv[1], "%d", &hi) != 1) {
			fprintf(stderr, "Scan failure on \"%s\".\n",
				argv[1]);
			exit(1);
		}
	}
	else if (argc == 3) {
		if (sscanf(argv[1], "%d", &lo) != 1) {
			fprintf(stderr, "Scan failure on \"%s\".\n",
				argv[1]);
			exit(1);
		}
		if (sscanf(argv[2], "%d", &hi) != 1) {
			fprintf(stderr, "Scan failure on \"%s\".\n",
				argv[2]);
			exit(1);
		}
	}
	else {
		fprintf(stderr, "Usage: %s [[lo] hi]\n", argv[0]);
		exit(1);
	}

	for (x = lo; x <= hi; x++) {
		z = (z2ipoly_t) x;
		printf("%8d %12s   %08llx  %s\n",
			x,
			isprime(x) ? "prime" : "composite",
			z,
			z2ipoly_is_irreducible(x) ? "prime" : "composite");
	}
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	//try_one(argc, argv);
	search(argc, argv);

	return 0;
}
