#include <stdio.h>
#include <stdlib.h>
#include "factorize.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {integers ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi;
	unsigned long long n;
	factor_info_ull_t finfo;
	char * fmt;
	int i;

	if (argc < 2)
		usage(argv[0]);
	for (argi = 1; argi < argc; argi++) {

		// xxx ux scan from X:\lib.
		fmt = "%llu";
		if (argv[argi][0] == '0')
			if (argv[argi][1] == 'x')
				fmt = "%llx";
		if (!sscanf(argv[argi], fmt, &n)) {
			fprintf(stderr, "Scan failure on \"%s\".\n",
				argv[argi]);
			continue;
		}

		printf("%llu: ", n);
		fflush(stdout);
		calc_factors_ull(n, &finfo);

		if (finfo.num_distinct == 0) {
			printf("(none)\n");
		}
		else {
			for (i = 0; i < finfo.num_distinct; i++) {
				printf(" %llu", finfo.factors[i].p);
				if (finfo.factors[i].count > 1)
					printf("^%u", finfo.factors[i].count);
			}
		}
		printf("\n");
	}

	return 0;
}
