// Algorithm from Seroul.

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gint.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {re,im}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
static int least_divisor(int n)
{
	int d, q;

	if ((n & 1) == 0)
		return 2;

	d = 3;
	do {
		q = n / d;
		if (n == q * d) {
			return d;
		}
		d += 2;
	} while (d <= q);
	return n; // n is prime
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi;
	gint_t g, d;
	int N, p;

	if (argc < 2)
		usage(argv[0]);

	for (argi = 1; argi < argc; argi++) {

		// xxx make a vscan, vprint.
		if (sscanf(argv[argi], "%d,%d", &g.re, &g.im) != 2) {
			g.im = 0;
			if (sscanf(argv[argi], "%d", &g.re) != 1) {
				fprintf(stderr,
					"Couldn't parse \"%s\"; skipping.\n",
					argv[argi]);
				continue;
			}
		}

		N = gint_norm(g);
		while (N > 1) {
			p = least_divisor(N);
			printf("stub!\n");
			exit(1);
			//d = irr div of g with shadow p
			d.re = 1;
			d.im = 0;
			g = gint_quot(g, d);
			N = gint_norm(g);
		}

		printf("%3d,%3d\n",
			g.re, g.im);
	}

	return 0;
}
