#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gint.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {re,im}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi;
	gint_t g;
	gint_t a, q, r;
	int nf;
	int N;

	if (argc < 2)
		usage(argv[0]);

	for (argi = 1; argi < argc; argi++) {
		// xxx make a vscan, vprint.
		if (sscanf(argv[argi], "%d,%d", &g.re, &g.im) != 2) {
			g.im = 0;
			if (sscanf(argv[argi], "%d", &g.re) != 1) {
				fprintf(stderr,
					"Couldn't parse \"%s\"; skipping.\n",
					argv[argi]);
				continue;
			}
		}

		N = gint_norm(g);
		nf = 0;

		for (a.re =  0; a.re <= N; a.re++) {
		for (a.im = -a.re; a.im <= a.re; a.im++) {

			if (gint_is_unit(a))
				continue;
			if (gint_is_zero(a))
				continue;

			gint_quot_and_rem(g, a, &q, &r);

			if (!gint_is_zero(r))
				continue;
			if (gint_is_unit(q))
				continue;

			nf++;
			printf("%3d,%3d * %3d,%3d = %3d,%3d\n",
				a.re, a.im,
				q.re, q.im,
				g.re, g.im);
		}
		}

		if (nf == 0)
			printf("%3d, %3d is prime\n", g.re, g.im);
	}

	return 0;
}
