#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2ipolymod.h"
#include "isprime.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int n;
	z2ipoly_t ri, rj, rlo, rhi;

	if (argc != 2)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &n) != 1)
		usage(argv[0]);

	rlo = 1LL << n;
	rhi = (rlo << 1) - 1;

	for (ri = rlo; ri <= rhi; ri++) {
		rj = z2ipoly_compose(ri, 3LL);
		if (rj > ri) {
			printf("%c%llx %c%llx\n",
				z2ipoly_is_irreducible(ri) ?
					z2ipoly_is_primitive(ri) ? 'p' : 'i'
					: '-',
				ri,
				z2ipoly_is_irreducible(rj) ?
					z2ipoly_is_primitive(rj) ? 'p' : 'i'
					: '-',
				rj);
		}
		else if (rj == ri) {
			printf("%c%llx\n",
				z2ipoly_is_irreducible(ri) ?
					z2ipoly_is_primitive(ri) ? 'p' : 'i'
					: '-',
					ri);
		}
	}

	return 0;
}
