#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "zppolymod.h"
#include "power.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {n ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t ri, rj, xc;
	int iri, irlo, irhi;
	int argi, p, n;

	if (argc < 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);


	for (argi = 2; argi < argc; argi++) {
		if (sscanf(argv[argi], "%d", &n) != 1)
			usage(argv[0]);

		irlo = calc_power(p, n);
		irhi = 2 * irlo - 1;

		for (iri = irlo; iri <= irhi; iri++) {
			ri = zppoly_from_base_rep(p, iri);
			xc = zppoly_from_coeffs1(1, -1, p);
			rj = zppoly_compose(&ri, &xc, p);
			if (zppoly_equal(&ri, &rj, p)) {
				zppoly_print(&ri, p);
				printf("\n");
			}
		}
	}

	return 0;
}
