#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2ipolymod.h"
#include "power.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {n ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t ri, rj;
	z2ipoly_t rlo, rhi;
	int argi, n;

	if (argc < 2)
		usage(argv[0]);

	for (argi = 1; argi < argc; argi++) {
		if (sscanf(argv[argi], "%d", &n) != 1)
			usage(argv[0]);

		rlo = 1LL << n;
		rhi = rlo + rlo - 1;

		for (ri = rlo; ri <= rhi; ri++) {
			rj = z2ipoly_compose(ri, 3LL);
			if (ri == rj) {
				z2ipoly_print(ri);
				printf("\n");
			}
		}
	}

	return 0;
}
