#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "isprime.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {numbers ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi, p;

	if (argc < 2)
		usage(argv[0]);
	for (argi = 1; argi < argc; argi++) {
		if (sscanf(argv[argi], "%d", &p) != 1)
			usage(argv[0]);
		if (argc > 2)
			printf("%d: ", p);
		if (isprime(p))
			printf("prime\n");
		else
			printf("composite\n");
	}

	return 0;
}

// ----------------------------------------------------------------
void my_list_primes(int lo, int hi, int verbose, int per_line)
{
	int i;
	int nfound = 0;
	int ntried = 0;
	int prime;

	for (i = lo; i <= hi; i++) {
		ntried++;
		prime = isprime(i);
		if (prime)
			nfound++;
		if (verbose == 2) {
			if (((i-lo) % per_line) == 0)
				printf("\n");
			printf("%c", prime ? '*' : '-');
			fflush(stdout);
		}
		else if (verbose == 1) {
			printf("%6d", i);
			if (prime)
				printf(" *");
			printf("\n");
		}
		else {
			if (prime) {
				printf("  ");
				printf("%6d", i);
				printf("\n");
			}
		}
	}
	if (verbose == 2)
		printf("\n");
	printf("%6d tried; %6d found.\n", ntried, nfound);
}
