#ifndef LEXAN_H
#define LEXAN_H

#include <stdio.h>
#include "symtab.h"
#include "opts.h"
#include "atom.h"

#define BSIZE  128

#define L_NONE      -1
#define L_DONE     257

#define L_NUM      258
#define L_ID       259
#define L_LVALUE   260

#define L_LSH      262
#define L_RSH      263
#define L_POW      264

#define L_UNOT     265
#define L_UPLUS    266
#define L_UMINUS   267

#define L_GCD      270
#define L_CHOOSE   271
#define L_ORD      272

#define L_SQRT     280
#define L_EXP      281
#define L_LOG      282
#define L_SIN      283
#define L_COS      284
#define L_TAN      285
#define L_ATAN     286
#define L_CONJ     287
#define L_MAG      288
#define L_PHZ      289

#define L_DEFER    300

typedef struct _lexctx_t {
	int  lineno;
	int  in_comment;
	int  token;
	int  tokenval;
	char tokenbuf[MAX_ATOM_SIZE];
} lexctx_t;

void lexctx_init(lexctx_t * pl);
void lexan(lexctx_t * pl, symtab_t * pst, FILE * fp, opts_t * popts,
	int in_pow_rhs);

void lexan_desc_token(int tok, FILE * fp);

#endif // LEXAN_H
