#include "lexan.h"
#include "parse.h"
#include "symtab.h"
#include "opts.h"

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	symtab_t   symtab;
	parsectx_t parsectx;
	stack_t    stack;
	opts_t     opts;

	st_init(&symtab);
	st_insert(&symtab, "gcd", L_GCD, 0);
	st_insert(&symtab, "choose", L_CHOOSE, 0);
	st_insert(&symtab, "ch", L_CHOOSE, 0);
	st_insert(&symtab, "hh", L_CHOOSE, 0);
	st_insert(&symtab, "sqrt", L_SQRT, 0);
	st_insert(&symtab, "exp",  L_EXP,  0);
	st_insert(&symtab, "log",  L_LOG,  0);
	st_insert(&symtab, "sin",  L_SIN,  0);
	st_insert(&symtab, "cos",  L_COS,  0);
	st_insert(&symtab, "tan",  L_TAN,  0);
	st_insert(&symtab, "atan", L_ATAN, 0);
	st_insert(&symtab, "conj", L_CONJ, 0);
	st_insert(&symtab, "mag",  L_MAG,  0);
	st_insert(&symtab, "phz",  L_PHZ,  0);
	st_insert(&symtab, "ord",  L_ORD,  0);

	opts_default(&opts);
	if (!opts_override(&opts, argc, argv, &symtab))
		opts_usage(argv[0]);

	lexctx_init(&parsectx.lookahead1);
	lexctx_init(&parsectx.lookahead2);
	parsectx.lookahead2.token = L_DEFER;
	stack_init (&stack);

	parse(&parsectx, &symtab, &stack, stdin,  &opts);

	ops_release(&opts.pops, &opts.pvtopts);

	return 0;
}
