#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "ops.h"
#include "gint.h"

// xxx maybe: a,b vs. a+bi?
//typedef struct _gint_opts_t {
//	char scan_fmt [16];
//	int  hex_in;
//	char print_fmt[16];
//} gint_opts_t;

//// ----------------------------------------------------------------
//void * gint_opt_alloc(void)
//{
//	gint_opts_t * p = (gint_opts_t *)malloc(sizeof(gint_opts_t));
//	if (p == 0) {
//		fprintf(stderr, "malloc(%d) failed.\n", sizeof(gint_opts_t));
//		exit(1);
//	}
//	return p;
//}

//// ----------------------------------------------------------------
//void gint_opt_arg_defaulter(
//	void * pvtopts,
//	void * pvaux)
//{
//	gint_opts_t * pgint_opts = pvtopts;
//
//	strcpy(pgint_opts->scan_fmt,  "%u");
//	pgint_opts->hex_in = 0;
//	strcpy(pgint_opts->print_fmt, "%u");
//	*(unsigned *)pvaux = gintulus;
//}

//// ----------------------------------------------------------------
//int  gint_opt_arg_handler(
//	void  * pvtopts,
//	void  * pvaux,
//	int     argi,
//	int     argc,
//	char ** argv,
//	int   * pnum_args_used)
//{
//	gint_opts_t * pgint_opts = pvtopts;
//	unsigned gintulus;
//
//	if (strcmp(argv[argi], "-ix") == 0) {
//		strcpy(pgint_opts->scan_fmt,  "%x");
//		pgint_opts->hex_in = 1;
//		*pnum_args_used = 1;
//		return 1;
//	}
//	else if (strcmp(argv[argi], "-ox") == 0) {
//		strcpy(pgint_opts->print_fmt, "%08x");
//		*pnum_args_used = 1;
//		return 1;
//	}
//	else if (strcmp(argv[argi], "-x") == 0) {
//		strcpy(pgint_opts->scan_fmt,  "%x");
//		pgint_opts->hex_in = 1;
//		strcpy(pgint_opts->print_fmt, "%08x");
//		*pnum_args_used = 1;
//		return 1;
//	}
//
//	else if (strcmp(argv[argi], "-id") == 0) {
//		strcpy(pgint_opts->scan_fmt,  "%u");
//		pgint_opts->hex_in = 0;
//		*pnum_args_used = 1;
//		return 1;
//	}
//	else if (strcmp(argv[argi], "-od") == 0) {
//		strcpy(pgint_opts->print_fmt, "%u");
//		*pnum_args_used = 1;
//		return 1;
//	}
//	else if (strcmp(argv[argi], "-d") == 0) {
//		strcpy(pgint_opts->scan_fmt,  "%u");
//		strcpy(pgint_opts->print_fmt, "%u");
//		pgint_opts->hex_in = 0;
//		*pnum_args_used = 1;
//		return 1;
//	}
//
//	else if (strcmp(argv[argi], "-m") == 0) {
//		if ((argc - argi) < 2) {
//			fprintf(stderr, "gint:  -m requires an argument.\n");
//			return 0;
//		}
//		if (sscanf(argv[argi+1], "%u", &gintulus) != 1) {
//			fprintf(stderr,
//				"gint:  Couldn't parse \"%s\" as integer.\n",
//				argv[argi+1]);
//			return 0;
//		}
//		*(unsigned *)pvaux = gintulus;
//		*pnum_args_used = 2;
//		return 1;
//	}
//
//	return 0;
//}

// ----------------------------------------------------------------
static int gint_lex_first(int c, void * pvtopts, int in_pow_rhs)
{
	if (isdigit(c))
		return 1;
	return 0;
}

// ----------------------------------------------------------------
static int gint_vscan(
	FILE * fp,
	void * patom,
	void * pvtopts,
	void * pvaux,
	int    in_pow_rhs)
{
	// xxx temp hack

	// data_types directory stuff does string scan.
	// kalk does file scan.
	gint_t * pg = patom;
	return fscanf(fp, "%d,%d", &pg->re, &pg->im);
}

// ----------------------------------------------------------------
static void gint_vprint(FILE * fp, void * patom, void * pvtopts,
	void * pvaux)
{
	// xxx temp hack

	// data_types directory stuff does print to stdout.
	// kalk does print to specified fp.

	gint_t * pg = patom;
	fprintf(fp, "%d,%d", pg->re, pg->im);
}

// ----------------------------------------------------------------
static void gint_vadd(
	void * pvout,
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	gint_t a = *(gint_t *)pvin1;
	gint_t b = *(gint_t *)pvin2;
	gint_t c = gint_add(a, b);
	*(gint_t *)pvout = c;
}

// ----------------------------------------------------------------
static void gint_vsub(
	void * pvout,
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	gint_t a = *(gint_t *)pvin1;
	gint_t b = *(gint_t *)pvin2;
	gint_t c = gint_sub(a, b);
	*(gint_t *)pvout = c;
}

// ----------------------------------------------------------------
static void gint_vmul(
	void * pvout,
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	gint_t a = *(gint_t *)pvin1;
	gint_t b = *(gint_t *)pvin2;
	gint_t c = gint_mul(a, b);
	*(gint_t *)pvout = c;
}

// ----------------------------------------------------------------
static void gint_vdiv(
	void * pvout,
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	gint_t a = *(gint_t *)pvin1;
	gint_t b = *(gint_t *)pvin2;
	gint_t c = gint_quot(a, b);
	*(gint_t *)pvout = c;
}

// ----------------------------------------------------------------
static void gint_vmod(
	void * pvout,
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	gint_t a = *(gint_t *)pvin1;
	gint_t b = *(gint_t *)pvin2;
	gint_t c = gint_rem(a, b);
	*(gint_t *)pvout = c;
}

//// ----------------------------------------------------------------
//static void gint_vpower(
//	void * pvout,
//	void * pvin1,
//	void * pvin2,
//	void * pvaux)
//{
//	unsigned a, b, c;
//	unsigned gintulus = *(unsigned *)pvaux;
//	unsigned i, p2;
//	memcpy(&a, pvin1, sizeof(a));
//	memcpy(&b, pvin2, sizeof(a));
//
//	a %= gintulus;
//	// Don't rectify the exponent.  Madness lies that way. :)
//	// Really, e.g. gint 11, we want 2 ** 13 to be 8.
//	// *Really*, this program needs to have heterogeneous data types,
//	// or at least have the possibility of the exponent being int
//	// and the base being of gintular type.
//
//	c  = 1;
//	p2 = a;
//
//	for (i = 0; i < 32; i++) {
//		if (b & 1) {
//			c = (c * p2) % gintulus;
//		}
//		b >>= 1;
//		p2 = (p2 * p2) % gintulus;
//	}
//
//	memcpy(pvout, &c, sizeof(a));
//}

// ----------------------------------------------------------------
static void gint_vuadd (
	void * pvout,
	void * pvin,
	void * pvaux)
{
	*(gint_t *)pvout = *(gint_t *)pvin;
}

// ----------------------------------------------------------------
static void gint_vusub (
	void * pvout,
	void * pvin,
	void * pvaux)
{
	gint_t a = *(gint_t *)pvin;
	gint_t c;

	c.re = -a.re;
	c.im = -a.im;

	*(gint_t *)pvout = c;
}

// ================================================================
ops_t gint_ops = {
	atom_desc          : "gint",
	plex_first_func    : gint_lex_first,
	pscan_func         : gint_vscan,
	pprint_func        : gint_vprint,
	padd_op            : gint_vadd,
	psub_op            : gint_vsub,
	pmul_op            : gint_vmul,
	pdiv_op            : gint_vdiv,
	pmod_op            : gint_vmod,
//	ppow_op            : gint_vpower,
	puadd_op           : gint_vuadd,
	pusub_op           : gint_vusub,
//	ptopt_alloc        : gint_opt_alloc,
//	parg_defaulter     : gint_opt_arg_defaulter,
//	parg_handler       : gint_opt_arg_handler,
	atom_size_in_bytes : sizeof(gint_t),
	aux_size_in_bytes  : sizeof(int)
};
