#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "opts.h"
#include "ops.h"
#include "emit.h"

#define DEFAULT_REQ_SEMI 0

// ----------------------------------------------------------------
void opts_default(opts_t * popts)
{
	popts->req_semi = DEFAULT_REQ_SEMI;
	ops_default(&popts->pops, &popts->pvtopts, popts->aux_buf);
}

// ----------------------------------------------------------------
int opts_override(opts_t * popts, int argc, char ** argv,
	symtab_t * pst)
{
	int argi;
	int num_args_used;

	for (argi = 1; argi < argc; /* increment in loop */) {
		if (strcmp(argv[argi], "-h") == 0)
			return 0;
		else if (strcmp(argv[argi], "--help") == 0)
			return 0;

		else if (strcmp(argv[argi], "-t") == 0) {
			if (!ops_set(&popts->pops, &popts->pvtopts,
			argv[argi+1], pst, popts->aux_buf)) {
				fprintf(stderr,
				"Couldn't find data type \"%s\".\n",
					argv[argi+1]);
				return 0;
			}
			argi += 2;
		}

		else if (strcmp(argv[argi], "-M") == 0) {
			popts->req_semi = 1;
			argi++;
		}

		else if (strcmp(argv[argi], "-P") == 0) {
			emit_set_print(1);
			argi++;
		}


		// Type-specific options.
		else if (popts->pops->parg_handler) {
			if (!popts->pops->parg_handler(popts->pvtopts,
				popts->aux_buf, argi, argc, argv,
				&num_args_used))
			{
				return 0;
			}
			else {
				argi += num_args_used;
			}
		}

		else {
			fprintf(stderr, "%s: Unrecognized option \"%s\".\n",
				argv[0], argv[argi]);
			return 0;
		}
	}

	return 1;
}

// ----------------------------------------------------------------
void opts_usage(char * argv0)
{
	fprintf(stderr, "Usage: %s [options ...]\n", argv0);
	fprintf(stderr, "Options:\n");
	fprintf(stderr, "-M:   Require semicolon terminator.\n");
	exit(1);
}
