#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "ops.h"
#include "z2ipoly.h"

// ----------------------------------------------------------------
static int z2ipoly_lex_first(int c, void * pvtopts, int in_pow_rhs)
{
	if (isxdigit(c))
		return 1;
	return 0;
}

// ----------------------------------------------------------------
static int z2ipoly_vscan(
	FILE * fp,
	void * patom,
	void * pvtopts,
	void * pvaux,
	int    in_pow_rhs)
{
	// xxx temp hack

	// data_types directory stuff does string scan.
	// kalk does file scan.
	z2ipoly_t * pg = patom;
	if (in_pow_rhs)
		return fscanf(fp, "%lld", pg);
	else
		return fscanf(fp, "%llx", pg);
}

// ----------------------------------------------------------------
static void z2ipoly_vprint(FILE * fp, void * patom, void * pvtopts,
	void * pvaux)
{
	// xxx temp hack

	// data_types directory stuff does print to stdout.
	// kalk does print to specified fp.

	z2ipoly_t a = *(z2ipoly_t *)patom;
	z2ipoly_print(a);
}

// ----------------------------------------------------------------
static void z2ipoly_vadd(
	void * pvout,
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	z2ipoly_t a = *(z2ipoly_t *)pvin1;
	z2ipoly_t b = *(z2ipoly_t *)pvin2;
	z2ipoly_t c = z2ipoly_add(a, b);
	*(z2ipoly_t *)pvout = c;
}

// ----------------------------------------------------------------
static void z2ipoly_vsub(
	void * pvout,
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	z2ipoly_t a = *(z2ipoly_t *)pvin1;
	z2ipoly_t b = *(z2ipoly_t *)pvin2;
	z2ipoly_t c = z2ipoly_sub(a, b);
	*(z2ipoly_t *)pvout = c;
}

// ----------------------------------------------------------------
static void z2ipoly_vmul(
	void * pvout,
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	z2ipoly_t a = *(z2ipoly_t *)pvin1;
	z2ipoly_t b = *(z2ipoly_t *)pvin2;
	z2ipoly_t c = z2ipoly_mul(a, b);
	*(z2ipoly_t *)pvout = c;
}

// ----------------------------------------------------------------
static void z2ipoly_vdiv(
	void * pvout,
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	z2ipoly_t a = *(z2ipoly_t *)pvin1;
	z2ipoly_t b = *(z2ipoly_t *)pvin2;
	z2ipoly_t c = z2ipoly_div(a, b);
	*(z2ipoly_t *)pvout = c;
}

// ----------------------------------------------------------------
static void z2ipoly_vmod(
	void * pvout,
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	z2ipoly_t a = *(z2ipoly_t *)pvin1;
	z2ipoly_t b = *(z2ipoly_t *)pvin2;
	z2ipoly_t c = z2ipoly_mod(a, b);
	*(z2ipoly_t *)pvout = c;
}

// ----------------------------------------------------------------
static void z2ipoly_vgcd(
	void * pvout,
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	z2ipoly_t a = *(z2ipoly_t *)pvin1;
	z2ipoly_t b = *(z2ipoly_t *)pvin2;
	z2ipoly_t c = z2ipoly_gcd(a, b);
	*(z2ipoly_t *)pvout = c;
}

// ----------------------------------------------------------------
static void z2ipoly_vpower(
	void * pvout,
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	z2ipoly_t a = *(z2ipoly_t *)pvin1;
	z2ipoly_t b = *(z2ipoly_t *)pvin2;
	z2ipoly_t c = z2ipoly_power(a, (unsigned)b);
	*(z2ipoly_t *)pvout = c;
}

// ----------------------------------------------------------------
static void z2ipoly_vuadd (
	void * pvout,
	void * pvin,
	void * pvaux)
{
	*(z2ipoly_t *)pvout = *(z2ipoly_t *)pvin;
}

// ----------------------------------------------------------------
static void z2ipoly_vusub (
	void * pvout,
	void * pvin,
	void * pvaux)
{
	*(z2ipoly_t *)pvout = *(z2ipoly_t *)pvin;
}

//// ----------------------------------------------------------------
//// This is gross because kalk will print the result as a z2ipoly_t (in hex).
//static void z2ipoly_vord (
//	void * pvout,
//	void * pvin,
//	void * pvaux)
//{
//	z2ipoly_t a = *(z2ipoly_t *)pvin;
//	z2ipoly_t c = (z2ipoly_t) (unsigned)z2ipolymod_element_order(a, r);
//	*(z2ipoly_t *)pvout = c;
//}

// ================================================================
ops_t z2ipoly_ops = {
	atom_desc          : "z2ipoly",
	plex_first_func    : z2ipoly_lex_first,
	pscan_func         : z2ipoly_vscan,
	pprint_func        : z2ipoly_vprint,
//	prectifier         : z2ipoly_vrectifier,
	padd_op            : z2ipoly_vadd,
	psub_op            : z2ipoly_vsub,
	pmul_op            : z2ipoly_vmul,
	pdiv_op            : z2ipoly_vdiv,
	pmod_op            : z2ipoly_vmod,
	pgcd_op            : z2ipoly_vgcd,
	ppow_op            : z2ipoly_vpower,
	puadd_op           : z2ipoly_vuadd,
	pusub_op           : z2ipoly_vusub,
//	pord_op            : z2ipoly_vord,
//	ptopt_alloc        : z2ipoly_opt_alloc,
//	parg_defaulter     : z2ipoly_opt_arg_defaulter,
//	parg_handler       : z2ipoly_opt_arg_handler,
	atom_size_in_bytes : sizeof(z2ipoly_t),
	aux_size_in_bytes  : 0
};
