#include <string.h>
#include "stack.h"
#include "error.h"

// ----------------------------------------------------------------
void stack_init(stack_t * ps)
{
	ps->stack_atom_size_in_bytes = 0;
}

// ----------------------------------------------------------------
int stack_push(stack_t * ps, void * pval, int nbytes)
{
	if (ps->stack_atom_size_in_bytes + nbytes > MAX_STACK_SIZE_IN_BYTES) {
		error("stack overflow.");
		// return 0;
	}
	memcpy(&ps->ents[ps->stack_atom_size_in_bytes], pval, nbytes);
	ps->stack_atom_size_in_bytes += nbytes;
	return 1;
}

// ----------------------------------------------------------------
int stack_pop(stack_t * ps, void * pval, int nbytes)
{
	if (ps->stack_atom_size_in_bytes < nbytes) {
		error("stack underflow.");
		// return 0;
	}
	ps->stack_atom_size_in_bytes -= nbytes;
	memcpy(pval, &ps->ents[ps->stack_atom_size_in_bytes], nbytes);
	return 1;
}
