#ifndef SYMTAB_H
#define SYMTAB_H

#include "atom.h"

#define STRMAX 999
#define SYMMAX 100

typedef struct _st_entry_t {
	char * lexptr;
	int    token;
	int    has_val;
	char   atombuf[MAX_ATOM_SIZE];
} st_entry_t;

typedef struct _symtab_t {
	char   lexemes[STRMAX];
	int    nchars;
	st_entry_t entries[SYMMAX];
	int    nents;
} symtab_t;

void st_init  (symtab_t * pst);
int  st_lookup(symtab_t * pst, char * string, int * ptok, int * pidx);
int  st_insert(symtab_t * pst, char * string, int   tok,  int * pidx);
char * st_name(symtab_t * pst, int stidx);
int  st_get_val(symtab_t * pst, int stidx, char buf[MAX_ATOM_SIZE]);
void st_set_val(symtab_t * pst, int stidx, char buf[MAX_ATOM_SIZE]);

void st_dump  (symtab_t * pst);

#endif // SYMTAB_H
