#include <stdio.h>
#include <stdlib.h>
#include "zppolymod.h"
#include "zpnpoly_factor.h"
#include "power.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t r;
	zpoly_t * fes;
	zppoly_aux_t aux;
	int p, n = 0, nel, i;

	if ((argc != 3) && (argc != 4))
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);
	if (sscanf(argv[2], "%d", &n) != 1)
		usage(argv[0]);
	if (argc == 3) {
		fes = zppolymod_get_elements(p, n, &nel);
		aux.p = p;
		aux.r = r = zppoly_from_base_rep(p, nel);
	}
	else {
		if (!zppoly_scan(&r, argv[3], p))
			usage(argv[0]);
		fes = zppolymod_get_elements_frobord(&r, p, &nel);
		aux.p = p;
		aux.r = r;
	}

	for (i = 0; i < nel; i++) {
		if (i > 0)
			printf(" ");
		zppolymod_print(&fes[i], &aux);
	}
	printf("\n");

	free(fes);
	return 0;
}
