#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"
#include "z2nipoly_factor.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t r;
	z2ipoly_t * fes;
	int n = 0, nel, i;

	if ((argc != 2) && (argc != 3))
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &n) != 1)
		usage(argv[0]);
	if (argc == 2) {
		fes = z2ipolymod_get_elements(n, &nel);
		r = 1LL << n;
	}
	else {
		if (!z2ipoly_scan(&r, argv[2]))
			usage(argv[0]);
		fes = z2ipolymod_get_elements_frobord(r, &nel);
	}

	for (i = 0; i < nel; i++) {
		if (i > 0)
			printf(" ");
		z2ipolymod_print(fes[i], r);
	}
	printf("\n");

	free(fes);
	return 0;
}
