#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"
#include "z2nipoly_factor.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {r} {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t r;
	z2nipoly_t a;
	int n, d, i, nel;

	if (argc != 3)
		usage(argv[0]);
	if (!z2ipoly_scan(&r, argv[1]))
		usage(argv[0]);
	if (sscanf(argv[2], "%d", &n) != 1)
		usage(argv[0]);
	d = z2ipoly_get_degree(r);
	nel = 1 << (d*n);

	for (i = 0; i < nel; i++) {
		a = z2nipoly_from_base_rep(i, d);
		z2nipoly_print(&a, r);
		printf("\n");
	}

	return 0;
}
