#include <stdio.h>
#include <stdlib.h>
#include "z3polymod.h"
#include "z3npoly_factor.h"
#include "power.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z3poly_t r;
	z3poly_t * fes;
	int n = 0, nel, i;

	if ((argc != 2) && (argc != 3))
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &n) != 1)
		usage(argv[0]);
	if (argc == 2) {
		fes = z3polymod_get_elements(n, &nel);
		r = z3poly_from_base_rep(nel);
	}
	else {
		if (!z3poly_scan(&r, argv[2]))
			usage(argv[0]);
		fes = z3polymod_get_elements_frobord(&r, &nel);
	}

	for (i = 0; i < nel; i++) {
		if (i > 0)
			printf(" ");
		z3polymod_print(&fes[i], &r);
	}
	printf("\n");

	free(fes);
	return 0;
}
