#include <stdio.h>

#define JNBITS 8

#if JNBITS == 4
#define JMSB  (0x10 << 2)
#define JPOLY (0x13 << 2)
#elif JNBITS == 8
#define JMSB  (0x100 << 2)
#define JPOLY (0x11d << 2)
#elif JNBITS == 16
#define JMSB  (0x10000 << 2)
#define JPOLY (0x11f29 << 2)
#elif JNBITS == 18
#define JMSB  (0x40000 << 2)
#define JPOLY (0x4b271 << 2)
#elif JNBITS == 21
#define JMSB  (0x200000 << 2)
#define JPOLY (0x25269b << 2)
#elif JNBITS == 22
#define JMSB  (0x400000 << 2)
#define JPOLY (0x4393f5 << 2)
#else
#error feh
#endif

#define JSIZE (1 << JNBITS)
#define JSTART 0xa00000
//static unsigned jbuf[JSIZE];
//#define JSTART (unsigned)&jbuf[0]

int testdramj(void)
{
	unsigned p1, p2;
	unsigned poff, i, diff;

	poff = 4;
	for (i = 0; i < JSIZE-1; i++) {

		p1 = JSTART + poff;
		poff <<= 1; if (poff & JMSB) poff ^= JPOLY;
		p2 = JSTART + poff;
		diff = p2 - p1;
		printf("%08x %+5d\n", p1, ((int)diff)>>2);
	}

	return 0;
}

int main(void)
{
	testdramj();
	return 0;
}
