#include <stdio.h>
#include <stdlib.h>
#include "zppolymod.h"
#include "power.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {n} [a0]\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t a0, a;
	zppoly_aux_t aux;
	int pn1, i;
	int p1, p2, diff;

	if ((argc != 3) && (argc != 4))
		usage(argv[0]);
	if (!zppolymod_auxscan(&aux, argv[1], argv[2]))
		usage(argv[0]);
	if (argc == 3) {
		a0 = zppoly_from_base_rep(aux.p, aux.p);
	}
	else {
		if (!zppoly_scan(&a0, argv[3], aux.p))
			usage(argv[0]);
	}
	pn1 = calc_power(aux.p, aux.r.degree) - 1;

	a = a0;
	for (i = 0; i < pn1; i++) {
		p1 = zppoly_to_base_rep(&a, aux.p);
		zppolymod_print(&a, &aux);
		a = zppolymod_mul(&a, &a0, &aux);
		p2 = zppoly_to_base_rep(&a, aux.p);
		diff = p2 - p1;
		printf(" %+5d\n", diff);
	}


	return 0;
}

//	for (i = 0; i < pn1; i++) {
//		p1 = a;
//		a <<= 1; if (a & msb) a ^= r;
//		p2 = a;
//		diff = p2 - p1;
//		printf("%08x %+5d\n", p1, (int)diff);
//	}
//
//	return 0;
//}
