// try:
// 12 1ff vs. 12 2
// 14 9
// 11 7ff
// 13 ede
// 13 ff3
// 13 ff8
// 13 7df
// 13 ff0
// 13 1ffd
// 13 fff *
// 14 fff
// ech: 14 3
// rand: 12 1ff, 14 333c

#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {r} {a}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t r, a, h, b, c;
	int n;
	int hex = 0;

	if (argc < 3)
		usage(argv[0]);

	if (!z2ipolymod_auxscan(&r, argv[1]))
		usage(argv[0]);
	if (!z2ipoly_scan(&a, argv[2]))
		usage(argv[0]);
	if (argc > 3)
		hex = 1;

	n = z2ipoly_get_degree(r);
	h = 1LL << n;

	for (b = 0LL; b < h; b++) {
		c = z2ipolymod_mul(a, b, r);
		if (hex) {
			z2ipolymod_print(b, r);
			printf(" ");
			z2ipolymod_print(c, r);
			printf("\n");
		}
		else {
			printf("%llu %llu\n", b, c);
		}
	}

	return 0;
}
