#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "zppolymod.h"
#include "malloc_check.h"
#include "power.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi, p, n;
	zpoly_t r, cpoly, rc;
	int pn, irlo, i, c;
	char * marks;

	if (argc < 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);

	for (argi = 2; argi < argc; argi++) {

		if (sscanf(argv[argi], "%d", &n) != 1)
			usage(argv[0]);

		pn = calc_power(p, n);
		marks = malloc_check(pn * sizeof(char));
		irlo = pn;

		for (i = 0; i < pn; i++) {
			marks[i] = 0;
		}

		for (i = 0; i < pn; i++) {
			if (marks[i])
				continue;
			r = zppoly_from_base_rep(p, irlo + i);
			if (!zppoly_is_irreducible(&r, p))
				continue;

			for (c = p; c < p+p; c++) {
				cpoly = zppoly_from_base_rep(p, c);
				rc = zppoly_compose(&r, &cpoly, p);
				if (c == p) {
					zppoly_print(&rc, p);
				}
				else if (!zppoly_equal(&rc, &r, p)) {
					printf(" ");
					zppoly_print(&rc, p);
				}
				marks[zppoly_to_base_rep(&rc, p) - irlo] = 1;
			}
			printf("\n");
		}
		free(marks);
		if (argc > 3)
			printf("\n");
	}

	return 0;
}
