#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2ipolymod.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int n, pn, i;
	z2ipoly_t rlo, r, c, rc;
	char * marks;

	if (argc != 2)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &n) != 1)
		usage(argv[0]);

	pn = 1 << n;
	marks = malloc_check(pn * sizeof(char));
	rlo = 1LL << n;

	for (i = 0; i < pn; i++) {
		marks[i] = 0;
	}

	for (i = 0; i < pn; i++) {
		if (marks[i])
			continue;
		r = rlo + i;
		if (!z2ipoly_is_irreducible(r))
			continue;

		for (c = 2LL; c <= 3LL; c++) {
			rc = z2ipoly_compose(r, c);
			if (c == 2LL) {
				z2ipoly_print(rc);
			}
			else if (rc != r) {
				printf(" ");
				z2ipoly_print(rc);
			}
			marks[rc - rlo] = 1;
		}
		printf("\n");
	}

	free(marks);
	return 0;
}
