#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "isprime.h"
#include "power.h"
#include "zppoly.h"

void my_list_primes(int lo, int hi, int verbose, int per_line);

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {lo} {hi}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int lo = 2;
	int hi = 10;
	int verbose = 0;
	int per_line = 0;

	if ((argc != 3) && (argc != 4))
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &lo) != 1)
		usage(argv[0]);
	if (sscanf(argv[2], "%d", &hi) != 1)
		usage(argv[0]);
	if (argc == 4) {
		verbose = 1;
		if (sscanf(argv[3], "@%d", &per_line) == 1)
			verbose = 2;
	}

	my_list_primes(lo, hi, verbose, per_line);

	return 0;
}

// ----------------------------------------------------------------
void my_list_primes(int lo, int hi, int verbose, int per_line)
{
	int i;
	int nfound = 0;
	int ntried = 0;
	int prime;

	for (i = lo; i <= hi; i++) {
		ntried++;
		prime = isprime(i);
		if (prime)
			nfound++;
		if (verbose == 2) {
			if (((i-lo) % per_line) == 0)
				printf("\n");
			printf("%c", prime ? '*' : '-');
			fflush(stdout);
		}
		else if (verbose == 1) {
			printf("%6d", i);
			if (prime)
				printf(" *");
			printf("\n");
		}
		else {
			if (prime) {
				printf("  ");
				printf("%6d", i);
				printf("\n");
			}
		}
	}
	if (verbose == 2)
		printf("\n");
	printf("%6d tried; %6d found.\n", ntried, nfound);
}
