#include <stdio.h>
#include <stdlib.h>
#include "isprime.h"
#include "mod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {max}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int max = 20;
	int p, g;
	int verbose = 0;
	int got_it;

	if ((argc != 2) && (argc != 3))
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &max) != 1)
		usage(argv[0]);
	if (argc == 3)
		verbose = 1;

	for (p = 3; p < max; p++) {
		if (!isprime(p))
			continue;

		got_it = 0;
		for (g = 2; g < p; g++) {
			if (mod_mul_order(g, p) == (p - 1)) {
				got_it = 1;
				break;
			}
		}
		if (!got_it) {
			fprintf(stderr, "No generator for %d!\n", p);
			exit(1);
		}
		printf("%4d: %4d\n", p, g);
	}

	return 0;
}
