#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"

#define VERBOSE

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t r, rtop = 0x100;
	unsigned  d, dtop = 8;
	z2ipoly_t x = 2LL, xd, modbefore, modafter;
	unsigned ngood = 0, nbad = 0;

	if (argc >= 2)
		(void)sscanf(argv[1], "%llx", &rtop);
	if (argc >= 3)
		(void)sscanf(argv[2], "%u", &dtop);

	for (r = 1; r <= rtop; r++) {
#ifndef VERBOSE
		printf("\r");
		z2ipolymod_print(r, rtop);
		fflush(stdout);
#endif
		for (d = 1; d <= dtop; d++) {
			xd = 1LL << d;
			modbefore = z2ipoly_mod(xd, r) ^ x;
			modafter  = z2ipoly_mod(xd ^ x, r);

#ifdef VERBOSE
			printf("(2^%2d mod ", d);
			z2ipolymod_print(r, rtop);
			printf(") + 2 = ");
			z2ipolymod_print(modbefore, rtop);
			printf("  ");

			printf("(2^%2d + 2) mod ", d);
			z2ipolymod_print(r, rtop);
			printf(" = ");
			z2ipolymod_print(modafter, rtop);

			if (modbefore != modafter) {
				printf("  ERROR: XOR = ");
				z2ipolymod_print(modbefore ^ modafter, rtop);
			}
			printf("\n");
#endif

			if (modbefore == modafter)
				ngood++;
			else
				nbad++;
		}
#ifdef VERBOSE
		printf("\n");
#endif
	}
#ifndef VERBOSE
	printf("\r");
#endif
	printf("ngood %u nbad %u\n", ngood, nbad);

	return 0;
}
