#include <stdio.h>
#include <stdlib.h>

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {numbers ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi;
	int i, prec = 20;
	long long p, n, q, r;

	if (argc < 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%lld", &p) != 1)
		usage(argv[0]);

	for (argi = 2; argi < argc; argi++) {
		if (sscanf(argv[argi], "%lld", &n) != 1) {
			fprintf(stderr,
				"Couldn't parse \"%s\"; skipping.\n",
				argv[argi]);
			continue;
		}

		printf("p = %2lld n = %6lld:   ", p, n);

		for (i = 0; i < prec; i++) {
			q = n / p;
			r = n % p;

			if (r < 0) {
				// Silly C mod!
				q--;
				r += p;
			}

			printf("%lld", r);
			if (i == 0)
				printf(".");
			else if (p > 10)
				printf(",");

			if (q == 0)
				break;

			n = q;
		}

		if (q != 0)
			printf(" ...");

		printf("\n");
	}

	return 0;
}
