#include <stdio.h>

// ----------------------------------------------------------------
int mod_power(int x, int e, int p)
{
	int xp = x % p;
	int rv = 1;

	while (e != 0) {
		if (e & 1) {
			rv = (rv * xp) % p;
		}
		e = (unsigned)e >> 1;
		xp = (xp * xp) % p;
	}
	return (int)rv;
}

// ----------------------------------------------------------------
int mod_recip(int x, int p)
{
	if (x == 0) {
		fprintf(stderr, "mod_recip():  Division by zero.\n");
		exit(1);
	}
	return mod_power(x, p-2, p);
}

// ----------------------------------------------------------------
void test_p(int p)
{
	int x, xi, xxi;
	for (x = 1; x < p; x++) {
		xi = mod_recip(x, p);
		xxi = (x * xi) % p;
		printf("%6d %6d %6d\n", x, xi, xxi);
	}
	printf("\n");
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	test_p(2);
	test_p(3);
	test_p(5);
	test_p(7);
	test_p(11);
	test_p(31);
	test_p(113);
	return 0;
}
