#include <stdio.h>
#include "padic.h"

// ----------------------------------------------------------------
void test_print(int p)
{
	int n;
	padic_t a;

	for (n = -10; n <= 10; n++) {
		a = padic_from_int(n, p);
		printf("%3d ~= ", n);
		padic_print(&a, p);
		printf("\n");
	}
}

// ----------------------------------------------------------------
void test_add(int p)
{
	int m, n;
	padic_t a, b, c, check;

	for (m = -5; m <= 5; m++) {
		a = padic_from_int(m, p);
		for (n = -5; n <= 5; n++) {
			b = padic_from_int(n, p);
			c = padic_add(&a, &b, p);
			check = padic_from_int(m + n, p);
			printf("%3d+%3d ~= ", m, n);
			padic_print(&a, p);
			printf(" + ");
			padic_print(&b, p);
			printf(" = ");
			padic_print(&c, p);
			printf(" vs. %3d ~= ", m + n);
			padic_print(&check, p);
			printf("\n");
		}
		printf("\n");
	}
}

// ----------------------------------------------------------------
void test_uneg(int p)
{
	int m;
	padic_t a, c, check;

	for (m = -10; m <= 10; m++) {
		a = padic_from_int(m, p);
		c = padic_uneg(&a, p);
		check = padic_from_int(-m, p);
		printf("-(%3d) ~= -", m);
		padic_print(&a, p);
		printf(" = ");
		padic_print(&c, p);
		printf(" vs. %3d ~= ", -m);
		padic_print(&check, p);
		printf("\n");
	}
}

// ----------------------------------------------------------------
void test_sub(int p)
{
	int m, n;
	padic_t a, b, c, check;

	for (m = -5; m <= 5; m++) {
		a = padic_from_int(m, p);
		for (n = -5; n <= 5; n++) {
			b = padic_from_int(n, p);
			c = padic_sub(&a, &b, p);
			check = padic_from_int(m - n, p);
			printf("%3d-%3d ~= ", m, n);
			padic_print(&a, p);
			printf(" - ");
			padic_print(&b, p);
			printf(" = ");
			padic_print(&c, p);
			printf(" vs. %3d ~= ", m - n);
			padic_print(&check, p);
			printf("\n");
		}
		printf("\n");
	}
}

// ----------------------------------------------------------------
void test_mul1(int p)
{
	int m = 3, n = 4;
	padic_t a, b, c, check;

	a = padic_from_int(m, p);
	b = padic_from_int(n, p);
	c = padic_mul(&a, &b, p);
	check = padic_from_int(m * n, p);
	printf("%3d*%3d ~= ", m, n);
	padic_print(&a, p);
	printf(" * ");
	padic_print(&b, p);
	printf(" = ");
	padic_print(&c, p);
	printf(" vs. %3d ~= ", m * n);
	padic_print(&check, p);
	printf("\n");
}

// ----------------------------------------------------------------
void test_mul(int p)
{
	int m, n;
	padic_t a, b, c, check;

	for (m = -5; m <= 5; m++) {
		a = padic_from_int(m, p);
		for (n = -5; n <= 5; n++) {
			b = padic_from_int(n, p);
			c = padic_mul(&a, &b, p);
			check = padic_from_int(m * n, p);
			printf("%3d*%3d ~= ", m, n);
			padic_print(&a, p);
			printf(" * ");
			padic_print(&b, p);
			printf(" = ");
			padic_print(&c, p);
			printf(" vs. %3d ~= ", m * n);
			padic_print(&check, p);
			printf("\n");
		}
		printf("\n");
	}
}

// ----------------------------------------------------------------
void test_div(int p)
{
	int m, n;
	padic_t a, b, c, check;

	for (m = -5; m <= 5; m++) {
		a = padic_from_int(m, p);
		for (n = -5; n <= 5; n++) {
			if (n == 0)
				continue;
			b = padic_from_int(n, p);
			c = padic_mul(&a, &b, p);
			check = padic_from_rat(
				rat_div(
					rat_from_int(m),
					rat_from_int(n)),
				p);
			printf("%3d/%3d ~= ", m, n);
			padic_print(&a, p);
			printf(" / ");
			padic_print(&b, p);
			printf(" = ");
			padic_print(&c, p);
			printf(" vs. %3d/%3d ~= ", m, n);
			padic_print(&check, p);
			printf("\n");
		}
		printf("\n");
	}
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int p = 2;

	if (argc == 2) {
		(void)sscanf(argv[1], "%d", &p);
	}

	//test_print(p);
	//test_add(p);
	test_uneg(p);
	//test_sub(p);
	//test_mul1(p);
	//test_mul(p);
	//test_div(p);

	return 0;
}

//padic_t padic_zero(void);
//void  padic_print(padic_t * pc, int p);
//
//padic_t padic_add(padic_t * pa, padic_t * pb, int p);
//padic_t padic_sub(padic_t * pa, padic_t * pb, int p);
//padic_t padic_mul(padic_t * pa, padic_t * pb, int p);
//padic_t padic_div(padic_t * pa, padic_t * pb, int p);
//
//padic_t padic_from_int(int   n, int p);
//padic_t padic_from_rat(rat_t n, int p);
