#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "isprime.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s [p=?] [a=?] [k=?] [m=?] [u=?]\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
// \prod_{i=1}^m (a + ik) mod p
int main(int argc, char ** argv)
{
	int plo = -1, phi = -1;
	int alo = -1, ahi = -1;
	int klo = -1, khi = -1;
	int mlo = -1, mhi = -1;
	int u = 1;
	int p, a, k, m;
	int aplo, aphi, kplo, kphi, mplo, mphi, up;
	int verbose = 0;
	int i, ak, product;
	int argi;

	for (argi = 1; argi < argc; argi++) {

		if (sscanf(argv[argi], "p=%d-%d", &plo, &phi) == 2)
			;
		else if (sscanf(argv[argi], "p=%d", &plo) == 1)
			phi = plo;

		else if (sscanf(argv[argi], "a=%d-%d", &alo, &ahi) == 2)
			;
		else if (sscanf(argv[argi], "a=%d", &alo) == 1)
			ahi = alo;

		else if (sscanf(argv[argi], "k=%d-%d", &klo, &khi) == 2)
			;
		else if (sscanf(argv[argi], "k=%d", &klo) == 1)
			khi = klo;

		else if (sscanf(argv[argi], "m=%d-%d", &mlo, &mhi) == 2)
			;
		else if (sscanf(argv[argi], "m=%d", &mlo) == 1)
			mhi = mlo;

		else if (sscanf(argv[argi], "u=%d", &u) == 1)
			;

		else if (strcmp(argv[argi], "-v") == 0)
			verbose = 1;
		else
			usage(argv[0]);
	}

	if (plo == -1) {
		plo = 11;
		phi = 11;
	}

	for (p = plo; p <= phi; p++) {
		if (!isprime(p))
			continue;

		if (plo != phi) {
			printf("\n");
			printf(">>>>>>>>>>> p=%d\n", p);
		}

		up = u % p;

		if (mlo == -1) {
			mplo = 2;
			mphi = p - 1;
		}
		else {
			mplo = mlo;
			mphi = mhi;
		}

		if (klo == -1) {
			kplo = 1;
			kphi = p - 1;
		}
		else {
			kplo = klo % p;
			kphi = khi % p;
		}

		if (alo == -1) {
			aplo = 1;
			aphi = p - 1;
		}
		else {
			aplo = alo % p;
			aphi = ahi % p;
		}

		for (m = mplo; m <= mphi; m++) {
			if (mplo != mphi) {
				printf("\n");
			}
			for (a = aplo; a <= aphi; a++) {
				for (k = kplo; k <= kphi; k++) {
					product = 1;
					ak = a % p;
					for (i = 0; i < m; i++) {
						product *= ak;
						product %= p;
						ak += k;
						ak %= p;
					}

					if (!verbose && (product != up))
						continue;

					product = 1;
					ak = a % p;
					printf("  ");
					for (i = 0; i < m; i++) {
						printf(" %d", ak);
						product *= ak;
						product %= p;
						ak += k;
						ak %= p;
					}
					printf(" = %d\n", product);
				}
			}
		}
	}

	return 0;
}
