#include <stdio.h>
#include <stdlib.h>

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s [p=?] [a=?] [k=?] [m=?] [u=?]\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
// \prod_{i=1}^m (a + ik) mod p
int main(int argc, char ** argv)
{
	int p = 11, a=5, k=1, m=3, u=1;
	int i, ak, product;
	int argi;

	for (argi = 1; argi < argc; argi++) {
		if (sscanf(argv[argi], "p=%d", &p) == 1)
			;
		else if (sscanf(argv[argi], "a=%d", &a) == 1)
			;
		else if (sscanf(argv[argi], "k=%d", &k) == 1)
			;
		else if (sscanf(argv[argi], "m=%d", &m) == 1)
			;
		else if (sscanf(argv[argi], "u=%d", &u) == 1)
			;
		else
			usage(argv[0]);
	}

	a %= p;
	k %= p;
	u %= p;


	product = 1;
	ak = a;
	printf(">>");
	for (i = 0; i < m; i++) {
		printf(" %d", ak);
		product *= ak;
		product %= p;
		ak += k;
	}
	printf(" = %d\n", product);

	return 0;
}
