#include <stdio.h>
#include <stdlib.h>
#include "zppolymod.h"
#include "power.h"

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t z, zp, zpx, zxp;
	int p = 3;
	int brmax = 1000;
	int i;
	int ngood = 0, nbad = 0;

	if (argc >= 2)
		(void)sscanf(argv[1], "%d", &p);
	if (argc >= 3)
		(void)sscanf(argv[2], "%d", &brmax);

	zp.degree = p;
	zp.coeffs[p] = 1;
	for (i = 0; i < p; i++)
		zp.coeffs[i] = 0;
	//zp = zppoly_from_base_rep(p, calc_power(p, p));

	for (i = 0; i < brmax; i++) {
		z = zppoly_from_base_rep(p, i);
		zpx = zppoly_power(&z, p, p);
		zxp = zppoly_compose(&z, &zp, p);
#if 0
		printf("i=%d ", i);
		printf(" z(x)=");       zppoly_print(&z, p);
		printf(" z^%d(x)=", p); zppoly_print(&zpx, p);
		printf(" z(x^%d)=", p); zppoly_print(&zxp, p);
		printf("\n");
#endif
		if (zppoly_equal(&zpx, &zxp, p))
			ngood++;
		else
			nbad++;
	}
	printf("#good=%d #bad=%d\n", ngood, nbad);

	return 0;
}
