#include <stdio.h>
#include <stdlib.h>
#include "isprime.h"
#include "mod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {plo[-phi]} {glo[-ghi]}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int plo, phi, glo, ghi;
	int p, g;

	if (argc != 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d-%d", &plo, &phi) == 2) {
	}
	else if (sscanf(argv[1], "%d", &plo) == 1) {
		phi = plo;
	}
	else {
		usage(argv[0]);
	}

	if (sscanf(argv[2], "%d-%d", &glo, &ghi) == 2) {
	}
	else if (sscanf(argv[2], "%d", &glo) == 1) {
		ghi = glo;
	}
	else {
		usage(argv[0]);
	}

	for (p = plo; p <= phi; p++) {
		if (!isprime(p))
			continue;
		for (g = glo; g <= ghi; g++) {
			printf("%4d: %4d %s\n",
				p, g,
				mod_mul_order(g, p) == (p-1) ? "gen" : "--");
		}
		if ((phi != plo) && (ghi != glo))
			printf("\n");
	}

	return 0;
}
