#include <stdio.h>
#include <stdlib.h>
#include "pmt.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {n} {image lists ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int n, argi;
	pmt_t pmt, pmti;

	if (argc < 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &n) != 1)
		usage(argv[0]);
	for (argi = 2; argi < argc; argi++) {
		if (!pmt_vscan(&pmt, argv[argi], &n, sizeof(pmt_t))) {
			usage(argv[0]);
		}
		pmt_invert(&pmt, &pmti, n);
		pmt_print(&pmti, n);
		printf("\n");
	}
	return 0;
}
