#include <stdio.h>
#include <stdlib.h>
#include "isprime.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	long long kmax = 2;
	long long nmax = 20;
	long long * buf, * pp;
	long long n, k;
	int verbose = 0;

	if (argc >= 2)
		(void)sscanf(argv[1], "%lld", &nmax);
	if (argc >= 3)
		(void)sscanf(argv[2], "%lld", &kmax);
	if (kmax < 1) {
		fprintf(stderr, "feh\n");
		exit(1);
	}
	if (argc >= 4)
		verbose = 1;

	buf = malloc_check((2 * kmax + 1) * sizeof(long long));
	pp = &buf[kmax];

	for (n = 2; n <= nmax; n++) {

		pp[0] = n;
		for (k = 1; k <= kmax; k++) {
			pp[ k] = pp[ k-1] * (n + k) / (k+1);
			pp[-k] = pp[-k+1] * (n - k) / (k+1);
		}

		printf("%5lld %d ", n, isprime((int)n));
		for (k = -kmax; k <= kmax; k++) {
			if (k == 0)
				printf("|");
			else if (k > n)
				printf("*");
			else if (-k > n)
				printf("*");
			else
				printf("%d", !(pp[k] %n));
		}
		if (verbose) {
			for (k = -kmax; k <= kmax; k++) {
				printf(" %5lld", pp[k]);
			}
		}
		printf("\n");

	}

	free(buf);
	return 0;
}
