#include <stdio.h>
#include <stdlib.h>
#include "z2poly_factor.h"
#include "isprime.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2poly_t r, Pe;
	z2poly_factor_info_t finfo;
	int argi;
	int i, n, e, pn1;

	if (argc < 2)
		usage(argv[0]);

	for (argi = 1; argi < argc; argi++) {
		if (!z2poly_scan(&r, argv[argi]))
			usage(argv[0]);
		n = z2poly_get_degree(&r);
		printf("n=%d\n", n);
		pn1 = (1 << n) - 1;
		printf("pn1=%d\n", pn1);
		if (pn1 > Z2POLY_MAX_DEGREE) {
			fprintf(stderr, "Max degree is %d; got %d.\n",
				Z2POLY_MAX_DEGREE, pn1);
			exit(1);
		}
		for (e = 1; e <= pn1; e++) {
			//if (0)
			//if (!isprime(e))
			//if (calc_gcd_signed(e, pn1) == 1)
			if ((pn1 % e) != 0)
				continue;
			Pe = z2poly_from_base_rep(0);
			for (i = 0; i < e; i++)
				z2poly_set_bit(&Pe, i);
			z2poly_factor(&Pe, &finfo);

			if (z2poly_is_irreducible(&Pe))
				printf("*");
			else
				printf(" ");
			printf("e=%2d", e);
			//printf(" Pe=", e);
			//z2poly_print(&Pe);
			printf(": ");

			for (i = 0; i < finfo.num_distinct; i++) {
				printf(" ");
				z2poly_print(&finfo.factor_counts[i].f);
				if (finfo.factor_counts[i].count > 1)
					printf("^%d",
						finfo.factor_counts[i].count);
				printf("[%d]",
					z2poly_get_degree(
					&finfo.factor_counts[i].f));
			}
			printf("\n");
			fflush(stdout);
		}
	}

	return 0;
}
