#include <stdio.h>
#include <stdlib.h>
#include "z2ipoly_factor.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t r, Pe;
	z2ipoly_factor_info_t finfo;
	int argi;
	int i, n, e, eprime, pn1, d;

	if (argc < 2)
		usage(argv[0]);
	for (argi = 1; argi < argc; argi++) {
		if (sscanf(argv[argi], "%llx", &r) != 1)
			usage(argv[0]);
		n = z2ipoly_get_degree(r);
		pn1 = (1 << n) - 1;
		// Higher bound if I were using z2poly, not z2ipoly ...
		if (pn1 >= 64) {
			fprintf(stderr, "max degree is 6; got %d.\n", n);
			continue;
		}
		printf("pn1=%d\n", pn1);
		for (e = 1; e < pn1; e++) {
			if ((pn1 % e) != 0)
			//if (calc_gcd_signed(e, pn1) == 1)
				continue;
			Pe = (1LL << e) - 1;
			printf("e=%2d Pe=%016llx: ", e, Pe);

			z2ipoly_factor(Pe, &finfo);
			for (i = 0; i < finfo.num_distinct; i++) {
				printf(" ");
				z2ipoly_print(finfo.factor_counts[i].f);
				if (finfo.factor_counts[i].count > 1)
					printf("^%d",
						finfo.factor_counts[i].count);
			}
			printf("\n");


			//for (d = 2, eprime = e; eprime > 1; d++) {
				//while ((e % d) != 0) {
					//x
				//}
			//}
		}

	}

	return 0;
}
