#include <stdio.h>
#include <stdlib.h>
#include "qpoly.h"
#include "power.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {poly1} {poly2}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	qpoly_t a, b, g, r, s;

	if (argc != 3)
		usage(argv[0]);
	if (!qpoly_scan(&a, argv[1]))
		usage(argv[0]);
	if (!qpoly_scan(&b, argv[2]))
		usage(argv[0]);

	g = qpoly_ext_gcd(&a, &b, &r, &s);
	r = qpoly_div(&r, &g);
	s = qpoly_div(&s, &g);
	g = qpoly_div(&g, &g);
	printf("g = "); qpoly_print(&g); printf("\n");
	printf("r = "); qpoly_print(&r); printf("\n");
	printf("s = "); qpoly_print(&s); printf("\n");

	return 0;
}
