#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m}\n", argv0);
	exit(1);
}

// 1bb = 13 * 19 but why don't we catch it?
// 808b = 25 * 29 * 2f
// 200f8b = 8f * 91 * 9d

//Testing 1bb
//  u = 02  u = 04  ux = 06  g = 01
//  u = 04  u = 10  ux = 12  g = 01
//  u = 10  u = bb  ux = b9  g = 01
//  u = bb  u = 02  ux = 00  g = 1bb

// x    =  2
// x^2  =  4
// x^4  = 10
// x^8  = bb
// x^16 =  2
//
// x^16 = x mod r
// r = ab (suppose there are only two factors), a & b irred.
// x^16 - x = 0 mod ab
// ab | x^16 - x
// a | x^16 - x  and  b | x^16 - x since UFD
// a & b are companion irrs (factors) of the master poly for F_2^4?
//
// When the alg'm is extended to not stop at i=d, I always get ux=00.

// remember 117, 1bb, 1d1?  Those are 13*19, 13*1f and 19*1f.

// can take mod before or after adding x???  I think so, but be sure.

// Note happens only when n has distinct non-trivial factors.  Explain this.
// Also explain why it doesn't happen for lower-order irrs -- ?
// E.g. if it fails on 13*1f, why not on 2 * 7, or 3 * 1f?

//Testing 200f8b
//  u = 000002  u = 000004  ux = 000006  g = 000001
//  u = 000004  u = 000010  ux = 000012  g = 000001
//  u = 000010  u = 000100  ux = 000102  g = 000001
//  u = 000100  u = 010000  ux = 010002  g = 000001
//  u = 010000  u = 1c489d  ux = 1c489f  g = 000001
//  u = 1c489d  u = 1d498b  ux = 1d4989  g = 000001
//  u = 1d498b  u = 000002  ux = 000000  g = 200f8b

//  1:       0
//  2:       1
//  3:       0
//  4:       0
//  5:       0
//  6:       1
//  7:       0
//  8:       3
//  9:       0
// 10:      15
// 11:       0
// 12:      38
// 13:       0
// 14:     153
// 15:      40
// 16:     435
// 17:       0
// 18:    1708
// 19:       0
// 20:    4896
// 21:    1632
// 22:   17205


//----------------------------------------------------------------
//Testing 808b
//  u = 0002  u = 0004  ux = 0006  g = 0001
//  u = 0004  u = 0010  ux = 0012  g = 0001
//  u = 0010  u = 0100  ux = 0102  g = 0001
//  u = 0100  u = 0116  ux = 0114  g = 0001
//  u = 0116  u = 0002  ux = 0000  g = 808b
// x^32 = x mod 808b
//----------------------------------------------------------------

int foo(z2ipoly_t r, int do_reduce)
{
	z2ipoly_t x = 2;
	z2ipoly_t u = 2;
	z2ipoly_t ux;
	z2ipoly_t g;
	int  d = z2ipoly_get_degree(r);
	int i;


printf("\n");
printf("Testing "); z2ipoly_print(r); printf("  ");
printf("degree = %d\n", d);
	for (i = 1; i < d+9/*i < d+d*/ /*i < d*/; i++) {
printf("d = %2d ", i);
		// u = u**2 mod r
//printf("  u = "); z2ipolymod_print(u, r);
		//u = z2ipoly_mod(z2ipoly_mul(u, u), r);

		if (do_reduce) {
			u = z2ipolymod_mul(u, u, r);
		}
		else {
			u = z2ipoly_mul(u, u);
		}

printf("  x^%4d=", 1<<i); z2ipolymod_print(u, r);
		// Test GCD(u + x, r)
		ux = u^x;
printf("  x^%4d+x = ", 1<<i); z2ipolymod_print(ux, r);
		g = z2ipoly_gcd(r, ux);
printf("  g = "); z2ipolymod_print(g, r);
printf("\n");
		if (ux == 0)
			return 0;

		//if (u == 0)
		//	return 0;
		//if (u == 1)
		//	return 0;

		if (g != 1) {
			// xxx how do we get here, with ux == 0?
			if ((ux != r) && (ux != 1) && (ux != 0)) {
				return 0;
			}
		}
	}
	return 1;
}

//int foo_squared(z2ipoly_t r, int do_reduce)
//{
//	z2ipoly_t x = 2;
//	z2ipoly_t u = 2;
//	z2ipoly_t ux;
//	z2ipoly_t g;
//	z2ipoly_t r2 = z2ipoly_mul(r, r);
//	int  d = z2ipoly_get_degree(r);
//	int i;
//
//
//printf("\n");
//printf("Testing "); z2ipoly_print(r); printf("  ");
//printf("degree = %d\n", d);
//	for (i = 1; i < d+9/*i < d+d*/ /*i < d*/; i++) {
//printf("d = %2d ", i);
//		// u = u**2 mod r
////printf("  u = "); z2ipolymod_print(u, r);
//		//u = z2ipoly_mod(z2ipoly_mul(u, u), r);
//		u = z2ipoly_mul(u, u);
//		if (do_reduce)
//			u = z2ipoly_mod(u, r2);
//printf("  x^%4d=", 1<<i); z2ipolymod_print(u, r);
//		// Test GCD(u + x, r)
//		ux = u^x;
//printf("  x^%4d+x = ", 1<<i); z2ipolymod_print(ux, r);
//		g = z2ipoly_gcd(r2, ux);
//printf("  g = "); z2ipolymod_print(g, r);
//printf("\n");
//		if (ux == 0)
//			return 0;
//
//		//if (u == 0)
//		//	return 0;
//		//if (u == 1)
//		//	return 0;
//
//		if (g != 1) {
//			// xxx how do we get here, with ux == 0?
//			if ((ux != r) && (ux != 1) && (ux != 0)) {
//				return 0;
//			}
//		}
//	}
//	return 1;
//}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t z;
	int argi;

	if (argc < 2)
		usage(argv[0]);
	for (argi = 1; argi < argc; argi++) {
		if (sscanf(argv[argi], "%llx", &z) != 1)
			usage(argv[0]);
		foo(z, 1);
		//foo(z, 0);
		//foo_squared(z, 1);
	}

	return 0;
}
