#include <stdio.h>
#include <iostream.h>
#include <unistd.h>
#include "qpoly.h"

// ----------------------------------------------------------------
void read_coeffs(
	int * coeffs,
	int * pdegree)
{
	char line[256];
	int scanrc;

	if (fgets(line, sizeof(line), stdin) == 0) {
		fprintf(stderr, "read_coeffs(): fgets null.\n");
		exit(1);
	}

	// xxx need to tokenize, then scan "%d/%d", else scan "%d".
	scanrc = sscanf(line, "%d %d %d %d %d %d %d %d %d %d %d %d %d",
		&coeffs[0], &coeffs[1], &coeffs[2],  &coeffs[3],
		&coeffs[4], &coeffs[5], &coeffs[6],  &coeffs[7],
		&coeffs[8], &coeffs[9], &coeffs[10], &coeffs[11]);

	if (scanrc < 1) {
		fprintf(stderr, "read_coeffs(): need >= 2 ints.\n");
		exit(1);
	}
	*pdegree = scanrc - 1;
}

// ----------------------------------------------------------------
void get_poly(
	char * name,
	qpoly & poly)
{
	int icoeffs[20];
	rat rcoeffs[20];
	int degree;
	int i;

	if (isatty(fileno(stdin))) {
		printf("Coeffs for %s: ", name);
		fflush(stdout);
	}
	read_coeffs(icoeffs, &degree);
	for (i = 0; i <= degree; i++)
		rcoeffs[i] = icoeffs[i];
	poly = qpoly(degree, rcoeffs);
}


// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	qpoly a, b;

	get_poly("a", a);
	get_poly("b", b);

	qpoly sum = a + b;
	cout << a << " + " << b << " = " << sum << endl;

	qpoly neg = -a;
	cout << "-" << a << " = " << neg << endl;

	qpoly diff = a - b;
	cout << a << " - " << b << " = " << diff << endl;

	qpoly prod = a * b;
	cout << a << " * " << b << " = " << prod << endl;

	qpoly quot = a / b;
	cout << a << " / " << b << " = " << quot << endl;

	qpoly rem = a % b;
	cout << a << " % " << b << " = " << rem << endl;

	a.quot_and_rem(b, quot, rem);
	cout << a << " / " << b << " = " << quot << endl;
	cout << a << " % " << b << " = " << rem << endl;

	qpoly check = b * quot + rem;
	cout << "a     = " << a     << endl;
	cout << "check = " << check << endl;

	if (a == check)
		cout << "OK" << endl;
	else {
		cout << "Error!!!!" << endl;
		return 1;
	}

	return 0;
}
