#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "zppolymod.h"
#include "power.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {n} [f]\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
// For f in Fp[x] up to a given degree
//   for a = 1 .. p-1, b = 0 .. p-1
//     print f(ax+b)

int main(int argc, char ** argv)
{
	int p, n;
	int filo, fihi, fi;
	zpoly_t f, axb, faxb;
	int a, b;

	if (argc != 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);
	if (sscanf(argv[2], "%d", &n) != 1)
		usage(argv[0]);

	filo = 0;
	fihi = calc_power(p, n+1);

	for (a = 1; a < p; a++) {
		for (b = 0; b < p; b++) {
			if ((a > 1) || (b > 0))
				printf(" ");
			printf("%d,%d", a, b);
		}
	}
	printf("\n");
	printf("\n");

	for (fi = filo; fi < fihi; fi++) {
		f = zppoly_from_base_rep(p, fi);

		for (a = 1; a < p; a++) {
			for (b = 0; b < p; b++) {
				axb = zppoly_from_coeffs1(a, b, p);
				faxb = zppoly_compose(&f, &axb, p);
				if ((a > 1) || (b > 0))
					printf(" ");
				zppoly_print(&faxb, p);
			}
		}
		printf("\n");

	}

	return 0;
}
