#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2ipolymod.h"
#include "power.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {n} [f]\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
// For f in Fp[x] up to a given degree
//   for a = 1 .. p-1, b = 0 .. p-1
//     print f(ax+b)

int main(int argc, char ** argv)
{
	int n;
	z2ipoly_t flo, fhi, f, axb, faxb;
	int a, b;

	if (argc != 2)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &n) != 1)
		usage(argv[0]);

	flo = 0;
	fhi = 1LL << (n+1);

	for (a = 1; a < 2; a++) {
		for (b = 0; b < 2; b++) {
			if ((a > 1) || (b > 0))
				printf(" ");
			printf("%d,%d", a, b);
		}
	}
	printf("\n");
	printf("\n");

	for (f = flo; f < fhi; f++) {
		for (a = 1; a < 2; a++) {
			for (b = 0; b < 2; b++) {
				axb = (a << 1) | b;
				faxb = z2ipoly_compose(f, axb);
				if ((a > 1) || (b > 0))
					printf(" ");
				z2ipoly_print(faxb);
			}
		}
		printf("\n");

	}

	return 0;
}
