#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z3polymod.h"
#include "power.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {n} [f]\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
// For f in Fp[x] up to a given degree
//   for a = 1 .. p-1, b = 0 .. p-1
//     print f(ax+b)

int main(int argc, char ** argv)
{
	int n;
	int filo, fihi, fi;
	z3poly_t f, axb, faxb;
	int a, b;

	if (argc != 2)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &n) != 1)
		usage(argv[0]);

	filo = 0;
	fihi = calc_power(3, n+1);

	for (a = 1; a < 3; a++) {
		for (b = 0; b < 3; b++) {
			if ((a > 1) || (b > 0))
				printf(" ");
			printf("%d,%d", a, b);
		}
	}
	printf("\n");
	printf("\n");

	for (fi = filo; fi < fihi; fi++) {
		f = z3poly_from_base_rep(fi);
		for (a = 1; a < 3; a++) {
			for (b = 0; b < 3; b++) {
				axb = z3poly_from_coeffs1(a, b);
				faxb = z3poly_compose(&f, &axb);
				if ((a > 1) || (b > 0))
					printf(" ");
				z3poly_print(&faxb);
			}
		}
		printf("\n");

	}

	return 0;
}
