#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "zppolymod.h"
#include "power.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {n} [rk]\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t r, c, rc, rk;
	zppoly_aux_t aux;
	int ir, irlo, irhi, ic, iclo, ichi;
	int do_mod = 0;
	int p, n;

	if (argc < 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);
	if (sscanf(argv[2], "%d", &n) != 1)
		usage(argv[0]);
	if (argc > 3) {
		if (!zppoly_scan(&rk, argv[3], p))
			usage(argv[0]);
		do_mod = 1;
	}

	irlo = calc_power(p, n);
	irhi = 2 * irlo - 1;
	iclo = 0;
	ichi = irlo - 1;

	aux.p = p;
	aux.r = zppoly_from_base_rep(p, calc_power(p, n));

	printf(". . ");
	for (ic = iclo; ic <= ichi; ic++) {
		printf(" ");
		c = zppoly_from_base_rep(p, ic);
		zppolymod_print(&c, &aux);
	}
	printf("\n");

	for (ir = irlo; ir <= irhi; ir++) {
		r = zppoly_from_base_rep(p, ir);
		if (zppoly_is_irreducible(&r, p)) {
			if (zppoly_is_primitive(&r, p, n)) {
				printf("p");
			}
			else {
				printf("i");
			}
		}
		else {
			printf("-");
		}

		printf(" ");
		zppoly_print(&r, p);
		printf(": ");

		for (ic = iclo; ic <= ichi; ic++) {
			c = zppoly_from_base_rep(p, ic);
			if (do_mod)
				rc = zppolymod_compose(&r, &c, &rk, p);
			else
				rc = zppoly_compose(&r, &c, p);
			printf(" ");
			zppoly_print(&rc, p);
		}
		printf("\n");
	}

	return 0;
}
