#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "zppolymod.h"
#include "power.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {n} [rk]\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t ri, rj, xc;
	int iri, irlo, irhi;
	int p, n, c;

	if (argc != 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);
	if (sscanf(argv[2], "%d", &n) != 1)
		usage(argv[0]);

	irlo = calc_power(p, n);
	irhi = 2 * irlo - 1;

	for (iri = irlo; iri <= irhi; iri++) {
		ri = zppoly_from_base_rep(p, iri);
		for (c = 0; c < p; c++) {
			xc = zppoly_from_coeffs1(1, c, p);
			rj = zppoly_compose(&ri, &xc, p);
			if (c > 0)
				printf(" ");
			zppoly_print(&rj, p);
		}
		printf("\n");

	}

	return 0;
}
