#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ring.h"
#include "cmds.h"

cmd_handler_t abelian_cmd;
//cmd_handler_t all_cjg_cmd;
cmd_handler_t ascendant_cmd;
cmd_handler_t aut_ring_cmd;
cmd_handler_t cap_cmd;
cmd_handler_t cayley_sn_cmd;
cmd_handler_t caytbl_cmd;
cmd_handler_t center_cmd;
cmd_handler_t centralizer_cmd;
cmd_handler_t close_cmd;
cmd_handler_t commsgr_cmd;
cmd_handler_t conjelt_cmd;
cmd_handler_t core_cmd;
cmd_handler_t cosets_cmd;
cmd_handler_t cycsgr_cmd;
cmd_handler_t dirprod_cmd;
cmd_handler_t find_id_cmd;
cmd_handler_t inn_cmd;
cmd_handler_t inverse_cmd;
cmd_handler_t iscyclic_cmd;
cmd_handler_t isring_cmd;
cmd_handler_t list_conj_cls_cmd;
cmd_handler_t list_elts_cmd;
cmd_handler_t maxord_cmd;
cmd_handler_t nilpotent_cmd;
cmd_handler_t normalizer_cmd;
cmd_handler_t normal_subring_cmd;
cmd_handler_t orbits_cmd;
cmd_handler_t order_cmd;
cmd_handler_t orders_cmd;
cmd_handler_t power_cmd;
cmd_handler_t powers_cmd;
cmd_handler_t powsgr_cmd;
cmd_handler_t solvable_cmd;
cmd_handler_t stabilizer_cmd;
cmd_handler_t subring_cmd;
cmd_handler_t torsion_cmd;

cmd_desc_t cmd_descs[] = {
	{ "abelian",          abelian_cmd },
	//{ "all_cjg",          all_cjg_cmd },
	{ "ascendant",        ascendant_cmd },
	{ "aut_ring",        aut_ring_cmd },
	{ "cap",              cap_cmd },
	{ "cayley_sn",        cayley_sn_cmd },
	{ "caytbl",           caytbl_cmd },
	{ "center",           center_cmd },
	{ "centralizer",      centralizer_cmd },
	{ "close",            close_cmd },
	{ "commsgr",          commsgr_cmd },
	{ "conjelt",          conjelt_cmd },
	{ "core",             core_cmd },
	{ "cosets",           cosets_cmd },
	{ "cycsgr",           cycsgr_cmd },
	{ "dirprod",          dirprod_cmd },
	{ "find_id",          find_id_cmd },
	{ "inn",              inn_cmd },
	{ "inverse",          inverse_cmd },
	{ "iscyclic",         iscyclic_cmd },
	{ "isring",          isring_cmd },
	{ "list_conj_cls",    list_conj_cls_cmd },
	{ "list_elts",        list_elts_cmd },
	{ "maxord",           maxord_cmd },
	{ "nilpotent",        nilpotent_cmd },
	{ "normalizer",       normalizer_cmd },
	{ "normal_subring",  normal_subring_cmd },
	{ "orbits",           orbits_cmd },
	{ "order",            order_cmd },
	{ "orders",           orders_cmd },
	{ "power",            power_cmd },
	{ "powers",           powers_cmd },
	{ "powsgr",           powsgr_cmd },
	{ "solvable",         solvable_cmd },
	{ "stabilizer",       stabilizer_cmd },
	{ "subring",         subring_cmd },
	{ "torsion",          torsion_cmd },
};
#define NUM_CMD_DESCS sizeof(cmd_descs) / sizeof(cmd_descs[0])

// ----------------------------------------------------------------
static void list_commands(void)
{
	int i;
	int point;
	int curlen;
	int term_width = 80;

	fprintf(stderr, "-- Commands:\n");
	point = 0;
	for (i = 0; i < NUM_CMD_DESCS; i++) {

		curlen = strlen(cmd_descs[i].desc);
		if (point != 0)
			curlen++;

		if (point + curlen >= term_width) {
			fprintf(stderr, "\n");
			fprintf(stderr, "%s", cmd_descs[i].desc);
			point = curlen;
		}
		else {
			if (point != 0)
				fprintf(stderr, " ");
			fprintf(stderr, "%s", cmd_descs[i].desc);
			point += curlen;
		}
	}
	if (point != 0)
		fprintf(stderr, "\n");
}

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr,
		"Usage: %s {cmd} {ring spec} {ring args ...}\n",
		argv0);
	printf("\n");
	list_commands();
	printf("\n");
	list_ring_specs();
	printf("\n");
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int i;

	if (argc < 2)
		usage(argv[0]);
	if (strcmp(argv[1], "--help") == 0)
		usage(argv[0]);
	if (strcmp(argv[1], "list") == 0) {
		list_ring_specs();
		exit(1);
	}

	for (i = 0; i < NUM_CMD_DESCS; i++) {
		if (strcmp(argv[1], cmd_descs[i].desc) == 0)
			return cmd_descs[i].phdlr(argc-1, argv+1);
	}
	printf("Command \"%s\" not found.  Try \"%s --help\" for help.\n",
		argv[1], argv[0]);
	// xxx ring names --classes option
	// xxx cmd   names --cmds option
	// --help option
	return 0;
}
