#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "zppolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {r}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int p;
	zpoly_t z;
	int argi, argp = 1;
	char * prim_string     = "PRIMITIVE";
	char * irr_string      = "IRREDUCIBLE";
	char * red_string      = "reducible";

	if ((argc >= 2) && (strcmp(argv[1], "-b") == 0)) {
		prim_string     = "P";
		irr_string      = "I";
		red_string      = "r";
		argp++;
	}

	if ((argc - argp) < 2)
		usage(argv[0]);

	if (sscanf(argv[argp], "%d", &p) != 1)
		usage(argv[0]);

	for (argi = argp + 1; argi < argc; argi++) {
		if (!zppoly_scan(&z, argv[argi], p))
			usage(argv[0]);

		zppoly_print(&z, p);
		printf(" ");
		if (zppoly_is_irreducible(&z, p)) {
			if (zppoly_is_primitive(&z, p, z.degree))
				printf("%s", prim_string);
			else
				printf("%s", irr_string);
		}
		else {
			printf("%s", red_string);
		}
		printf("\n");
	}

	return 0;
}
