#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2polymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi;
	z2poly_t z;
	char * prim_string     = "PRIMITIVE";
	char * irr_string      = "IRREDUCIBLE";
	char * red_string      = "reducible";
	char * rootful_string  = "has a root";
	int check_primitive = 1;

	if (argc < 2)
		usage(argv[0]);

	for (argi = 1; argi < argc; argi++) {
		if (strcmp(argv[argi], "-b") == 0) {
			prim_string     = "P";
			irr_string      = "I";
			red_string      = "r";
			rootful_string  = "l";
			continue;
		}
		if (strcmp(argv[argi], "-np") == 0) {
			check_primitive = 0;
			continue;
		}

		if (!z2poly_scan(&z, argv[argi]))
			usage(argv[0]);

		z2poly_print(&z);
		printf(" ");
		if (z2poly_is_rootless(&z)) {
			if (z2poly_is_irreducible(&z)) {
				fflush(stdout);
				if (check_primitive && z2poly_is_primitive(&z))
					printf("%s", prim_string);
				else
					printf("%s", irr_string);
			}
			else {
				printf("%s", red_string);
			}
		}
		else {
			printf("%s", rootful_string);
		}
		printf("\n");
	}

	return 0;
}
