#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi;
	z2ipoly_t z;
	char * prim_string     = "PRIMITIVE";
	char * irr_string      = "IRREDUCIBLE";
	char * red_string      = "reducible";
	char * rootful_string  = "has a root";

	if (argc < 2)
		usage(argv[0]);

	for (argi = 1; argi < argc; argi++) {
		if (strcmp(argv[argi], "-b") == 0) {
			prim_string     = "P";
			irr_string      = "I";
			red_string      = "r";
			rootful_string  = "l";
			continue;
		}

		if (sscanf(argv[argi], "%llx", &z) != 1)
			usage(argv[0]);

		z2ipoly_print(z);
		printf(" ");
		if (z2ipoly_is_rootless(z)) {
			if (z2ipoly_is_irreducible(z)) {
				fflush(stdout);
				if (z2ipoly_is_primitive(z))
					printf("%s", prim_string);
				else
					printf("%s", irr_string);
			}
			else {
				printf("%s", red_string);
			}
		}
		else {
			printf("%s", rootful_string);
		}
		printf("\n");
	}

	return 0;
}
