#include <stdio.h>
#include <stdlib.h>
#include "z3polymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z3poly_t z;

	if (argc != 2)
		usage(argv[0]);
	if (!z3poly_scan(&z, argv[1]))
		usage(argv[0]);

	z3poly_print(&z);
	printf(" ");
	if (z3poly_is_rootless(&z)) {
		if (z3poly_is_irreducible(&z)) {
			printf("IRREDUCIBLE");
		}
		else {
			printf("reducible");
		}
	}
	else {
		// xxx temp printf("has a root");
	}
	printf("\n");

	return 0;
}
