#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2nipolymod.h"
#include "power.h"
#include "mod.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
// for each of 64 possible reductors r
//   for each of 64 possible generators g
//     if g^9 mod r == 0:2
//       wahoo!

void seek_alpha(void)
{
	z2ipoly_t r = 0xb;
	z2ipoly_t i, j, k;
	z2nipoly_t g, rr, gpow1, gpow2;
	z2nipoly_t gwant1 = z2nipoly_from_coeffs1(0LL, 2LL);
	z2nipoly_t gwant2 = z2nipoly_from_coeffs1(1LL, 0LL);
	int power1 =  9;
	int power2 = 21;

	for (i = 0; i < 64; i++) {
		rr = z2nipoly_from_coeffs2(1LL, i >> 3, i & 7LL);
		for (j = 0; j < 64; j++) {
			g = z2nipoly_from_coeffs1(j >> 3, j & 7LL);
			gpow1 = z2nipolymod_power(&g, power1, &rr, r);
			gpow2 = z2nipolymod_power(&g, power2, &rr, r);

			if ((z2nipoly_equal(&gpow1, &gwant1, r))
			&& (z2nipoly_equal(&gpow2, &gwant2, r))) {
			//}
			//{
				printf("rr=");
				z2nipoly_print(&rr, r);
				printf(" g=");
				z2nipoly_print(&g, r);
				printf(" g^%d=", power1);
				z2nipoly_print(&gpow1, r);
				printf(" gp^%d=", power2);
				z2nipoly_print(&gpow2, r);
				printf("\n");

#if 1
				for (k = 0; k < 64; k++) {
					z2nipoly_t gpow = z2nipolymod_power(
						&g, k, &rr, r);
					z2nipoly_print(&g, r);
					printf("^%d = ", (int)k);
					z2nipoly_print(&gpow, r);
					printf("\n");
				}
				printf("\n");
#endif

			}
		}
		//printf("\n");
	}
}

// ----------------------------------------------------------------
void test_alpha(void)
{
//rr=1:1:1 g=2:7 gpow1=2 gpow2=1:0
//rr=1:1:1 g=5:2 gpow1=2 gpow2=1:0
//rr=1:1:1 g=7:5 gpow1=2 gpow2=1:0
	z2ipoly_t r = 0xb;
	z2nipoly_t rr = z2nipoly_from_coeffs2(1LL, 1LL, 1LL);
	z2nipoly_t  g = z2nipoly_from_coeffs1(2LL, 7LL);
	z2nipoly_t  gpow;
	int i;

	for (i = 0; i < 64; i++) {
		gpow = z2nipolymod_power(&g, i, &rr, r);
		z2nipoly_print(&gpow, r);
		printf("\n");
	}
}

// ----------------------------------------------------------------
// for each of 64 possible reductors r
//   for each of 64 possible generators g
//     if g^9 mod r == 0:2
//       wahoo!

void seek_beta(void)
{
	z2ipoly_t r = 0x7;
	z2ipoly_t i, j, k;
	z2nipoly_t g, rr, gpow1, gpow2;
	z2nipoly_t gwant1 = z2nipoly_from_coeffs2(0LL, 1LL, 0LL);
	z2nipoly_t gwant2 = z2nipoly_from_coeffs2(0LL, 0LL, 2LL);
	int power1 =  9;
	int power2 = 21;

	for (i = 0; i < 64; i++) {
		rr = z2nipoly_from_coeffs3(1LL, (i >> 4) & 3, (i >> 2) & 3, i & 3);
		for (j = 0; j < 64; j++) {
			g = z2nipoly_from_coeffs2((j >> 4) & 3, (j >> 2) & 3, j & 3);
			gpow1 = z2nipolymod_power(&g, power1, &rr, r);
			gpow2 = z2nipolymod_power(&g, power2, &rr, r);

			if ((z2nipoly_equal(&gpow1, &gwant1, r))
			&& (z2nipoly_equal(&gpow2, &gwant2, r))) {
			//}
			//{
				printf("rr=");
				z2nipoly_print(&rr, r);
				printf(" g=");
				z2nipoly_print(&g, r);
				printf(" g^%d=", power1);
				z2nipoly_print(&gpow1, r);
				printf(" gp^%d=", power2);
				z2nipoly_print(&gpow2, r);
				printf("\n");

#if 1
				for (k = 0; k < 64; k++) {
					z2nipoly_t gpow = z2nipolymod_power(
						&g, k, &rr, r);
					z2nipoly_print(&g, r);
					printf("^%d = ", (int)k);
					z2nipoly_print(&gpow, r);
					printf("\n");
				}
				printf("\n");
#endif

			}
		}
		//printf("\n");
	}
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	if (argc == 1)
		seek_alpha();
	else
		seek_beta();

	return 0;
}
