LIBDIR=../../../bin/alg
BINDIR=../../../bin/alg
INC=-I../containers -I../containers/group -I ../containers/ring -I../data_types -I../utils
LIB=-L$(LIBDIR) -lkalg -lm
CC=gcc -O3 -s -Wall

all: build_lib \
  $(BINDIR)/b27to3 $(BINDIR)/b3to27 $(BINDIR)/divs2 $(BINDIR)/divs2i \
  $(BINDIR)/divsn $(BINDIR)/divsnll $(BINDIR)/divsp $(BINDIR)/f2nisplit \
  $(BINDIR)/f2nsplit $(BINDIR)/f3nsplit $(BINDIR)/fpnsplit \
  $(BINDIR)/z2factor $(BINDIR)/z2ifactor $(BINDIR)/z2nifactor \
  $(BINDIR)/z2nfactor $(BINDIR)/factor2slow $(BINDIR)/z3factor \
  $(BINDIR)/z2itaps $(BINDIR)/factor32 $(BINDIR)/factor64 \
  $(BINDIR)/factorg3 $(BINDIR)/zpfactor $(BINDIR)/z2irr \
  $(BINDIR)/z2imrr $(BINDIR)/zprr $(BINDIR)/zpmrr $(BINDIR)/z2nirr \
  $(BINDIR)/z2nieval $(BINDIR)/zpnfactor $(BINDIR)/zpnufactor \
  $(BINDIR)/factorpslow $(BINDIR)/factortest $(BINDIR)/findisom \
  $(BINDIR)/findisom2 $(BINDIR)/findisom3 $(BINDIR)/z2iallsums \
  $(BINDIR)/lfe $(BINDIR)/lfe2i $(BINDIR)/lfe2ni $(BINDIR)/lfe3 \
  $(BINDIR)/listdivisors $(BINDIR)/listprimes $(BINDIR)/isprime \
  $(BINDIR)/zppolylist $(BINDIR)/z2ipolylist $(BINDIR)/z3polylist \
  $(BINDIR)/z2nipolylist $(BINDIR)/zpnpolylist $(BINDIR)/Pe \
  $(BINDIR)/Pe2 $(BINDIR)/ricjcompl $(BINDIR)/ricjcompl2 \
  $(BINDIR)/ricjcompl3 $(BINDIR)/testirr $(BINDIR)/testirr2 \
  $(BINDIR)/testirr2i $(BINDIR)/testirr3 $(BINDIR)/Up $(BINDIR)/Up2 \
  $(BINDIR)/z2add $(BINDIR)/z2deg $(BINDIR)/z2div $(BINDIR)/z2mod \
  $(BINDIR)/z2eval $(BINDIR)/z2gcd $(BINDIR)/z2iadd $(BINDIR)/z2ideriv \
  $(BINDIR)/z2idisc $(BINDIR)/z2idiv $(BINDIR)/z2igcd $(BINDIR)/z2ilog \
  $(BINDIR)/z2imdiv $(BINDIR)/z2imeval $(BINDIR)/z2immul \
  $(BINDIR)/z2impow $(BINDIR)/z2imul $(BINDIR)/z2imrecip \
  $(BINDIR)/z2ipow $(BINDIR)/z2meval $(BINDIR)/z2mmul $(BINDIR)/z2mpow \
  $(BINDIR)/z2mul $(BINDIR)/z2pow $(BINDIR)/z3add $(BINDIR)/z3disc \
  $(BINDIR)/z3log $(BINDIR)/z3meval $(BINDIR)/z3mmul $(BINDIR)/z3mpow \
  $(BINDIR)/z3mul $(BINDIR)/z3pow $(BINDIR)/zpderiv $(BINDIR)/zpdisc \
  $(BINDIR)/zpdiv $(BINDIR)/zpeval $(BINDIR)/zpmeval $(BINDIR)/zpgcd \
  $(BINDIR)/zplog $(BINDIR)/zpmonic $(BINDIR)/zpmpow $(BINDIR)/zpadd \
  $(BINDIR)/zpmul $(BINDIR)/zpnop $(BINDIR)/zpop $(BINDIR)/zpop2 \
  $(BINDIR)/zpop2i $(BINDIR)/zpop3 $(BINDIR)/zppow $(BINDIR)/zpmmul \
  $(BINDIR)/exts2i $(BINDIR)/exts3 $(BINDIR)/exts $(BINDIR)/listcompl2 \
  $(BINDIR)/listcompl3 $(BINDIR)/listcompl $(BINDIR)/c2i $(BINDIR)/i2c \
  $(BINDIR)/i2ct $(BINDIR)/c2ct $(BINDIR)/pmtmul $(BINDIR)/pmtcmul \
  $(BINDIR)/pmtinv $(BINDIR)/pmtcinv $(BINDIR)/riaut2i $(BINDIR)/riaut3 \
  $(BINDIR)/riaut $(BINDIR)/mcpq $(BINDIR)/mcpqprod $(BINDIR)/frobrep \
  $(BINDIR)/z2niorbit $(BINDIR)/z2iorbit $(BINDIR)/z2iorder \
  $(BINDIR)/z2iring $(BINDIR)/zpring $(BINDIR)/zpnorbit $(BINDIR)/padx \
  $(BINDIR)/srm $(BINDIR)/pgen $(BINDIR)/frobord2i $(BINDIR)/z2nimin \
  $(BINDIR)/z2nmin $(BINDIR)/z2nicvt $(BINDIR)/z2ncvt $(BINDIR)/zpncvt \
  $(BINDIR)/fpchart $(BINDIR)/f2ichart $(BINDIR)/zpmquots \
  $(BINDIR)/z2imquots $(BINDIR)/zmmul $(BINDIR)/zmpower \
  $(BINDIR)/zmorder $(BINDIR)/zm2order $(BINDIR)/zmorbit \

build_lib:
	make -f libkalg.mk

$(BINDIR)/b27to3: b27to3.c
	$(CC) $(INC) b27to3.c $(LIB) -o $(BINDIR)/b27to3

$(BINDIR)/b3to27: b3to27.c
	$(CC) $(INC) b3to27.c $(LIB) -o $(BINDIR)/b3to27

$(BINDIR)/divs2: divs2.c
	$(CC) $(INC) divs2.c $(LIB) -o $(BINDIR)/divs2

$(BINDIR)/divs2i: divs2i.c
	$(CC) $(INC) divs2i.c $(LIB) -o $(BINDIR)/divs2i

$(BINDIR)/divsn: divsn.c
	$(CC) $(INC) divsn.c $(LIB) -o $(BINDIR)/divsn

$(BINDIR)/divsnll: divsnll.c
	$(CC) $(INC) divsnll.c $(LIB) -o $(BINDIR)/divsnll

$(BINDIR)/divsp: divsp.c
	$(CC) $(INC) divsp.c $(LIB) -o $(BINDIR)/divsp

$(BINDIR)/f2nisplit: f2nisplit.c
	$(CC) $(INC) f2nisplit.c $(LIB) -o $(BINDIR)/f2nisplit

$(BINDIR)/f2nsplit: f2nsplit.c
	$(CC) $(INC) f2nsplit.c $(LIB) -o $(BINDIR)/f2nsplit

$(BINDIR)/f3nsplit: f3nsplit.c
	$(CC) $(INC) f3nsplit.c $(LIB) -o $(BINDIR)/f3nsplit

$(BINDIR)/fpnsplit: fpnsplit.c
	$(CC) $(INC) fpnsplit.c $(LIB) -o $(BINDIR)/fpnsplit

$(BINDIR)/z2factor: z2factor.c
	$(CC) $(INC) z2factor.c $(LIB) -o $(BINDIR)/z2factor

$(BINDIR)/z2ifactor: z2ifactor.c
	$(CC) $(INC) z2ifactor.c $(LIB) -o $(BINDIR)/z2ifactor

$(BINDIR)/z2nifactor: z2nifactor.c
	$(CC) $(INC) z2nifactor.c $(LIB) -o $(BINDIR)/z2nifactor

$(BINDIR)/z2nfactor: z2nfactor.c
	$(CC) $(INC) z2nfactor.c $(LIB) -o $(BINDIR)/z2nfactor

$(BINDIR)/factor2slow: factor2slow.c
	$(CC) $(INC) factor2slow.c $(LIB) -o $(BINDIR)/factor2slow

$(BINDIR)/z3factor: z3factor.c
	$(CC) $(INC) z3factor.c $(LIB) -o $(BINDIR)/z3factor

$(BINDIR)/z2itaps: z2itaps.c
	$(CC) $(INC) z2itaps.c $(LIB) -o $(BINDIR)/z2itaps

$(BINDIR)/factor32: factor32.c
	$(CC) $(INC) factor32.c $(LIB) -o $(BINDIR)/factor32

$(BINDIR)/factor64: factor64.c
	$(CC) $(INC) factor64.c $(LIB) -o $(BINDIR)/factor64

$(BINDIR)/factorg3: factorg3.c
	$(CC) $(INC) factorg3.c $(LIB) -o $(BINDIR)/factorg3

$(BINDIR)/zpfactor: zpfactor.c
	$(CC) $(INC) zpfactor.c $(LIB) -o $(BINDIR)/zpfactor

$(BINDIR)/z2irr: z2irr.c
	$(CC) $(INC) z2irr.c $(LIB) -o $(BINDIR)/z2irr

$(BINDIR)/z2imrr: z2imrr.c
	$(CC) $(INC) z2imrr.c $(LIB) -o $(BINDIR)/z2imrr

$(BINDIR)/zprr: zprr.c
	$(CC) $(INC) zprr.c $(LIB) -o $(BINDIR)/zprr

$(BINDIR)/zpmrr: zpmrr.c
	$(CC) $(INC) zpmrr.c $(LIB) -o $(BINDIR)/zpmrr

$(BINDIR)/z2nirr: z2nirr.c
	$(CC) $(INC) z2nirr.c $(LIB) -o $(BINDIR)/z2nirr

$(BINDIR)/z2nieval: z2nieval.c
	$(CC) $(INC) z2nieval.c $(LIB) -o $(BINDIR)/z2nieval

$(BINDIR)/zpnfactor: zpnfactor.c
	$(CC) $(INC) zpnfactor.c $(LIB) -o $(BINDIR)/zpnfactor

$(BINDIR)/zpnufactor: zpnufactor.c
	$(CC) $(INC) zpnufactor.c $(LIB) -o $(BINDIR)/zpnufactor

$(BINDIR)/factorpslow: factorpslow.c
	$(CC) $(INC) factorpslow.c $(LIB) -o $(BINDIR)/factorpslow

$(BINDIR)/factortest: factortest.c
	$(CC) $(INC) factortest.c $(LIB) -o $(BINDIR)/factortest

$(BINDIR)/findisom: findisom.c
	$(CC) $(INC) findisom.c $(LIB) -o $(BINDIR)/findisom

$(BINDIR)/findisom2: findisom2.c
	$(CC) $(INC) findisom2.c $(LIB) -o $(BINDIR)/findisom2

$(BINDIR)/findisom3: findisom3.c
	$(CC) $(INC) findisom3.c $(LIB) -o $(BINDIR)/findisom3

$(BINDIR)/z2iallsums: z2iallsums.c
	$(CC) $(INC) z2iallsums.c $(LIB) -o $(BINDIR)/z2iallsums

$(BINDIR)/lfe: lfe.c
	$(CC) $(INC) lfe.c $(LIB) -o $(BINDIR)/lfe

$(BINDIR)/lfe2i: lfe2i.c
	$(CC) $(INC) lfe2i.c $(LIB) -o $(BINDIR)/lfe2i

$(BINDIR)/lfe2ni: lfe2ni.c
	$(CC) $(INC) lfe2ni.c $(LIB) -o $(BINDIR)/lfe2ni

$(BINDIR)/lfe3: lfe3.c
	$(CC) $(INC) lfe3.c $(LIB) -o $(BINDIR)/lfe3

$(BINDIR)/listdivisors: listdivisors.c
	$(CC) $(INC) listdivisors.c $(LIB) -o $(BINDIR)/listdivisors

$(BINDIR)/listprimes: listprimes.c
	$(CC) $(INC) listprimes.c $(LIB) -o $(BINDIR)/listprimes

$(BINDIR)/isprime: isprime.c
	$(CC) $(INC) isprime.c $(LIB) -o $(BINDIR)/isprime

$(BINDIR)/zppolylist: zppolylist.c
	$(CC) $(INC) zppolylist.c $(LIB) -o $(BINDIR)/zppolylist

$(BINDIR)/z2ipolylist: z2ipolylist.c
	$(CC) $(INC) z2ipolylist.c $(LIB) -o $(BINDIR)/z2ipolylist

$(BINDIR)/z3polylist: z3polylist.c
	$(CC) $(INC) z3polylist.c $(LIB) -o $(BINDIR)/z3polylist

$(BINDIR)/z2nipolylist: z2nipolylist.c
	$(CC) $(INC) z2nipolylist.c $(LIB) -o $(BINDIR)/z2nipolylist

$(BINDIR)/zpnpolylist: zpnpolylist.c
	$(CC) $(INC) zpnpolylist.c $(LIB) -o $(BINDIR)/zpnpolylist

$(BINDIR)/Pe: Pe.c
	$(CC) $(INC) Pe.c $(LIB) -o $(BINDIR)/Pe

$(BINDIR)/Pe2: Pe2.c
	$(CC) $(INC) Pe2.c $(LIB) -o $(BINDIR)/Pe2

$(BINDIR)/ricjcompl: ricjcompl.c
	$(CC) $(INC) ricjcompl.c $(LIB) -o $(BINDIR)/ricjcompl

$(BINDIR)/ricjcompl2: ricjcompl2.c
	$(CC) $(INC) ricjcompl2.c $(LIB) -o $(BINDIR)/ricjcompl2

$(BINDIR)/ricjcompl3: ricjcompl3.c
	$(CC) $(INC) ricjcompl3.c $(LIB) -o $(BINDIR)/ricjcompl3

$(BINDIR)/testirr: testirr.c
	$(CC) $(INC) testirr.c $(LIB) -o $(BINDIR)/testirr

$(BINDIR)/testirr2: testirr2.c
	$(CC) $(INC) testirr2.c $(LIB) -o $(BINDIR)/testirr2

$(BINDIR)/testirr2i: testirr2i.c
	$(CC) $(INC) testirr2i.c $(LIB) -o $(BINDIR)/testirr2i

$(BINDIR)/testirr3: testirr3.c
	$(CC) $(INC) testirr3.c $(LIB) -o $(BINDIR)/testirr3

$(BINDIR)/Up: Up.c
	$(CC) $(INC) Up.c $(LIB) -o $(BINDIR)/Up

$(BINDIR)/Up2: Up2.c
	$(CC) $(INC) Up2.c $(LIB) -o $(BINDIR)/Up2

$(BINDIR)/z2add: z2add.c
	$(CC) $(INC) z2add.c $(LIB) -o $(BINDIR)/z2add

$(BINDIR)/z2deg: z2deg.c
	$(CC) $(INC) z2deg.c $(LIB) -o $(BINDIR)/z2deg

$(BINDIR)/z2div: z2div.c
	$(CC) $(INC) z2div.c $(LIB) -o $(BINDIR)/z2div

$(BINDIR)/z2mod: z2mod.c
	$(CC) $(INC) z2mod.c $(LIB) -o $(BINDIR)/z2mod

$(BINDIR)/z2eval: z2eval.c
	$(CC) $(INC) z2eval.c $(LIB) -o $(BINDIR)/z2eval

$(BINDIR)/z2gcd: z2gcd.c
	$(CC) $(INC) z2gcd.c $(LIB) -o $(BINDIR)/z2gcd

$(BINDIR)/z2iadd: z2iadd.c
	$(CC) $(INC) z2iadd.c $(LIB) -o $(BINDIR)/z2iadd

$(BINDIR)/z2ideriv: z2ideriv.c
	$(CC) $(INC) z2ideriv.c $(LIB) -o $(BINDIR)/z2ideriv

$(BINDIR)/z2idisc: z2idisc.c
	$(CC) $(INC) z2idisc.c $(LIB) -o $(BINDIR)/z2idisc

$(BINDIR)/z2idiv: z2idiv.c
	$(CC) $(INC) z2idiv.c $(LIB) -o $(BINDIR)/z2idiv

$(BINDIR)/z2igcd: z2igcd.c
	$(CC) $(INC) z2igcd.c $(LIB) -o $(BINDIR)/z2igcd

$(BINDIR)/z2ilog: z2ilog.c
	$(CC) $(INC) z2ilog.c $(LIB) -o $(BINDIR)/z2ilog

$(BINDIR)/z2imdiv: z2imdiv.c
	$(CC) $(INC) z2imdiv.c $(LIB) -o $(BINDIR)/z2imdiv

$(BINDIR)/z2imeval: z2imeval.c
	$(CC) $(INC) z2imeval.c $(LIB) -o $(BINDIR)/z2imeval

$(BINDIR)/z2immul: z2immul.c
	$(CC) $(INC) z2immul.c $(LIB) -o $(BINDIR)/z2immul

$(BINDIR)/z2impow: z2impow.c
	$(CC) $(INC) z2impow.c $(LIB) -o $(BINDIR)/z2impow

$(BINDIR)/z2imul: z2imul.c
	$(CC) $(INC) z2imul.c $(LIB) -o $(BINDIR)/z2imul

$(BINDIR)/z2imrecip: z2imrecip.c
	$(CC) $(INC) z2imrecip.c $(LIB) -o $(BINDIR)/z2imrecip

$(BINDIR)/z2ipow: z2ipow.c
	$(CC) $(INC) z2ipow.c $(LIB) -o $(BINDIR)/z2ipow

$(BINDIR)/z2meval: z2meval.c
	$(CC) $(INC) z2meval.c $(LIB) -o $(BINDIR)/z2meval

$(BINDIR)/z2mmul: z2mmul.c
	$(CC) $(INC) z2mmul.c $(LIB) -o $(BINDIR)/z2mmul

$(BINDIR)/z2mpow: z2mpow.c
	$(CC) $(INC) z2mpow.c $(LIB) -o $(BINDIR)/z2mpow

$(BINDIR)/z2mul: z2mul.c
	$(CC) $(INC) z2mul.c $(LIB) -o $(BINDIR)/z2mul

$(BINDIR)/z2pow: z2pow.c
	$(CC) $(INC) z2pow.c $(LIB) -o $(BINDIR)/z2pow

$(BINDIR)/z3add: z3add.c
	$(CC) $(INC) z3add.c $(LIB) -o $(BINDIR)/z3add

$(BINDIR)/z3disc: z3disc.c
	$(CC) $(INC) z3disc.c $(LIB) -o $(BINDIR)/z3disc

$(BINDIR)/z3log: z3log.c
	$(CC) $(INC) z3log.c $(LIB) -o $(BINDIR)/z3log

$(BINDIR)/z3meval: z3meval.c
	$(CC) $(INC) z3meval.c $(LIB) -o $(BINDIR)/z3meval

$(BINDIR)/z3mmul: z3mmul.c
	$(CC) $(INC) z3mmul.c $(LIB) -o $(BINDIR)/z3mmul

$(BINDIR)/z3mpow: z3mpow.c
	$(CC) $(INC) z3mpow.c $(LIB) -o $(BINDIR)/z3mpow

$(BINDIR)/z3mul: z3mul.c
	$(CC) $(INC) z3mul.c $(LIB) -o $(BINDIR)/z3mul

$(BINDIR)/z3pow: z3pow.c
	$(CC) $(INC) z3pow.c $(LIB) -o $(BINDIR)/z3pow

$(BINDIR)/zpderiv: zpderiv.c
	$(CC) $(INC) zpderiv.c $(LIB) -o $(BINDIR)/zpderiv

$(BINDIR)/zpdisc: zpdisc.c
	$(CC) $(INC) zpdisc.c $(LIB) -o $(BINDIR)/zpdisc

$(BINDIR)/zpdiv: zpdiv.c
	$(CC) $(INC) zpdiv.c $(LIB) -o $(BINDIR)/zpdiv

$(BINDIR)/zpeval: zpeval.c
	$(CC) $(INC) zpeval.c $(LIB) -o $(BINDIR)/zpeval

$(BINDIR)/zpmeval: zpmeval.c
	$(CC) $(INC) zpmeval.c $(LIB) -o $(BINDIR)/zpmeval

$(BINDIR)/zpgcd: zpgcd.c
	$(CC) $(INC) zpgcd.c $(LIB) -o $(BINDIR)/zpgcd

$(BINDIR)/zplog: zplog.c
	$(CC) $(INC) zplog.c $(LIB) -o $(BINDIR)/zplog

$(BINDIR)/zpmonic: zpmonic.c
	$(CC) $(INC) zpmonic.c $(LIB) -o $(BINDIR)/zpmonic

$(BINDIR)/zpmpow: zpmpow.c
	$(CC) $(INC) zpmpow.c $(LIB) -o $(BINDIR)/zpmpow

$(BINDIR)/zpadd: zpadd.c
	$(CC) $(INC) zpadd.c $(LIB) -o $(BINDIR)/zpadd

$(BINDIR)/zpmul: zpmul.c
	$(CC) $(INC) zpmul.c $(LIB) -o $(BINDIR)/zpmul

$(BINDIR)/zpnop: zpnop.c
	$(CC) $(INC) zpnop.c $(LIB) -o $(BINDIR)/zpnop

$(BINDIR)/zpop: zpop.c
	$(CC) $(INC) zpop.c $(LIB) -o $(BINDIR)/zpop

$(BINDIR)/zpop2: zpop2.c
	$(CC) $(INC) zpop2.c $(LIB) -o $(BINDIR)/zpop2

$(BINDIR)/zpop2i: zpop2i.c
	$(CC) $(INC) zpop2i.c $(LIB) -o $(BINDIR)/zpop2i

$(BINDIR)/zpop3: zpop3.c
	$(CC) $(INC) zpop3.c $(LIB) -o $(BINDIR)/zpop3

$(BINDIR)/zppow: zppow.c
	$(CC) $(INC) zppow.c $(LIB) -o $(BINDIR)/zppow

$(BINDIR)/zpmmul: zpmmul.c
	$(CC) $(INC) zpmmul.c $(LIB) -o $(BINDIR)/zpmmul

$(BINDIR)/exts2i: exts2i.c
	$(CC) $(INC) exts2i.c $(LIB) -o $(BINDIR)/exts2i

$(BINDIR)/exts3: exts3.c
	$(CC) $(INC) exts3.c $(LIB) -o $(BINDIR)/exts3

$(BINDIR)/exts: exts.c
	$(CC) $(INC) exts.c $(LIB) -o $(BINDIR)/exts

$(BINDIR)/listcompl2: listcompl2.c
	$(CC) $(INC) listcompl2.c $(LIB) -o $(BINDIR)/listcompl2

$(BINDIR)/listcompl3: listcompl3.c
	$(CC) $(INC) listcompl3.c $(LIB) -o $(BINDIR)/listcompl3

$(BINDIR)/listcompl: listcompl.c
	$(CC) $(INC) listcompl.c $(LIB) -o $(BINDIR)/listcompl

$(BINDIR)/c2i: c2i.c
	$(CC) $(INC) c2i.c $(LIB) -o $(BINDIR)/c2i

$(BINDIR)/i2c: i2c.c
	$(CC) $(INC) i2c.c $(LIB) -o $(BINDIR)/i2c

$(BINDIR)/i2ct: i2ct.c
	$(CC) $(INC) i2ct.c $(LIB) -o $(BINDIR)/i2ct

$(BINDIR)/c2ct: c2ct.c
	$(CC) $(INC) c2ct.c $(LIB) -o $(BINDIR)/c2ct

$(BINDIR)/pmtmul: pmtmul.c
	$(CC) $(INC) pmtmul.c $(LIB) -o $(BINDIR)/pmtmul

$(BINDIR)/pmtcmul: pmtcmul.c
	$(CC) $(INC) pmtcmul.c $(LIB) -o $(BINDIR)/pmtcmul

$(BINDIR)/pmtinv: pmtinv.c
	$(CC) $(INC) pmtinv.c $(LIB) -o $(BINDIR)/pmtinv

$(BINDIR)/pmtcinv: pmtcinv.c
	$(CC) $(INC) pmtcinv.c $(LIB) -o $(BINDIR)/pmtcinv

$(BINDIR)/riaut2i: riaut2i.c
	$(CC) $(INC) riaut2i.c $(LIB) -o $(BINDIR)/riaut2i

$(BINDIR)/riaut3: riaut3.c
	$(CC) $(INC) riaut3.c $(LIB) -o $(BINDIR)/riaut3

$(BINDIR)/riaut: riaut.c
	$(CC) $(INC) riaut.c $(LIB) -o $(BINDIR)/riaut

$(BINDIR)/mcpq: mcpq.c
	$(CC) $(INC) mcpq.c $(LIB) -o $(BINDIR)/mcpq

$(BINDIR)/mcpqprod: mcpqprod.c
	$(CC) $(INC) mcpqprod.c $(LIB) -o $(BINDIR)/mcpqprod

$(BINDIR)/frobrep: frobrep.c
	$(CC) $(INC) frobrep.c $(LIB) -o $(BINDIR)/frobrep

$(BINDIR)/z2niorbit: z2niorbit.c
	$(CC) $(INC) z2niorbit.c $(LIB) -o $(BINDIR)/z2niorbit

$(BINDIR)/z2iorbit: z2iorbit.c
	$(CC) $(INC) z2iorbit.c $(LIB) -o $(BINDIR)/z2iorbit

$(BINDIR)/z2iorder: z2iorder.c
	$(CC) $(INC) z2iorder.c $(LIB) -o $(BINDIR)/z2iorder

$(BINDIR)/z2iring: z2iring.c
	$(CC) $(INC) z2iring.c $(LIB) -o $(BINDIR)/z2iring

$(BINDIR)/zpring: zpring.c
	$(CC) $(INC) zpring.c $(LIB) -o $(BINDIR)/zpring

$(BINDIR)/zpnorbit: zpnorbit.c
	$(CC) $(INC) zpnorbit.c $(LIB) -o $(BINDIR)/zpnorbit

$(BINDIR)/padx: padx.c
	$(CC) $(INC) padx.c $(LIB) -o $(BINDIR)/padx

$(BINDIR)/srm: srm.c
	$(CC) $(INC) srm.c $(LIB) -o $(BINDIR)/srm

$(BINDIR)/pgen: pgen.c
	$(CC) $(INC) pgen.c $(LIB) -o $(BINDIR)/pgen

$(BINDIR)/frobord2i: frobord2i.c
	$(CC) $(INC) frobord2i.c $(LIB) -o $(BINDIR)/frobord2i

$(BINDIR)/z2nimin: z2nimin.c
	$(CC) $(INC) z2nimin.c $(LIB) -o $(BINDIR)/z2nimin

$(BINDIR)/z2nmin: z2nmin.c
	$(CC) $(INC) z2nmin.c $(LIB) -o $(BINDIR)/z2nmin

$(BINDIR)/z2nicvt: z2nicvt.c
	$(CC) $(INC) z2nicvt.c $(LIB) -o $(BINDIR)/z2nicvt

$(BINDIR)/z2ncvt: z2ncvt.c
	$(CC) $(INC) z2ncvt.c $(LIB) -o $(BINDIR)/z2ncvt

$(BINDIR)/zpncvt: zpncvt.c
	$(CC) $(INC) zpncvt.c $(LIB) -o $(BINDIR)/zpncvt

$(BINDIR)/fpchart: fpchart.c
	$(CC) $(INC) fpchart.c $(LIB) -o $(BINDIR)/fpchart

$(BINDIR)/f2ichart: f2ichart.c
	$(CC) $(INC) f2ichart.c $(LIB) -o $(BINDIR)/f2ichart

$(BINDIR)/zpmquots: zpmquots.c
	$(CC) $(INC) zpmquots.c $(LIB) -o $(BINDIR)/zpmquots

$(BINDIR)/z2imquots: z2imquots.c
	$(CC) $(INC) z2imquots.c $(LIB) -o $(BINDIR)/z2imquots

$(BINDIR)/zmmul: zmmul.c
	$(CC) $(INC) zmmul.c $(LIB) -o $(BINDIR)/zmmul

$(BINDIR)/zmpower: zmpower.c
	$(CC) $(INC) zmpower.c $(LIB) -o $(BINDIR)/zmpower

$(BINDIR)/zmorder: zmorder.c
	$(CC) $(INC) zmorder.c $(LIB) -o $(BINDIR)/zmorder

$(BINDIR)/zm2order: zm2order.c
	$(CC) $(INC) zm2order.c $(LIB) -o $(BINDIR)/zm2order

$(BINDIR)/zmorbit: zmorbit.c
	$(CC) $(INC) zmorbit.c $(LIB) -o $(BINDIR)/zmorbit

clean:
	@-rm -f $(BINDIR)/b27to3 $(BINDIR)/b3to27 $(BINDIR)/divs2
	@-rm -f $(BINDIR)/divs2i $(BINDIR)/divsn $(BINDIR)/divsnll
	@-rm -f $(BINDIR)/divsp $(BINDIR)/f2nisplit $(BINDIR)/f2nsplit
	@-rm -f $(BINDIR)/f3nsplit $(BINDIR)/fpnsplit $(BINDIR)/z2factor
	@-rm -f $(BINDIR)/z2ifactor $(BINDIR)/z2nifactor
	@-rm -f $(BINDIR)/z2nfactor $(BINDIR)/factor2slow
	@-rm -f $(BINDIR)/z3factor $(BINDIR)/z2itaps $(BINDIR)/factor32
	@-rm -f $(BINDIR)/factor64 $(BINDIR)/factorg3 $(BINDIR)/zpfactor
	@-rm -f $(BINDIR)/z2irr $(BINDIR)/z2imrr $(BINDIR)/zprr
	@-rm -f $(BINDIR)/zpmrr $(BINDIR)/z2nirr $(BINDIR)/z2nieval
	@-rm -f $(BINDIR)/zpnfactor $(BINDIR)/zpnufactor
	@-rm -f $(BINDIR)/factorpslow $(BINDIR)/factortest
	@-rm -f $(BINDIR)/findisom $(BINDIR)/findisom2 $(BINDIR)/findisom3
	@-rm -f $(BINDIR)/z2iallsums $(BINDIR)/lfe $(BINDIR)/lfe2i
	@-rm -f $(BINDIR)/lfe2ni $(BINDIR)/lfe3 $(BINDIR)/listdivisors
	@-rm -f $(BINDIR)/listprimes $(BINDIR)/isprime $(BINDIR)/zppolylist
	@-rm -f $(BINDIR)/z2ipolylist $(BINDIR)/z3polylist
	@-rm -f $(BINDIR)/z2nipolylist $(BINDIR)/zpnpolylist $(BINDIR)/Pe
	@-rm -f $(BINDIR)/Pe2 $(BINDIR)/ricjcompl $(BINDIR)/ricjcompl2
	@-rm -f $(BINDIR)/ricjcompl3 $(BINDIR)/testirr $(BINDIR)/testirr2
	@-rm -f $(BINDIR)/testirr2i $(BINDIR)/testirr3 $(BINDIR)/Up
	@-rm -f $(BINDIR)/Up2 $(BINDIR)/z2add $(BINDIR)/z2deg
	@-rm -f $(BINDIR)/z2div $(BINDIR)/z2mod $(BINDIR)/z2eval
	@-rm -f $(BINDIR)/z2gcd $(BINDIR)/z2iadd $(BINDIR)/z2ideriv
	@-rm -f $(BINDIR)/z2idisc $(BINDIR)/z2idiv $(BINDIR)/z2igcd
	@-rm -f $(BINDIR)/z2ilog $(BINDIR)/z2imdiv $(BINDIR)/z2imeval
	@-rm -f $(BINDIR)/z2immul $(BINDIR)/z2impow $(BINDIR)/z2imul
	@-rm -f $(BINDIR)/z2imrecip $(BINDIR)/z2ipow $(BINDIR)/z2meval
	@-rm -f $(BINDIR)/z2mmul $(BINDIR)/z2mpow $(BINDIR)/z2mul
	@-rm -f $(BINDIR)/z2pow $(BINDIR)/z3add $(BINDIR)/z3disc
	@-rm -f $(BINDIR)/z3log $(BINDIR)/z3meval $(BINDIR)/z3mmul
	@-rm -f $(BINDIR)/z3mpow $(BINDIR)/z3mul $(BINDIR)/z3pow
	@-rm -f $(BINDIR)/zpderiv $(BINDIR)/zpdisc $(BINDIR)/zpdiv
	@-rm -f $(BINDIR)/zpeval $(BINDIR)/zpmeval $(BINDIR)/zpgcd
	@-rm -f $(BINDIR)/zplog $(BINDIR)/zpmonic $(BINDIR)/zpmpow
	@-rm -f $(BINDIR)/zpadd $(BINDIR)/zpmul $(BINDIR)/zpnop
	@-rm -f $(BINDIR)/zpop $(BINDIR)/zpop2 $(BINDIR)/zpop2i
	@-rm -f $(BINDIR)/zpop3 $(BINDIR)/zppow $(BINDIR)/zpmmul
	@-rm -f $(BINDIR)/exts2i $(BINDIR)/exts3 $(BINDIR)/exts
	@-rm -f $(BINDIR)/listcompl2 $(BINDIR)/listcompl3
	@-rm -f $(BINDIR)/listcompl $(BINDIR)/c2i $(BINDIR)/i2c
	@-rm -f $(BINDIR)/i2ct $(BINDIR)/c2ct $(BINDIR)/pmtmul
	@-rm -f $(BINDIR)/pmtcmul $(BINDIR)/pmtinv $(BINDIR)/pmtcinv
	@-rm -f $(BINDIR)/riaut2i $(BINDIR)/riaut3 $(BINDIR)/riaut
	@-rm -f $(BINDIR)/mcpq $(BINDIR)/mcpqprod $(BINDIR)/frobrep
	@-rm -f $(BINDIR)/z2niorbit $(BINDIR)/z2iorbit $(BINDIR)/z2iorder
	@-rm -f $(BINDIR)/z2iring $(BINDIR)/zpring $(BINDIR)/zpnorbit
	@-rm -f $(BINDIR)/padx $(BINDIR)/srm $(BINDIR)/pgen
	@-rm -f $(BINDIR)/frobord2i $(BINDIR)/z2nimin $(BINDIR)/z2nmin
	@-rm -f $(BINDIR)/z2nicvt $(BINDIR)/z2ncvt $(BINDIR)/zpncvt
	@-rm -f $(BINDIR)/fpchart $(BINDIR)/f2ichart $(BINDIR)/zpmquots
	@-rm -f $(BINDIR)/z2imquots $(BINDIR)/zmmul $(BINDIR)/zmpower
	@-rm -f $(BINDIR)/zmorder $(BINDIR)/zm2order $(BINDIR)/zmorbit
