#include <stdio.h>
#include <stdlib.h>
#include "z2poly_factor.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi;
	z2poly_t r;

	if (argc < 2)
		usage(argv[0]);
	for (argi = 1; argi < argc; argi++) {
		if (!z2poly_scan(&r, argv[argi])) {
			fprintf(stderr, "%s: Couldn't parse \"%s\".\n",
				argv[0], argv[argi]);
			continue;
		}
		if (argc > 2) {
			z2poly_print(&r);
			printf(": ");
		}
		printf("%d\n", z2poly_get_degree(&r));
	}

	return 0;
}
