#include <stdio.h>
#include <stdlib.h>
#include "z2polymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {a} {b}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2poly_t a, b, q, r;

	if (argc != 3)
		usage(argv[0]);

	if (!z2poly_scan(&a, argv[1]))
		usage(argv[0]);
	if (!z2poly_scan(&b, argv[2]))
		usage(argv[0]);
	q = z2poly_div(&a, &b);
	r = z2poly_mod(&a, &b);
	z2poly_print(&q);
	if (!z2poly_equals_unsigned(&r, 0)) {
		printf(" REM ");
		z2poly_print(&r);
	}
	printf("\n");

	return 0;
}
