#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2polymod.h"
#include "isprime.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {r} {values ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2poly_t r, z, rz;
	int argi;

	if (argc < 2)
		usage(argv[0]);

	if (!z2poly_scan(&r, argv[1]))
		usage(argv[0]);

	for (argi = 2; argi < argc; argi++) {
		if (!z2poly_scan(&z, argv[argi])) {
			fprintf(stderr,
				"Couldn't parse \"%s\"; skipping.\n",
				argv[argi]);
			continue;
		}
		//z2poly_print(&z);
		//printf(": ");
		rz = z2poly_compose(&r, &z);
		z2poly_print(&rz);
		printf("\n");
	}

	return 0;
}
