#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "linescan.h"
#include "z2ipolymod.h"
#include "z2ilinalg.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi, n, i, j;
	int deg, maxdeg;
	z2ipoly_t * array;

	if (argc < 2)
		usage(argv[0]);

	n = argc - 1;
	array = malloc_check(n * sizeof(z2ipoly_t));

	for (argi = 1, i = 0; argi < argc; argi++, i++) {
		if (!z2ipoly_scan(&array[i], argv[argi])) {
			fprintf(stderr, "%s:  couldn't scan \"%s\"\n",
				argv[0], argv[argi]);
			exit(1);
		}
	}

	maxdeg = 0;
	for (i = 0; i < n; i++) {
		deg = z2ipoly_get_degree(array[i]);
		if (deg > maxdeg)
			maxdeg = deg;
	}
	maxdeg++;

	for (i = 0; i < n; i++) {
		for (j = i; j < n; j++) {
			z2ipoly_dprint(array[i] ^ array[j], maxdeg);
			printf("\n");
		}
	}

	free(array);
	return 0;
}
