#include <stdio.h>
#include <stdlib.h>
#include "z2nipoly_factor.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
z2ipoly_t z2ipolymod_discriminant(
	z2ipoly_t z,
	z2ipoly_t r)
{
	z2ipoly_t * roots = z2ipoly_get_roots(z, r);
	int deg = z2ipoly_get_degree(z);
	int i, j;
	z2ipoly_t diff;
	z2ipoly_t rv = 1LL;

	for (i = 0; i < deg; i++) {
		printf("%llx ", roots[i]);
	}
	printf("|");
	for (i = 0; i < deg; i++) {
		for (j = i+1; j < deg; j++) {
			diff = z2ipoly_sub(roots[i], roots[j]);
			//printf("[%llx-%llx=%llx]",
				//roots[i], roots[j], diff);
			printf(" %llx", diff);
			rv = z2ipolymod_mul(rv, diff, r);
		}
	}
	printf(" |");

	free(roots);
	return rv;
}

// ----------------------------------------------------------------
z2ipoly_t z2ipoly_discriminant(
	z2ipoly_t z,
	z2ipoly_t r)
{
	z2ipoly_t * roots = z2ipoly_get_roots(z, r);
	int deg = z2ipoly_get_degree(z);
	int i, j;
	z2ipoly_t diff;
	z2ipoly_t rv = 1LL;

	for (i = 0; i < deg; i++) {
		for (j = i+1; j < deg; j++) {
			diff = z2ipoly_sub(roots[i], roots[j]);
			rv = z2ipoly_mul(rv, diff);
		}
	}

	free(roots);
	return rv;
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t * r;
	z2ipoly_t resm;//, res;
	int numr, argi, i, j;

	if (argc < 2)
		usage(argv[0]);
	numr = argc - 1;
	r = malloc_check(numr * sizeof(z2ipoly_t));
	for (i = 0, argi = 1; argi < argc; i++, argi++) {
		if (!z2ipoly_scan(&r[i], argv[argi]))
			usage(argv[0]);
	}

	for (i = 0; i < numr; i++) {
		printf("%llx: ", r[i]);
		for (j = 0; j < numr; j++) {
			resm = z2ipolymod_discriminant(r[i], r[j]);
			//res  = z2ipoly_discriminant(r[i], r[j]);
			//printf("%llx %llx %llx %llx\n", r[i], r[j], resm,
			//	res);
		}
		printf("\n");
	}

	free(r);
	return 0;
}
