#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {r} {values ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t r, z, rz;
	int argi;

	if (argc < 2)
		usage(argv[0]);

	if (!z2ipoly_scan(&r, argv[1]))
		usage(argv[0]);

	for (argi = 2; argi < argc; argi++) {
		if (!z2ipoly_scan(&z, argv[argi])) {
			fprintf(stderr,
				"Couldn't parse \"%s\"; skipping.\n",
				argv[argi]);
			continue;
		}
		//z2ipoly_print(z);
		//printf(": ");
		rz = z2ipolymod_compose(r, z, r);
		z2ipoly_print(rz);
		printf("\n");
	}

	return 0;
}
