#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {r} {a} {b} ...\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t r, a, b, q;
	int argi;
	int fwd = 1;

	if (argc < 4)
		usage(argv[0]);
	if (!z2ipolymod_auxscan(&r, argv[1]))
		usage(argv[0]);

	for (argi = 2; argi < argc - 1; argi++) {
		if (strcmp(argv[argi], "-r") == 0) {
			fwd = 0;
			continue;
		}

		if (!z2ipoly_scan(&a, argv[argi]))
			usage(argv[0]);
		if (!z2ipoly_scan(&b, argv[argi+1]))
			usage(argv[0]);
		if (!fwd) {
			q = a;
			a = b;
			b = q;
		}
		q = z2ipolymod_div(b, a, r);

		z2ipolymod_print(b, r);
		printf(" / ");
		z2ipolymod_print(a, r);
		printf(" = ");
		z2ipolymod_print(q, r);
		printf("\n");
	}

	return 0;
}
