#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr,
		"Usage: %s {int r} {g}\n",
		argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t int_r;
	z2ipoly_t g, gpower;
	int n, pn1, i;
	int do_frobit = 0;

	if ((argc != 3) && (argc != 4))
		usage(argv[0]);
	if (!z2ipoly_scan(&int_r, argv[1]))
		usage(argv[0]);
	if (!z2ipoly_scan(&g, argv[2]))
		usage(argv[0]);
	if (argc == 4)
		do_frobit = 1;

	n = z2ipoly_get_degree(int_r);
	pn1 = (1 << n) - 1;

	gpower = g;
	for (i = 1; i <= pn1; i++) {
		printf("%3d: ", i);
		z2ipolymod_print(gpower, int_r);
		printf("\n");
		if (do_frobit)
			gpower = z2ipolymod_power(gpower, 2, int_r);
		else
			gpower = z2ipolymod_mul(gpower, g, int_r);
		if (gpower == g)
			break;
	}

	return 0;
}
