#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {a} {b} ...\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t a, b, q, r;
	int argi;

	if (argc < 3)
		usage(argv[0]);
	for (argi = 1; argi < argc - 1; argi++) {
		if (!z2ipoly_scan(&a, argv[argi]))
			usage(argv[0]);
		if (!z2ipoly_scan(&b, argv[argi+1]))
			usage(argv[0]);
		q = z2ipoly_div(a, b);
		r = z2ipoly_mod(a, b);
		z2ipoly_print(q);
		if (r != 0LL) {
			printf(" REM ");
			z2ipoly_print(r);
		}
		printf("\n");
	}

	return 0;
}
