#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "power.h"
#include "z2npoly_factor.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m or red} {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi, i;
	z2poly_t r;
	z2npoly_t z;
	static z2npoly_factor_info_t finfo;

	if (argc < 3)
		usage(argv[0]);

	if (!z2poly_scan(&r, argv[1]))
		usage(argv[0]);

	for (argi = 2; argi < argc; argi++) {
		if (!z2npoly_scan(&z, argv[argi], &r)) {
			fprintf(stderr, "Scan failure on \"%s\".\n",
				argv[argi]);
			continue;
		}

		if (z.degree == 0)
			z = z2npoly_extend_z2poly(&z.coeffs[0]);

		printf("Factoring ");
		z2npoly_print(&z, &r);
		printf(" over GF(2^%d)[X]:\n", z2poly_get_degree(&r));

		z2npoly_factor(&z, &r, &finfo);

		//z2npoly_print(&z, r);
		//printf(": ");
		for (i = 0; i < finfo.num_distinct; i++) {
			printf(" ");
			z2npoly_print(&finfo.factor_counts[i].f, &r);
			if (finfo.factor_counts[i].count > 1)
				printf("^%d", finfo.factor_counts[i].count);
			printf("\n");
		}
		printf("\n");
	}

	return 0;
}
