#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2nipoly.h"
#include "isprime.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {r} {poly} {scalars ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t r;
	z2nipoly_t f;
	z2ipoly_t a, b;
	int argi;

	if (argc < 4)
		usage(argv[0]);

	if (!z2ipoly_scan(&r, argv[1]))
		usage(argv[0]);
	if (!z2nipoly_scan(&f, argv[2], r))
		usage(argv[0]);

	for (argi = 3; argi < argc; argi++) {
		if (!z2ipoly_scan(&a, argv[argi])) {
			fprintf(stderr,
				"Couldn't parse \"%s\"; skipping.\n",
				argv[argi]);
			continue;
		}
		b = z2nipoly_eval(a, &f, r);
		z2ipoly_print(b);
		printf("\n");
	}

	return 0;
}
