#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "power.h"
#include "z2nipoly_factor.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m or red} {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi, i;
	z2ipoly_t r;
	z2nipoly_t z;
	static z2nipoly_factor_info_t finfo;

	if (argc < 3)
		usage(argv[0]);

	if (!z2ipoly_scan(&r, argv[1]))
		usage(argv[0]);

	for (argi = 2; argi < argc; argi++) {
		if (!z2nipoly_scan(&z, argv[argi], r)) {
			fprintf(stderr, "Scan failure on \"%s\".\n",
				argv[argi]);
			continue;
		}

		if (z.degree == 0)
			z = z2nipoly_extend_z2ipoly(z.coeffs[0]);

		printf("Factoring ");
		z2nipoly_print(&z, r);
		printf(" over GF(2^%d)[X]:\n", z2ipoly_get_degree(r));

		z2nipoly_factor(&z, r, &finfo);

		//z2nipoly_print(&z, r);
		//printf(": ");
		for (i = 0; i < finfo.num_distinct; i++) {
			printf(" ");
			z2nipoly_print(&finfo.factor_counts[i].f, r);
			if (finfo.factor_counts[i].count > 1)
				printf("^%d", finfo.factor_counts[i].count);
			printf("\n");
		}
		printf("\n");
	}

	return 0;
}
