#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2nipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr,
		"Usage: %s {int r} {ext r} {g}\n",
		argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t  int_r;
	z2nipoly_t ext_r, g, gpower;
	int d, m, n, pn1, i;
	int do_frobit = 0;

	if ((argc != 4) && (argc != 5))
		usage(argv[0]);
	if (!z2ipoly_scan(&int_r, argv[1]))
		usage(argv[0]);
	if (!z2nipoly_scan(&ext_r, argv[2], int_r))
		usage(argv[0]);
	if (!z2nipoly_scan(&g, argv[3], int_r))
		usage(argv[0]);
	if (argc == 5)
		do_frobit = 1;

	d = z2ipoly_get_degree(int_r);
	m = ext_r.degree;
	n = m * d;
	pn1 = (1 << n) - 1;

	gpower = g;
	for (i = 1; i <= pn1; i++) {
		printf("%3d: ", i);
		z2nipoly_print(&gpower, int_r);
		printf("\n");
		if (do_frobit)
			gpower = z2nipolymod_power(&gpower, 1<<d,
				&ext_r, int_r);
		else
			gpower = z2nipolymod_mul(&gpower, &g, &ext_r, int_r);
		if (z2nipoly_equal(&gpower, &g, int_r))
			break;
	}

	return 0;
}
