#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z3polymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z3poly_t c, a;
	int power;
	int argi;
	char * pcaret;

	if (argc < 2)
		usage(argv[0]);

	c = z3poly_from_base_rep(0);
	for (argi = 1; argi < argc; argi++) {
		pcaret = strchr(argv[argi], '^');
		if (pcaret) {
			*pcaret = 0;
			if (!sscanf(pcaret + 1, "%d", &power)) {
				usage(argv[0]);
			}
		}
		else {
			power = 1;
		}
		if (!z3poly_scan(&a, argv[argi]))
			usage(argv[0]);
		if (power != 1)
			a = z3poly_power(&a, power);
		c = z3poly_add(&c, &a);
	}
	z3poly_print(&c);
	printf("\n");

	return 0;
}
