#include <stdio.h>
#include <stdlib.h>
#include "z3npoly_factor.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
z3poly_t z3polymod_discriminant(
	z3poly_t * pz,
	z3poly_t * pr)
{
	z3poly_t * roots = z3poly_get_roots(pz, pr);
	int deg = z3poly_get_degree(pz);
	int i, j;
	z3poly_t diff;
	z3poly_t rv = z3poly_from_base_rep(1);

	for (i = 0; i < deg; i++) {
		z3poly_print(&roots[i]);
		printf(" ");
	}
	printf("|");
	for (i = 0; i < deg; i++) {
		for (j = i+1; j < deg; j++) {
			diff = z3poly_sub(&roots[i], &roots[j]);
			printf(" ");
			z3poly_print(&diff);
			rv = z3polymod_mul(&rv, &diff, pr);
		}
	}
	printf(" |");

	free(roots);
	return rv;
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z3poly_t * r;
	z3poly_t resm;//, res;
	int numr, argi, i, j;

	if (argc < 2)
		usage(argv[0]);
	numr = argc - 1;
	r = malloc_check(numr * sizeof(z3poly_t));
	for (i = 0, argi = 1; argi < argc; i++, argi++) {
		if (!z3poly_scan(&r[i], argv[argi]))
			usage(argv[0]);
	}

	for (i = 0; i < numr; i++) {
		z3poly_print(&r[i]);
		printf(": ");
		for (j = 0; j < numr; j++) {
			resm = z3polymod_discriminant(&r[i], &r[j]);
		}
		printf("\n");
	}

	free(r);
	return 0;
}
