#include <stdio.h>
#include <stdlib.h>
#include "z3poly_factor.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z3poly_t r;
	z3poly_factor_info_t finfo;
	int argi;
	int i;

	if (argc < 2)
		usage(argv[0]);
	for (argi = 1; argi < argc; argi++) {
		if (!z3poly_scan(&r, argv[argi]))
			usage(argv[0]);
		z3poly_factor(&r, &finfo);

		z3poly_print(&r);
		printf(": ");
		for (i = 0; i < finfo.num_distinct; i++) {
			printf(" ");
			z3poly_print(&finfo.factor_counts[i].f);
			if (finfo.factor_counts[i].count > 1)
				printf("^%d", finfo.factor_counts[i].count);
		}
		printf("\n");
	}

	return 0;
}
