#include <stdio.h>
#include <stdlib.h>
#include "z3polymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...} {g} {r}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z3poly_t a, g, r;
	int log;
	int argi;

	if (argc < 4)
		usage(argv[0]);
	if (!z3poly_scan(&g, argv[argc-2]))
		usage(argv[0]);
	if (!z3poly_scan(&r, argv[argc-1]))
		usage(argv[0]);

	for (argi = 1; argi < argc-2; argi++) {
		if (!z3poly_scan(&a, argv[argi]))
			usage(argv[0]);
		log = z3polymod_log(&a, &g, &r);
		printf("%d\n", log);
	}

	return 0;
}
