#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z3polymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {r} {values ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z3poly_t r, z, rz;
	int argi;

	if (argc < 2)
		usage(argv[0]);

	if (!z3poly_scan(&r, argv[1]))
		usage(argv[0]);

	for (argi = 2; argi < argc; argi++) {
		if (!z3poly_scan(&z, argv[argi])) {
			fprintf(stderr,
				"Couldn't parse \"%s\"; skipping.\n",
				argv[argi]);
			continue;
		}
		//z3poly_print(&z);
		//printf(": ");
		rz = z3polymod_compose(&r, &z, &r);
		z3poly_print(&rz);
		printf("\n");
	}

	return 0;
}
