#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z3polymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...} {r}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z3poly_t r, c, a;
	int power;
	int argi;
	char * pcaret;

	if (argc < 3)
		usage(argv[0]);
	if (!z3poly_scan(&r, argv[argc-1]))
		usage(argv[0]);

	c = z3poly_from_base_rep(1);
	for (argi = 1; argi < argc-1; argi++) {
		pcaret = strchr(argv[argi], '^');
		if (pcaret) {
			*pcaret = 0;
			if (!sscanf(pcaret + 1, "%d", &power)) {
				usage(argv[0]);
			}
		}
		else {
			power = 1;
		}
		if (!z3poly_scan(&a, argv[argi]))
			usage(argv[0]);
		if (power != 1)
			a = z3poly_power(&a, power);
		c = z3polymod_mul(&c, &a, &r);
	}
	z3poly_print(&c);
	printf("\n");

	return 0;
}
