#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z3polymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...} {e} {r}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z3poly_t c, a, r;
	int power;
	int argi;

	if (argc < 4)
		usage(argv[0]);
	if (sscanf(argv[argc-2], "%d", &power) != 1)
		usage(argv[0]);
	if (!z3poly_scan(&r, argv[argc-1]))
		usage(argv[0]);

	for (argi = 1; argi < argc-2; argi++) {
		if (!z3poly_scan(&a, argv[argi]))
			usage(argv[0]);
		c = z3polymod_power(&a, power, &r);
		z3poly_print(&c);
		printf("\n");
	}

	return 0;
}
