#include <stdio.h>
#include <stdlib.h>
#include "gcd.h"
#include "mod.h"
#include "posmod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m} {numbers ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi, a, ap, i, m;

	if (argc < 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &m) != 1)
		usage(argv[0]);

	for (argi = 2; argi < argc; argi++) {
		if (sscanf(argv[argi], "%d", &a) != 1)
			usage(argv[0]);

		if (calc_gcd_signed(a, m) != 1) {
			printf("%d\n", a);
		}
		else {
			a = posmod(a, m);
			ap = a;
			printf("%d", ap);
			for (i = 1; i <= m; i++) {
				ap *= a;
				ap %= m;
				if (ap == 1)
					break;
				printf(" %d", ap);
			}
			if (a != 1)
				printf(" %d", ap);
			printf("\n");
		}
	}

	return 0;
}
