#include <stdio.h>
#include <stdlib.h>
#include "gcd.h"
#include "mod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m} {numbers ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi;
	long long a, m, order;

	if (argc < 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%lld", &m) != 1)
		usage(argv[0]);

	for (argi = 2; argi < argc; argi++) {
		if (sscanf(argv[argi], "%lld", &a) != 1)
			usage(argv[0]);
		if (calc_gcd_signed_ll(a, m) != 1LL) {
			order = 0;
		}
		else {
			order = mod64_mul_order(a, m);
		}
		if (argc > 3)
			printf("%lld: ", a);
		printf("%lld\n", order);
	}

	return 0;
}
