#include <stdio.h>
#include <stdlib.h>
#include "zppolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int p;
	zpoly_t a, d;
	int argi;

	if (argc < 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);

	for (argi = 2; argi < argc; argi++) {
		if (!zppoly_scan(&a, argv[argi], p))
			usage(argv[0]);
		d = zppoly_deriv(&a, p);
		zppoly_print(&d, p);
		printf("\n");
	}

	return 0;
}
