#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "zppolymod.h"
#include "isprime.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {r} [values]\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int p, argi;
	zpoly_t r, z, rz;

	if (argc < 4)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);
	if (!zppoly_scan(&r, argv[2], p))
		usage(argv[0]);

	for (argi = 3; argi < argc; argi++) {
		if (!zppoly_scan(&z, argv[argi], p)) {
			fprintf(stderr,
				"Couldn't parse \"%s\"; skipping.\n",
				argv[argi]);
			continue;
		}
		//zppoly_print(&z, p);
		//printf(": ");
		rz = zppoly_compose(&r, &z, p);
		zppoly_print(&rz, p);
		printf("\n");
	}

	return 0;
}
