#include <stdio.h>
#include <stdlib.h>
#include "zppoly_factor.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t r;
	zppoly_factor_info_t finfo;
	int p;
	int argi;
	int i;

	if (argc < 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);
	for (argi = 2; argi < argc; argi++) {
		if (!zppoly_scan(&r, argv[argi], p))
			usage(argv[0]);
		zppoly_factor(&r, p, &finfo);

		zppoly_print(&r, p);
		printf(": ");
		for (i = 0; i < finfo.num_distinct; i++) {
			printf(" ");
			zppoly_print(&finfo.factor_counts[i].f, p);
			if (finfo.factor_counts[i].count > 1)
				printf("^%d", finfo.factor_counts[i].count);
		}
		printf("\n");
	}

	return 0;
}
