#include <stdio.h>
#include <stdlib.h>
#include "zppolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...} {p} {g} {r}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t a, g;
	zppoly_aux_t aux;
	int argi, log;

	if (argc < 5)
		usage(argv[0]);
	if (sscanf(argv[argc-3], "%d", &aux.p) != 1)
		usage(argv[0]);
	if (!zppoly_scan(&g, argv[argc-2], aux.p))
		usage(argv[0]);
	if (!zppoly_scan(&aux.r, argv[argc-1], aux.p))
		usage(argv[0]);

	for (argi = 1; argi < argc-3; argi++) {
		if (!zppoly_scan(&a, argv[argi], aux.p))
			usage(argv[0]);
		log = zppolymod_log(&a, &g, &aux);
		printf("%d\n", log);
	}

	return 0;
}
