#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "zppolymod.h"
#include "zpnpoly.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {polys ...} {r}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t m, a, r;
	zppoly_aux_t aux;
	int p;
	int argi;

	if (argc < 4)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);
	if (!zppoly_scan(&r, argv[argc-1], p))
		usage(argv[0]);
	aux.p = p;
	aux.r = r;

	for (argi = 2; argi < argc-1; argi++) {
		if (!zppoly_scan(&a, argv[argi], p))
			usage(argv[0]);
		m = zppoly_get_min_poly(&a, &aux);
		zppoly_print(&m, p);
		printf("\n");
	}

	return 0;
}
