#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "zppolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {polys ...} {r}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t r, c, a;
	int p;
	int power;
	int argi;
	char * pcaret;
	zppoly_aux_t aux;

	if (argc < 4)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);
	if (!zppoly_scan(&r, argv[argc-1], p))
		usage(argv[0]);
	aux.p = p;
	aux.r = r;

	c = zppoly_from_base_rep(p, 1);
	for (argi = 2; argi < argc-1; argi++) {
		pcaret = strchr(argv[argi], '^');
		if (pcaret) {
			*pcaret = 0;
			if (!sscanf(pcaret + 1, "%d", &power)) {
				usage(argv[0]);
			}
		}
		else {
			power = 1;
		}
		if (!zppoly_scan(&a, argv[argi], p))
			usage(argv[0]);
		if (power != 1)
			a = zppoly_power(&a, power, p);
		c = zppolymod_mul(&c, &a, &aux);
	}
	zppoly_print(&c, p);
	printf("\n");

	return 0;
}
