#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "zppolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {polys ...} {e} {r}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t c, a, r;
	zppoly_aux_t aux;
	int p;
	int power;
	int argi;

	if (argc < 5)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);
	if (sscanf(argv[argc-2], "%d", &power) != 1)
		usage(argv[0]);
	if (!zppoly_scan(&r, argv[argc-1], p))
		usage(argv[0]);
	aux.p = p;
	aux.r = r;

	for (argi = 2; argi < argc-2; argi++) {
		if (!zppoly_scan(&a, argv[argi], p))
			usage(argv[0]);
		c = zppolymod_power(&a, power, &aux);
		zppoly_print(&c, p);
		printf("\n");
	}

	return 0;
}
