#include <stdio.h>
#include <stdlib.h>
#include "zppolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {r} {a} {b} ...\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t a, b, q;
	zppoly_aux_t aux;
	int argi;

	if (argc < 5)
		usage(argv[0]);
	if (!zppolymod_auxscan(&aux, argv[1], argv[2]))
		usage(argv[0]);

	for (argi = 3; argi < argc - 1; argi++) {
		if (!zppoly_scan(&a, argv[argi], aux.p))
			usage(argv[0]);
		if (!zppoly_scan(&b, argv[argi+1], aux.p))
			usage(argv[0]);
		q = zppolymod_div(&b, &a, &aux);

		zppolymod_print(&b, &aux);
		printf(" / ");
		zppolymod_print(&a, &aux);
		printf(" = ");
		zppolymod_print(&q, &aux);
		printf("\n");
	}

	return 0;
}
