#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "power.h"
#include "zpnpoly_factor.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {m or red} {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi, i;
	zppoly_aux_t aux;
	zpnpoly_t z;
	static zpnpoly_factor_info_t finfo;

	if (argc < 4)
		usage(argv[0]);

	if (!zppolymod_auxscan(&aux, argv[1], argv[2]))
		usage(argv[0]);

	for (argi = 3; argi < argc; argi++) {
		if (!zpnpoly_vscan(&z, argv[argi], &aux, sizeof(z))) {
			fprintf(stderr, "Scan failure on \"%s\".\n",
				argv[argi]);
			continue;
		}

		if (z.degree == 0)
			z = zpnpoly_extend_zppoly(&z.coeffs[0]);

		printf("Factoring ");
		zpnpoly_vprintsmall(&z, &aux);
		printf(" over GF(%d^%d)[X]:\n", aux.p, aux.r.degree);

		zpnpoly_factor(&z, &aux, &finfo);

		//zpnpoly_print(&z, &aux);
		//printf(": ");
		for (i = 0; i < finfo.num_distinct; i++) {
			printf(" ");
			zpnpoly_print(&finfo.factor_counts[i].f, &aux);
			if (finfo.factor_counts[i].count > 1)
				printf("^%d", finfo.factor_counts[i].count);
			printf("\n");
		}
		printf("\n");

	}

	return 0;
}
