#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "zpnpolymod.h"
#include "power.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr,
		"Usage: %s {p} {int r} {ext r} {g}\n",
		argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zppoly_aux_t innaux;
	zpnpoly_t ext_r, g, gpower;
	int d, m, n, pn1, i, pd;
	int do_frobit = 0;

	if ((argc != 5) && (argc != 6))
		usage(argv[0]);
	if (!zppolymod_auxscan(&innaux, argv[1], argv[2]))
		usage(argv[0]);
	if (!zpnpoly_scan(&ext_r, argv[3], &innaux))
		usage(argv[0]);
	if (!zpnpoly_scan(&g, argv[4], &innaux))
		usage(argv[0]);
	if (argc == 6)
		do_frobit = 1;

	d = innaux.r.degree;
	m = ext_r.degree;
	n = m * d;
	pn1 = calc_power(innaux.p, n) - 1;
	pd = calc_power(innaux.p, d);

	gpower = g;
	for (i = 1; i <= pn1; i++) {
		printf("%3d: ", i);
		zpnpoly_print(&gpower, &innaux);
		printf("\n");
		if (do_frobit)
			gpower = zpnpolymod_power(&gpower, pd, &ext_r, &innaux);
		else
			gpower = zpnpolymod_mul(&gpower, &g, &ext_r, &innaux);
		if (zpnpoly_equal(&gpower, &g, &innaux))
			break;
	}

	return 0;
}
