#include <stdio.h>
#include <stdlib.h>
#include <z2ipolymod.h>
#include <z2ilinalg.h>
#include <malloc_check.h>

// ----------------------------------------------------------------
z2ipoly_t galois_lfsr(
	z2ipoly_t a, // state
	z2ipoly_t r) // poly
{
	int n = z2ipoly_get_degree(r);
	z2ipoly_t msb = 1LL << n;
	z2ipoly_t mask = r ^ msb;

	if (a & 1LL) {
		a = ((a ^ mask) >> 1) | (msb >> 1);
	}
	else {
		a >>= 1;
	}
	return a;
}

// ----------------------------------------------------------------
z2ipoly_t fibo_lfsr(
	z2ipoly_t a, // state
	z2ipoly_t r) // poly
{
	z2ipoly_t rv = 0LL;
	// xxx temp
	return rv;
}

// ----------------------------------------------------------------
int main(void)
{
	z2ipoly_t r = 0x13LL;
	z2ipoly_t u = 0x02LL;
	z2ipoly_t a, b, c, d, e;
	z2ipoly_t msb = 0x10LL;
	z2ipoly_t * M;
	//z2ipoly_t lsb = 0x01LL;
	int i, n, pn;

	M = z2ipoly_companion_matrix(r, 0);
	n = z2ipoly_get_degree(r);
	pn = 1 << n;
	a = b = c = d = e = 1;

	printf("u-RER FF* mx gal fibo\n");
	for (i = 0; i <= pn; i++) {
		printf("%02llx %02llx   %02llx %02llx %02llx\n", a, b, c, d, e);

		a <<= 1;
		if (a & msb)
			a ^= r;

		b = z2ipolymod_mul(b, u, r);

		c = z2ila_mx_times_vr(M, n, c);
		d = galois_lfsr(d, r);


	}

	free(M);
	return 0;
}
