#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t T, S1, S;
	z2ipoly_t xnk, Smk, term, fST;
	int m, n, k;

	T  = 0x13LL;
	S1 = 0x31LL;

	if (argc >= 3) {
		(void)sscanf(argv[1], "%llx", &T);
		(void)sscanf(argv[2], "%llx", &S1);
	}

	m = z2ipoly_get_degree(T);
	n = z2ipoly_get_degree(S1);
	if (m < 1) {
		fprintf(stderr, "m must be >= 1.\n");
		exit(1);
	}
	if (n < 1) {
		fprintf(stderr, "n must be >= 1.\n");
		exit(1);
	}
	if ((m * n) > 63) {
		fprintf(stderr, "mn must be <= 63.\n");
		exit(1);
	}
	S = S1 ^ (1LL << n);

	// sum k=0 to m of t^k x^nk fS(m-k)

	printf("S=%04llx T=%04llx\n", S, T);
	fST = 0;
	for (k = 0; k <= m; k++) {

		// Check t^k
		if (!(T & (1LL << k)))
			continue;

		// Compute x^nk
		xnk = 1LL << (n * k);

		// Compute fS^{m-k}
		Smk = z2ipoly_power(S, m-k);

		term = z2ipoly_mul(xnk, Smk);

		printf("-- k=%d xnk=%llx Smk=%llx\n",
			k, xnk, Smk);

		fST ^= term;
	}
	printf("%llx\n", fST);
	printf("\n");

	return 0;
}
