\\ Note this function assumes the matrix is invertible.
\\ If not, it will print the message 
mxorder(T, verbose)=
{
	local(n, id, Tk, order);
	n = length(T);
	id = matid(n);
	Tk = T;
	order = 1;

	if (matdet(T) == 0, print("Singular matrix!"); return);

	while (Tk != id,

		\\printp(order);
		\\printp("I:");
		\\printp(lift(id));
		\\printp("T:");
		\\printp(lift(T));
		\\printp("T^", order);
		\\printp(lift(Tk));
		\\printp();
		if (verbose, print(lift(Tk), " = T^", order));

		Tk = Tk * T;
		order++;
		if (order > 1000, error("panic!"));
		);
	if (verbose, print(lift(Tk), " = T^", order, " = I"));
	print("order = ", order);
}

show_info(T, verbose)=
{
	local(ch);
	ch = charpoly(lift(T));
	ch = Mod(1,2) * ch;
	print("charpoly = ", lift(ch));
	print("factors  = ", lift(factor(ch)));
	mxorder(T, verbose);
}

show_odd_24s(verbose)=
{
	local (kshift);
	forstep (k=1, 15, 2,
		T= Mod(1,2) * [\
			0,0,0,0; \
   			1,0,0,0; \
   			0,1,0,0; \
   			0,0,1,0] * Mod(1,2); \
		kshift = k;
		T[1,4] = Mod(kshift % 2, 2); kshift = kshift \ 2;
		T[1,3] = Mod(kshift % 2, 2); kshift = kshift \ 2;
		T[1,2] = Mod(kshift % 2, 2); kshift = kshift \ 2;
		T[1,1] = Mod(kshift % 2, 2); kshift = kshift \ 2;
		\\T[1,4] = Mod(1,2);
		show_info(T, verbose);
		print("");
	)
}

show_odd_24s(1);
