#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2ipolymod.h"
#include "z2ilinalg.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
void do_M(
	z2ipoly_t * M,
	int n)
{
	z2ipoly_t a, Ta, hi = 1LL << n;
	int i;

	for (i = 0; i < n; i++) {
		if (i > 0)
			printf(" ");
		z2ipolymod_print(M[i], hi);
	}
	printf(" | ");

	for (a = 0; a < hi; a++) {
		printf(" ");
		Ta = z2ila_mx_times_vr(M, n, a);
		z2ipolymod_print(Ta, hi);
	}
	printf("\n");
}

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s [-f|-g] {r}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t * M = malloc_check(4 * sizeof(z2ipoly_t));
	z2ipoly_t i, j, hi = 0x10000LL;

	if (argc == 2)
		(void)sscanf(argv[1], "%lli", &hi);

	for (i = 0; i < hi; i++) {
		j = i;
		M[0] = j & 0x0f; j >>= 4;
		M[1] = j & 0x0f; j >>= 4;
		M[2] = j & 0x0f; j >>= 4;
		M[3] = j & 0x0f; j >>= 4;
		do_M(M, 4);
	}

	free(M);
	return 0;
}
