#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2ipolymod.h"
#include "z2ilinalg.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s [-f|-g] {r}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t T, * M, a, Ta, hi;
	int do_galois_cfg = 0;
	int argi;
	int i, n;

	if (argc < 2)
		usage(argv[0]);

	for (argi = 1; argi < argc; argi++) {
		if (strcmp(argv[argi], "-f") == 0) {
			do_galois_cfg = 0;
			continue;
		}
		if (strcmp(argv[argi], "-g") == 0) {
			do_galois_cfg = 1;
			continue;
		}

		if (sscanf(argv[argi], "%llx", &T) != 1) {
			fprintf(stderr, "%s: Couldn't scan \"%s\".\n",
				argv[0], argv[argi]);
			exit(1);
		}
		M = z2ipoly_companion_matrix(T, do_galois_cfg);
		n = z2ipoly_get_degree(T);

		printf("-- %llx: [", T);
		for (i = 0; i < n; i++) {
			if (i > 0)
				printf(" ");
			z2ipolymod_print(M[i], T);
		}
		printf("]\n");

		hi = 1LL << n;

		for (a = 0; a < hi; a++) {
			Ta = a;
			for (i = 0; i < hi; i++) {
				if (i > 0)
					printf(" ");
				z2ipolymod_print(Ta, T);
				Ta = z2ila_mx_times_vr(M, n, Ta);
			}
			printf("\n");
		}
		free(M);
		if (argc > 2)
			printf("\n");
	}

	return 0;
}
