#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "gcd.h"
#include "phi.h"

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int members[990];
	int mod9s[990];
	int mod10s[990];
	int mod11s[990];
	int m = 990;
	int x;
	int r9, r10, r11;
	int rex;

	int m9;
	int m10;
	int m11;
	int a;
	int astep = 495;
	int ntotry;
	int ntried = 0;

	int ngood;
	int nbad;
	int print_status = isatty(fileno(stdin));

	if (argc == 2)
		(void)sscanf(argv[1], "%d", &astep);
	ntotry = 990 * (990/astep);

	for (x = 0; x < 990; x++) {
		members[x] = (calc_gcd(x, m) == 1) ? 1 : 0;
		if (members[x]) {
			mod9s [x] = x %  9;
			mod10s[x] = x % 10;
			mod11s[x] = x % 11;
		}
	}

	for (m9 = 110; m9 < m; m9+=110) {
		for (m10 = 99; m10 < m; m10+=99) {
			for (m11 = 90; m11 < m; m11+=90) {
				for (a = 0; a < m; a+=astep) {
					ngood = 0;
					nbad  = 0;

					for (x = 1; x < m; x++) {
						//if (calc_gcd(x, m) != 1)
						if (!members[x])
							continue;
						//r9  = x % 9;
						//r10 = x % 10;
						//r11 = x % 11;
						r9  = mod9s[x];
						r10 = mod10s[x];
						r11 = mod11s[x];
						rex = (
							//((r9 * m9 ) % m) +
							//((r10* m10) % m) +
							//((r11* m11) % m) +
							//a
							(r9 * m9)  +
							(r10* m10) +
							(r11* m11) +
							a
						) % m;
						if (x == rex)
							ngood++;
						else
							nbad++;
						//printf("%3d: (%3d, %3d, %3d) => %3d",
							//x, r9, r10, r11, rex);
						//if (x != rex)
							//printf(" diff %d", (m + x - rex) % m);
						//printf("\n");
					}
					if (nbad == 0) {
						if (print_status)
							printf("\r%3d %3d %3d %3d           \n",
								m9, m10, m11, a);

					}
					ntried++;
				}
				if (print_status) {
					printf("\r%3d %3d %3d  %6.2lf%%",
						m9, m10, m11,
						(100.0 * ntried) / ntotry);
						//(((m9 /110 * 110) +
						//(m10/ 99 * 11) +
						//(m10/ 90)) * 100) / 990);
					fflush(stdout);
				}
			}
		}
	}
	if (print_status)
		printf("\r                                     \n");

	return 0;
}
