#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

#include "int_random.h"

#define BUFSZ 10000

// ----------------------------------------------------------------
unsigned get_rand_unsigned(void)
{
	return (unsigned)get_rand_int();
}

// ----------------------------------------------------------------
unsigned long long get_rand_ull(void)
{
	unsigned lo = get_rand_unsigned();
	unsigned hi = get_rand_unsigned();
	return ((unsigned long long)hi << 32) | (unsigned long long)lo;
}

// ----------------------------------------------------------------
int get_rand_int(void)
{
	static int fd = -1;
	static int buf[BUFSZ];
	static int bufpos = 0;
	int rv;
	if (fd == -1) {
		fd = open("/dev/urandom", O_RDONLY);
		if (fd < 0) {
			fprintf(stderr, "Couldn't open /dev/urandom.\n");
			perror("Reason");
			exit(1);
		}
	}

	if (bufpos == 0) {
		if (read(fd, buf, BUFSZ * sizeof(int)) < 0) {
			fprintf(stderr, "Couldn't read /dev/urandom.\n");
			perror("Reason");
			exit(1);
		}
	}
	rv = buf[bufpos];
	bufpos++;
	if (bufpos >= BUFSZ)
		bufpos = 0;
	return rv;
}
