#include <stdio.h>
#include <stdlib.h>
#include "inv.h"
#include "gcd.h"
#include "phi.h"

// ----------------------------------------------------------------
int calc_inv(int x, int m)
{
	int phi;
	int phi2;
	int i;
	int xi;

	if (calc_gcd_signed(x, m) != 1) {
		fprintf(stderr,
			"calc_inv():  %d is not relatively prime to %d.\n",
			x,m);
		exit(1);
	}

	phi = calc_phi_signed(m);
	phi2 = phi - 2;

	// Fermat's little theorem (generalized to composites)
	// x ^ (phi(m))   = x   mod m
	// x ^ (phi(m)-1) = 1   mod m
	// x ^ (phi(m)-2) = 1/x mod m
	xi = x;
	for (i = 0; i < phi2; i++) {
		xi *= x;
		xi %= m;
	}
	return xi;
}
