//24 = 4 * 3 * 2 * 1
//
//Split 24 into 4 * 6
//first 6 start with a
//next  6 start with b
//next  6 start with c
//last  6 start with d
//
//Split 6 into 3 * 2
//first 2 start with b
//next  2 start with c
//last  2 start with d
//
//Split 2 into 2 * 1
//first 1 starts with c
//next  1 starts with d
//
//pos0: 24/6=4;  0..23 / 6 = 0..3;  strip that from temp
//pos1:  6/2=3;  0.. 5 / 2 = 0..2;  strip that from temp
//pos2:  2/1=2;  0.. 1 / 1 = 0..1;  strip that from temp
//pos3:  1/1=1;  0.. 0 / 1 = 0..0;  strip that from temp

//pos0: k % (n-1)!
//k / (n-1)!
//pos1: k % (n-2)!
//k / (n-2)!

// ----------------------------------------------------------------
void kth_pmt(
	char       in[],
	char       temp[],
	char       out[],
	unsigned   n,
	unsigned   k)
{
	unsigned pos, q, r, i;
	unsigned nfact, ni, nifact;

	nfact = 1;
	for (i = 1; i <= n; i++)
		nfact *= i;
	nifact = nfact;

	for (i = 0; i < n; i++)
		temp[i] = in[i];

	ni = n;
	for (pos = 0; pos < n; pos++) {
		nifact /= ni;
		r = k % nifact;
		q = k / nifact;
		k = r;

		out[pos] = temp[q];
		for (i = q; i < ni; i++)
			temp[i] = temp[i+1];

		ni--;
	}
}

// ----------------------------------------------------------------
int main(void)
{
	char in  [] = "abcd";
	char temp[] = "abcd";
	char out [] = "abcd";
	unsigned n = 4;
	unsigned k;

	for (k = 0; k < 24; k++) {
		kth_pmt(in, temp, out, n, k);
		//printf("[%2u] %s => %s\n", k, in, out);
		printf("%2u %s %s\n", k, in, out);
	}
	return 0;
}
