#include "lcm.h"
#include "gcd.h"

// ----------------------------------------------------------------
int calc_lcm_signed(int a, int b)
{
	return (a * b) / calc_gcd_signed(a, b);
}

// ----------------------------------------------------------------
unsigned calc_lcm_unsigned(unsigned a, unsigned b)
{
	return (a * b) / calc_gcd_unsigned(a, b);
}

// ----------------------------------------------------------------
unsigned calc_lcm_unsigned_multi(
	unsigned * pm,
	int count)
{
	unsigned product, gcd, lcm, j;

	if (count == 0)
		return 1;
	if (count == 1)
		return pm[0];

	gcd = pm[0];
	for (j = 1; j < count; j++)
		gcd = calc_gcd_unsigned(gcd, pm[j]);
	product = 1;
	for (j = 0; j < count; j++)
		product *= pm[j];
	lcm = product / gcd;
	return lcm;
}

// ----------------------------------------------------------------
long long calc_lcm_signed_ll(long long a, long long b)
{
	return (a * b) / calc_gcd_signed_ll(a, b);
}

// ----------------------------------------------------------------
unsigned long long calc_lcm_unsigned_ll(
	unsigned long long a,
	unsigned long long b)
{
	return (a * b) / calc_gcd_unsigned_ll(a, b);
}

// ----------------------------------------------------------------
unsigned long long calc_lcm_unsigned_ll_multi(
	unsigned long long * pm,
	int count)
{
	unsigned long long product, gcd, lcm;
	unsigned j;

	if (count == 0LL)
		return 1LL;
	if (count == 1LL)
		return pm[0];

	gcd = pm[0];
	for (j = 1; j < count; j++)
		gcd = calc_gcd_unsigned(gcd, pm[j]);
	product = 1LL;
	for (j = 0; j < count; j++)
		product *= pm[j];
	lcm = product / gcd;
	return lcm;
}
