#include <stdio.h>
#include <stdlib.h>
#include "legsym.h"
#include "mod.h"

// ----------------------------------------------------------------
// Euler's criterion: (n|p) = n^((p-1)/2) mod p

int calc_legsym_32(
	unsigned x,
	unsigned p)
{
	int rv;

	x %= p;
	if (x == 0)
		return 0;
	rv = mod_power(x, (p - 1) / 2, p);

	if (rv == 1) {
	}
	else if (rv == (p - 1)) {
		rv = -1;
	}
	else {
		fprintf(stderr, "calc_legsym_32:  coding error.\n");
		exit(1);
	}

	return rv;
}

// ----------------------------------------------------------------
int calc_legsym_64(
	unsigned long long x,
	unsigned long long p)
{
	unsigned long long y, y2;

	x %= p;
	if (x == 0LL)
		return 0;

	// xxx implement a 64-bit mod power!

	// Brute-force search y=1..p-1, checking for x==y**2
	for (y = 1; y < p; y++) {
		y2 = (y*y) % p;
		if (x == y2)
			return 1;
	}

	return -1;
}
