#include <stdio.h>
#include "malloc_check.h"

// ----------------------------------------------------------------
void * malloc_check(size_t size)
{
	void * ptr = malloc(size);
	if (ptr == 0) {
		fprintf(stderr, "malloc(%u) failed.\n", (unsigned) size);
		exit(1);
	}
	return ptr;
}

// ----------------------------------------------------------------
void * realloc_check(void * optr, size_t size)
{
	void * nptr = realloc(optr, size);
	if (nptr == 0) {
		fprintf(stderr, "realloc(%u) failed.\n", (unsigned) size);
		exit(1);
	}
	return nptr;
}
