#include <stdio.h>
#include "ubig.h"
#include "isqrt_ubig.h"

//int main(void)
//{
//	double N = 1000;
//	double p = 4.0;
//	int i;
//
//	for (i = 0; i < 20; i++) {
//		printf("[%3d] %18.11lf\n", i, p);
//		p = 0.5 * (p + N/p);
//	}
//	return 0;
//}

//int main(int argc, char ** argv)
//{
//	unsigned N = 1000;
//	unsigned p = 20;
//	int i;
//
//	if (argc >= 2)
//		(void)sscanf(argv[1], "%u", &N);
//	if (argc >= 3)
//		(void)sscanf(argv[2], "%u", &p);
//
//	for (i = 0; i < 20; i++) {
//		printf("[%3d] %6u\n", i, p);
//		p = (p + N/p) >> 1;
//	}
//	return 0;
//}

//int main(int argc, char ** argv)
//{
//	ubig N, p, q;
//	ubig prev, diff;
//	ubig zero, sv;
//	unsigned half_log;
//	int i;
//	ubig_opts_t uo;
//
//	uo.hex_in = 0;
//	uo.hex_out = 0;
//	uo.zero_fill = 0;
//	uo.underscore_out = 0;
//
//	ubig_from_unsigned(&N, 1000);
//
//	if (argc >= 2)
//		(void)ubig_sscan(argv[1], &N, &uo);
//
//	ubig_from_unsigned(&zero, 0);
//	if (ubig_equals_unsigned(&N, 0)) {
//		printf("zero in, zero out.\n");
//		return 0;
//	}
//
//	half_log = 0;
//	for (sv = N; !ubig_equals_unsigned(&sv, 0); ubig_irsh(&sv, &sv, 2))
//		half_log++;
//	half_log--;
//
//	p = zero;
//	ubig_set_bit(&p, half_log);
//
//	for (i = 0; ; i++) {
//
//		prev = p;
//
//		//p = (p + N/p) >> 1;
//		ubig_div(&q, &N, &p);
//		ubig_add(&p, &p, &q);
//		ubig_irsh(&p, &p, 1);
//
//		printf("[%3d] ", i);
//		ubig_print(stdout, &p, &uo);
//		printf("\n");
//
//		if (ubig_ge(&prev, &p))
//			ubig_sub(&diff, &prev, &p);
//		else
//			ubig_sub(&diff, &p, &prev);
//		if (ubig_equals_unsigned(&diff, 0))
//			break;
//		if (ubig_equals_unsigned(&diff, 1))
//			// Oscillation when N is m^2 - 1 for some m.
//			break;
//	}
//	return 0;
//}

int main(int argc, char ** argv)
{
	ubig N, snf, snc, snf_sq;
	ubig_opts_t uo;

	uo.hex_in = 0;
	uo.hex_out = 0;
	uo.zero_fill = 0;
	uo.underscore_out = 0;

	N = ubig_from_unsigned(1000);

	if (argc >= 2)
		(void)ubig_sscan(argv[1], &N, &uo);

	snf = calc_isqrt_newton_ubig(&N, IFLOOR);
	snc = calc_isqrt_newton_ubig(&N, ICEIL);
	snf_sq = ubig_mul(&snf, &snf);

	printf("isqrt(");
	ubig_print(stdout, &N, &uo);
	printf(") = ");
	ubig_print(stdout, &snf, &uo);
	printf(" ");
	ubig_print(stdout, &snc, &uo);
	printf("%s\n",
		ubig_eq(&snf_sq, &N) ? " *" : "");

	return 0;
}
