#include "power.h"

// ----------------------------------------------------------------
int calc_power_signed(int b, int e)
{
	int b2 = b;
	int rv = 1;

	while (e != 0) {
		if (e & 1)
			rv = rv * b2;
		e = (unsigned)e >> 1;
		b2 = b2 * b2;
	}
	return rv;
}

// ----------------------------------------------------------------
unsigned calc_power(unsigned b, unsigned e)
{
	unsigned b2 = b;
	unsigned rv = 1;

	while (e != 0) {
		if (e & 1)
			rv = rv * b2;
		e >>= 1;
		b2 = b2 * b2;
	}
	return rv;
}

// ----------------------------------------------------------------
unsigned long long calc_power_ull(unsigned long long b, unsigned e)
{
	unsigned long long b2 = b;
	unsigned long long rv = 1;

	while (e != 0) {
		if (e & 1)
			rv = rv * b2;
		e >>= 1;
		b2 = b2 * b2;
	}
	return rv;
}
