#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "linescan.h"
#include "readlines.h"
#include "malloc_check.h"

#define TEMP_LINE_SIZE 4096
#define INIT_ALLOC_LINES 100

// ----------------------------------------------------------------
int read_lines(
	FILE   * fp,
	char *** pline_ptrs,
	int    * pnlines)
{
	int      nlines = 0;
	int      num_alloc_lines = INIT_ALLOC_LINES;
	char  ** line_ptrs = malloc_check(sizeof(char *) * num_alloc_lines);
	char   * temp = malloc_check(TEMP_LINE_SIZE);

	while (fgets(temp, TEMP_LINE_SIZE, fp)) {
		if (nlines >= num_alloc_lines) {
			num_alloc_lines += INIT_ALLOC_LINES;
			line_ptrs = realloc_check(line_ptrs,
				sizeof(char *) * num_alloc_lines);
		}

		chomp(temp);
		line_ptrs[nlines] = malloc_check(strlen(temp) + 1);
		strcpy(line_ptrs[nlines], temp);
		nlines++;
	}

	*pnlines = nlines;
	*pline_ptrs = line_ptrs;
	free(temp);
	return 1;
}

// ----------------------------------------------------------------
void free_lines(
	char ** line_ptrs,
	int     nlines)
{
	int i;
	for (i = 0; i < nlines; i++)
		free(line_ptrs[i]);
	free(line_ptrs);
}
