#include <stdio.h>
#include <stdlib.h>

typedef long long int64s;

// ----------------------------------------------------------------
int64s centermod(int64s a, int64s m)
{
	if (a < m/2)
		return a;
	else
		return a - m;
}

// ----------------------------------------------------------------
int64s calc_factorial_mod(int64s a, int64s m)
{
	int64s rv = 1;

	for ( ; a > 1; a--) {
		rv *= a;
		if (rv > m) {
			rv %= m;
		}
	}
	return rv;
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int64s lo = 3;
	int64s hi = 20;
	int64s n;

	if (argc == 2) {
		(void)sscanf(argv[1], "%lld", &hi);
	}
	if (argc == 3) {
		(void)sscanf(argv[1], "%lld", &lo);
		(void)sscanf(argv[2], "%lld", &hi);
	}

	for (n = lo; n < hi; n++) {
		printf("%8lld %8lld\n",
			n, centermod(calc_factorial_mod(n-1, n), n));

	}

	return 0;
}
