// ((n-1)! + 1) / n) mod n

#include <stdio.h>
#include <stdlib.h>
#include "factorize.h"
#include "gcd.h"

typedef long long i64;

// ----------------------------------------------------------------
i64 centermod(i64 a, i64 m)
{
	if (a < m/2)
		return a;
	else
		return a - m;
}

// ----------------------------------------------------------------
i64 calc_factorial_mod(i64 a, i64 m)
{
	i64 rv = 1;

	for ( ; a > 1; a--) {
		rv *= a;
		rv %= m;
	}
	return rv;
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	i64 lo = 2;
	i64 hi = 20;
	i64 n, k, up;

	if (argc == 2) {
		(void)sscanf(argv[1], "%lld", &hi);
	}
	if (argc == 3) {
		(void)sscanf(argv[1], "%lld", &lo);
		(void)sscanf(argv[2], "%lld", &hi);
	}

	for (n = lo; n < hi; n++) {
		up = 1;
		for (k = 1; k < n; k++) {
			if (calc_gcd_signed(k, n) != 1)
				continue;
			up *= k;
			up %= n;
		}
		printf("%8lld %8lld %8lld {", n, up, centermod(up, n));
		print_factors(n);
		printf("}\n");
	}

	return 0;
}
