// ((n-1)! + 1) / n) mod n

#include <stdio.h>
#include <stdlib.h>
#include "factorize.h"
#include "isprime.h"
#include "mod.h"

typedef long long i64;

// ----------------------------------------------------------------
i64 centermod(i64 a, i64 m)
{
	if (a < m/2)
		return a;
	else
		return a - m;
}

// ----------------------------------------------------------------
i64 calc_factorial_mod(i64 a, i64 m)
{
	i64 rv = 1;

	for ( ; a > 1; a--) {
		rv *= a;
		rv %= m;
	}
	return rv;
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	i64 lo = 2;
	i64 hi = 20;
	i64 p, p2, j, k, a, ai, up, pup;
	int all = 0;
	int shuffle = 0;

	if (argc == 2) {
		(void)sscanf(argv[1], "%lld", &hi);
	}
	if (argc == 3) {
		(void)sscanf(argv[1], "%lld", &lo);
		(void)sscanf(argv[2], "%lld", &hi);
	}
	if (argc == 4) {
		(void)sscanf(argv[1], "%lld", &lo);
		(void)sscanf(argv[2], "%lld", &hi);
		all = 1;
	}
	if (argc == 5) {
		(void)sscanf(argv[1], "%lld", &lo);
		(void)sscanf(argv[2], "%lld", &hi);
		all = 1;
		shuffle = 1;
	}

	for (p = lo; p <= hi; p++) {
		if (!isprime(p))
			continue;
		p2 = p * p;

		printf("%lld:\n", p);
		up = 1;

		if (shuffle) {
		for (j = 1; j < p; j++) {
			pup = 1;
			for (k = 0; k < p; k++) {
				a = k * p + j;
				ai = mod64_recip(a, p2);
				pup *= a;
				pup %= p2;
				printf("  %3lld: %3lld (%3lld)\n",
					a, ai, ai / p);
			}
			up *= pup;
			up %= p2;
				printf("    -- pup = %lld\n", pup);
			if (!all)
				break;
		}
		}
		else {

		for (k = 0; k < p; k++) {
			pup = 1;
			for (j = 1; j < p; j++) {
				a = k * p + j;
				ai = mod64_recip(a, p2);
				pup *= a;
				pup %= p2;
				printf("  %3lld: %3lld (%3lld)\n",
					a, ai, ai / p);
			}
			up *= pup;
			up %= p2;
			printf("    -- pup = %lld\n", pup);
			if (!all)
				break;
		}
		}

		printf("  -- up = %lld\n", p2-1);
		printf("\n");
	}

	return 0;
}
