// ((n-1)! + 1) / n) mod n

#include <stdio.h>
#include <stdlib.h>
#include "factorize.h"
#include "isprime.h"

typedef long long i64;

//#define VERBOSE

// ----------------------------------------------------------------
i64 centermod(i64 a, i64 m)
{
	if (a < m/2)
		return a;
	else
		return a - m;
}

// ----------------------------------------------------------------
i64 calc_factorial_mod(i64 a, i64 m)
{
	i64 rv = 1;

	for ( ; a > 1; a--) {
		rv *= a;
		rv %= m;
	}
	return rv;
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	i64 lo = 2;
	i64 hi = 20;
	i64 p, p2, j, k, up;

	if (argc == 2) {
		(void)sscanf(argv[1], "%lld", &hi);
	}
	if (argc == 3) {
		(void)sscanf(argv[1], "%lld", &lo);
		(void)sscanf(argv[2], "%lld", &hi);
	}

	for (p = lo; p <= hi; p++) {
		if (!isprime(p))
			continue;
		p2 = p * p;
#ifdef VERBOSE
		printf("%8lld:\n", p);
#endif
		for (k = 0; k < p; k++) {
			up = 1;
			for (j = 1; j < p; j++) {
				up *= k * p + j;
				up %= p2;
			}
#ifdef VERBOSE
			printf("  %8lld: %8lld %8lld %8lld\n",
				k, up, centermod(up, p2),
				((up + 1) / p) % p);
#else
			if (k == 0) {
				printf("%8lld: pup=%8lld ctr=%8lld wp=%8lld\n",
					p, up, centermod(up, p2),
					((up + 1) / p) % p);
				break;
			}
#endif
		}
	}

	return 0;
}
