// ((n-1)! + 1) / n) mod n

#include <stdio.h>
#include <stdlib.h>
#include "factorize.h"
#include "isprime.h"
#include "mod.h"

typedef long long i64;

// ----------------------------------------------------------------
i64 centermod(i64 a, i64 m)
{
	if (a < m/2)
		return a;
	else
		return a - m;
}

// ----------------------------------------------------------------
i64 calc_factorial_mod(i64 a, i64 m)
{
	i64 rv = 1;

	for ( ; a > 1; a--) {
		rv *= a;
		rv %= m;
	}
	return rv;
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	i64 lo = 2;
	i64 hi = 20;
	i64 p, p2, k, i, a, pup;

	if (argc == 2) {
		(void)sscanf(argv[1], "%lld", &hi);
		lo = hi;
	}
	if (argc == 3) {
		(void)sscanf(argv[1], "%lld", &lo);
		(void)sscanf(argv[2], "%lld", &hi);
	}

	for (p = lo; p <= hi; p++) {
		if (!isprime(p))
			continue;
		p2 = p * p;

		printf("%lld: ", p);
		for (i = 1; i < p2; i += p) {
			pup = 1;
			a = 1;
			for (k = 1; k < p; k++) {
				pup *= a;
				pup %= p2;

				a += i;
				a %= p2;
			}
			printf(" %lld", ((pup + 1) / p) % p);
		}
		printf("\n");
	}

	return 0;
}
