#include <stdio.h>
#include <stdlib.h>

typedef unsigned long long int64u;
unsigned navoid = 0;
unsigned ncompute = 0;

// ----------------------------------------------------------------
int64u calc_factorial_mod(int64u a, int64u m)
{
	int64u rv = 1;

	for ( ; a > 1; a--) {
		rv *= a;
		if (rv > m) {
			rv %= m;
			ncompute++;
		}
		else {
			navoid++;
		}
	}
	return rv;
}

// ----------------------------------------------------------------
static int check1(int64u p)
{
	int64u p2 = p * p;
	int64u f = calc_factorial_mod(p-1, p2);
	if (f == p2-1)
		return 1;
	else
		return 0;
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int64u lo = 3;
	int64u hi = 20;
	int64u p;

	if (argc == 2) {
		(void)sscanf(argv[1], "%llu", &hi);
	}
	if (argc == 3) {
		(void)sscanf(argv[1], "%llu", &lo);
		(void)sscanf(argv[2], "%llu", &hi);
	}

	lo |= 1; // make odd
	for (p = lo; p < hi; p += 2) {
		if ((p & 0xfffLL) == 1)
			printf("  (%llu)\n", p);
		if (check1(p))
			printf("%llu\n", p);
	}

	printf("avoid   %u\n", navoid);
	printf("compute %u\n", ncompute);
	return 0;
}
