#include <stdio.h>
#include <stdlib.h>
#include "isprime.h"
#include "mod.h"
#include "factorial.h"

typedef long long i64;
#define MAX 5

// ----------------------------------------------------------------
static void banner(void)
{
	i64 m;

	printf("p");
	for (m = -MAX; m < 0; m++)
		printf(" %%(p-%lld)", -m);
	printf(" %%p");
	for (m = 1; m <= MAX; m++)
		printf(" %%(p+%lld)", m);
	printf("\n");

	printf("-----");
	for (m = -MAX; m <= MAX; m++)
		printf(" -----");
	printf("\n");
}

// ----------------------------------------------------------------
i64 calc_factorial_mod(i64 a, i64 m)
{
	i64 rv = 1;

	for ( ; a > 1; a--) {
		rv *= a;
		rv %= m;
	}
	return rv;
}

// ----------------------------------------------------------------
static void check1(i64 p)
{
	i64 m, pm, r;

	// ((p-1)! + 1) / p;
	printf("%lld", p);
	for (m = -MAX; m <= MAX; m++) {
		pm = p * (p + m);
		r = calc_factorial_mod(p-1, pm);
		r = (r + 1) % pm;
		if ((r % p) != 0) {
			fprintf(stderr, "ABEND!\n");
			exit(1);
		}
		r /= p;
		printf(" %lld", r);
	}
	printf("\n");
}

// ----------------------------------------------------------------
int main(void)
{
	i64 lo = 7;
	i64 hi = 40000;
	i64 p;

	banner();

	for (p = lo; p <= hi; p++) {
		if (!isprime((int)p))
			continue;
		check1(p);
	}
	return 0;
}
