// ((p-1)! + 1) / p) mod p

#include <stdio.h>
#include <stdlib.h>
#include "isprime.h"
#include "factorize.h"

typedef long long i64;

// ----------------------------------------------------------------
i64 centermod(i64 a, i64 m)
{
	if (a < m/2)
		return a;
	else
		return a - m;
}

// ----------------------------------------------------------------
i64 calc_factorial_mod(i64 a, i64 m)
{
	i64 rv = 1;

	for ( ; a > 1; a--) {
		rv *= a;
		rv %= m;
	}
	return rv;
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	i64 lo = 3;
	i64 hi = 20;
	i64 p, pm1fact, wp;

	if (argc == 2) {
		(void)sscanf(argv[1], "%lld", &hi);
	}
	if (argc == 3) {
		(void)sscanf(argv[1], "%lld", &lo);
		(void)sscanf(argv[2], "%lld", &hi);
	}

	lo |= 1; // make odd
	for (p = lo; p < hi; p+=2) {
		if (!isprime((int)p))
			continue;
		pm1fact = calc_factorial_mod(p-1, p*p);
		wp = ((pm1fact + 1) / p) % p;
		if (((pm1fact + 1) % p) != 0) {
			printf("ABEND at %lld!\n", p);
			exit(1);
		}

		//printf("%8lld %8lld (%8lld) {", p, centermod(wp, p), wp);
		printf("%8lld %8lld  {", p, wp);
		print_factors(wp);
		printf("}\n");
	}

	return 0;
}
